unit fMHA_ASI_Sign;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  fIA_Dialogs,
  StdCtrls,
  ORFn,
  Hash,
  JvExControls,
  JvComponent,
  JvXPCore,
  JvXPButtons;

type
  TfrmASISign = class(TForm)
    txtESCode: TEdit;
    lblESCode: TLabel;
    lblText: TLabel;
    cmdOK: TJvXPButton;
    cmdCancel: TJvXPButton;
    procedure cmdOKClick(Sender: TObject);
    procedure cmdCancelClick(Sender: TObject);
    procedure ConfigureForm;
    procedure FormCreate(Sender: TObject);
    procedure txtESCodeKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    FESCode: string;
  public
    { Public declarations }
  end;

procedure SignatureForASI(FontSize: Integer;
  const AText, ACaption: string; var ESCode: string);

implementation

{$R *.DFM}

uses
  uIA_Const,
  uIA_GUIControl;

const
  TX_INVAL_MSG                = 'Not a valid electronic signature code.  Enter a valid code or press Cancel.';
  TX_INVAL_CAP                = 'Unrecognized Signature Code';

procedure TfrmASISign.FormCreate(Sender: TObject);
begin
  Position := poDesigned;
  ConfigureForm;
  ActiveControl := txtESCode;
end;

procedure SignatureForASI(FontSize: Integer; const AText, ACaption: string; var ESCode: string);
var
  frmASISign                  : TfrmASISign;
begin
  frmASISign := TfrmASISign.Create(Application);
  try
    with frmASISign do
      begin
        FESCode := '';
        Caption := ACaption;
        lblText.Caption := AText;
        ShowModal;
        ESCode := FESCode;
      end;
  finally
    frmASISign.Release;
  end;
end;

procedure TfrmASISign.ConfigureForm;
begin
  with GUI_Control do
    begin
      Scaled := True;
      AutoScroll := False;
      AutoSize := False;
      PixelsPerInch := 120;

      KeyPreview := True;
      HorzScrollBar.Range := 0; // Ensures that buttons will move when re-sized
      VertScrollBar.Range := 0;
      Font.Assign(gvFont);

      Height := 8 * ButtonHeight; //CheckHeight(200, Height);
      Width := 6 * ButtonWidthNormal; //CheckWidth(200, Width);
      Left := GetLeft(Width);
      Top := GetTop(Height);
      if CheckWidth(Width) or CheckHeight(Height) then
        WindowState := wsMaximized;
      Refresh; // resets alClient dimensions

      cmdOk.Height := ButtonHeight;
      cmdCancel.Height := ButtonHeight;
      txtESCode.Height := 3 * TextHeight('Yy', gvFont);

      cmdOk.Width := ButtonWidthNormal;
      cmdCancel.Width := ButtonWidthNormal;

      lblESCode.Top := Height - txtESCode.Top - lblESCode.Height - 5;

      if gvUseScreenReader then
        begin
          Left := 0;
          Width := Screen.Width;
          cmdOK.caption := cmdOK.Caption + ' button';
          cmdCancel.caption := cmdCancel.Caption + ' button';
        end;
    end;
end;

procedure TfrmASISign.cmdOKClick(Sender: TObject);
begin
  FESCode := Encrypt(txtESCode.Text);
  Close;
end;

procedure TfrmASISign.cmdCancelClick(Sender: TObject);
begin
  FESCode := '';
  Close;
end;

procedure TfrmASISign.txtESCodeKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (key = vk_return) then
    cmdOKClick(Sender);
end;

end.

