unit fMHA_GAF;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  BaseGrid,
  AdvGrid,
  TeEngine,
  Series,
  TeeProcs,
  Chart,
  ExtCtrls,
  StdCtrls,
  ComCtrls,
  Contnrs,
  Grids,
  Vawrgrid,
  Menus,
  Fmcntrls,
  RzLabel,
  RzPanel,
  ORCtrls,
  Spin,
  uMHA_GAF,
  JvExControls,
  JvComponent,
  JvXPCore,
  JvXPButtons,
  Dialogs;

type

  TfrmMHA_GAF = class(TForm)
    pnlAllGAFCriteria: TPanel;
    pnlNewGAF: TPanel;
    lblEnterGAF: TLabel;
    lblDate: TLabel;
    dtpkrEval: TDateTimePicker;
    spnedtGAF: TSpinEdit;
    pnlOldGAF: TPanel;
    spltGAF: TSplitter;
    chrtGAF: TChart;
    Series2: TLineSeries;
    Splitter1: TSplitter;
    MainMenu1: TMainMenu;
    mnuFile: TMenuItem;
    mnuExit: TMenuItem;
    N1: TMenuItem;
    mnuSave: TMenuItem;
    mnuRevise: TMenuItem;
    mnuSelectPatient: TMenuItem;
    N3: TMenuItem;
    mnuAction: TMenuItem;
    dlgSave: TSaveDialog;
    mnuTool: TMenuItem;
    mnuOptions: TMenuItem;
    pnlHeader: TRzPanel;
    lblHeader: TRzLabel;
    lblPatient: TRzLabel;
    mnuHelp: TMenuItem;
    mnuOnlineSupport: TMenuItem;
    N2: TMenuItem;
    mnuAbout: TMenuItem;
    mnuEdit: TMenuItem;
    mnuCopy: TMenuItem;
    mnuCopyGraph: TMenuItem;
    mnuCopyTable: TMenuItem;
    mnuSaveAs: TMenuItem;
    mnuSaveGraph: TMenuItem;
    mnuSaveTable: TMenuItem;
    mnuPrint: TMenuItem;
    mnuPrintGraph: TMenuItem;
    mnuPrintTable: TMenuItem;
    mnuSaveNewRating: TMenuItem;
    N4: TMenuItem;
    mnuCopyrightInfo: TMenuItem;
    grpGAFCriteria: TRzGroupBox;
    grdGAFCriteria: TAdvStringGrid;
    grpOldGAFs: TRzGroupBox;
    grdGAFResults: TAdvStringGrid;
    pnlOldGAFs: TPanel;
    mnuView: TMenuItem;
    mnuShowGraphLabels: TMenuItem;
    btnSave: TJvXPButton;
    imgBackup: TImage;
    btnEditGAF: TJvXPButton;

    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure mnuSelectPatientClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure spnedtGAFChange(Sender: TObject);
    procedure grdGAFCriteriaClick(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
    procedure dtpkrEvalChange(Sender: TObject);
    procedure grdGAFResultsClick(Sender: TObject);
    procedure grdGAFResultsGetCellColor(Sender: TObject; ARow,
      ACol: Integer; AState: TGridDrawState; ABrush: TBrush; AFont: TFont);
    //procedure btnPanelEditButtons0Click(Sender: TObject; index: Integer);
    procedure FormDestroy(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure mnuExitClick(Sender: TObject);
    procedure mnuCopyTblClick(Sender: TObject);
    procedure mnuSaveAsTblClick(Sender: TObject);
    procedure mnuPrintTblClick(Sender: TObject);
    procedure mnuCopyGphClick(Sender: TObject);
    procedure mnuSaveAsGphClick(Sender: TObject);
    procedure mnuPrintGphClick(Sender: TObject);
    procedure mnuOptionsClick(Sender: TObject);
    procedure FormCanResize(Sender: TObject; var NewWidth,
      NewHeight: Integer; var Resize: Boolean);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure mnuOnlineSupportClick(Sender: TObject);
    procedure mnuAboutClick(Sender: TObject);
    procedure grdGAFCriteriaGridHint(Sender: TObject; ARow, ACol: Integer;
      var hintstr: string);
    procedure mnuCopyrightInfoClick(Sender: TObject);
    procedure btnEditGAFClick(Sender: TObject);
    procedure mnuReviseClick(Sender: TObject);
    procedure mnuShowGraphLabelsClick(Sender: TObject);
    procedure spnedtGAFKeyPress(Sender: TObject; var Key: Char);
    procedure spnedtGAFClick(Sender: TObject);
    procedure dtpkrEvalEnter(Sender: TObject);
    procedure imgBackupClick(Sender: TObject);

    procedure UpdateAllDisplays;
    procedure FormResize(Sender: TObject);
    procedure grdGAFCriteriaKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    FspnGAFChange: BOOLEAN; //local variable used in spnGAF and grdGAFResults
    //FActiveGAF: TGAF;
    procedure ClearTempGAF;
    procedure InitGAFCriteria;
    procedure InitGrdResults;
    procedure ConfigureForm;
    procedure SetSaveButton;
    procedure DisplayPreviousRatings;
    procedure GraphRatings;
    procedure SetEditButton;
    function RowTag(ARow: integer): string;
    procedure SetGAFDate;
    function EnterDataForDeadPatient(aCaption: string): BOOLEAN;
    function GetGAFScores(aDFN: string): string;
    procedure ConvertGridToStringList(var List: TStringList);
    { Private declarations }
  public
    { Public declarations }
    //property ActiveGAF: TGAF read FActiveGAF write FActiveGAF;
  end;

var
  frmMHA_GAF                  : TfrmMHA_GAF;

implementation

uses
  uIA_Const,
  uMHA_Const,
  uIA_Utils,
  uIA_GUIControl,
  uMHA_GAF_OPS,
  uIA_ThisUser,
  uIA_Patient,
  uIA_Patient_OPS,
  fIA_Dialogs,
  fMHA_EditGAF,
  uMHA_Registry,
  fMHA_Options,
  fMHA_Options_508,
  fMHA_About,
  fMHA_Print,
  fMHA_Main,
  Clipbrd;

{$R *.DFM}

const
  lcGAF_Copyright             : string = 'Reprinted with permission from the ' +
    'Diagnostic and Statistical Manual of Mental Disorders, Fourth Edition. ' +
    'Copyright 1994 American Psychiatric Association.';

var
  lvInitialize                : Boolean;


procedure TfrmMHA_GAF.FormCreate(Sender: TObject);
begin
  lvInitialize := True;
  Position := poDesigned;
  ActiveGAF := TGAF.Create;

  ConfigureForm;
  UpdateAllDisplays;
end;

procedure TfrmMHA_GAF.FormShow(Sender: TObject);
begin
  frmMHA_Main.Hide;
  lvInitialize := False;
  Screen.Cursor := crDefault;

  if gvUseScreenReader then
    ActiveControl := grpOldGAFs
  else
    ActiveControl := grdGAFResults;
end;


procedure TfrmMHA_GAF.FormDestroy(Sender: TObject);
begin

  if ActiveGAF <> nil then
    ActiveGAF.Free;
end;


procedure TfrmMHA_GAF.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  gvGAFWidth := Width;
  gvGAFHeight := Height;
  MHA_Registry.SaveRegistry;

  frmMHA_Main.Visible := True;
end;

procedure TfrmMHA_GAF.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  CanClose := True;

  if not ActiveGAF.IsSaved then
    if (MsgDlgFrm('You have changed the rating or the evaluation date ' +
      'but have not yet saved the rating.' + CRLF + CRLF +
      'Do you want to save the new rating now?', MHA_Caption, mtConfirmation,
      [mbYes, mbNo], 0) = mrYes) then
      begin
        CanClose := False;
        btnSaveClick(Sender);
      end;

  if gvCPRSShutDown then
    Application.Terminate;
end;

procedure TfrmMHA_GAF.ConfigureForm;
begin
  MHA_Registry.ReadRegistry;
  Caption := MHA_Caption + ' in use by ' + ThisUser.Name;

  with GUI_Control do
    begin
      Scaled := True;
      AutoScroll := False;
      AutoSize := False;
      PixelsPerInch := 120;
      KeyPreview := True;
      HorzScrollBar.Range := 0; // Ensures that buttons will move when re-sized
      VertScrollBar.Range := 0;
      Font.Assign(gvFont);

      Height := gvGAFHeight;
      Width := gvGAFWidth;
      Left := GetLeft(Width);
      Top := GetTop(Height);
      if CheckWidth(Width) or CheckHeight(Height) then
        WindowState := wsMaximized;
      Refresh; // resets alClient dimensions

      // Make sure the control buttons are visible
      if (Top + Height) > Screen.WorkAreaHeight then
        Top := Screen.WorkAreaHeight - Height;

      pnlOldGAF.Height := (ButtonHeight * 6);
      pnlNewGAF.Height := 2 * ButtonHeight;

      btnSave.height := ButtonHeight;
      pnlOldGAFs.Height := ButtonHeight;
      //btnEditGAF.Height := ButtonHeight;
      //btnEditGAF.Left := 3;
      //btnEditGAF.Top := 0;

      lblEnterGAF.height := 3 * TextHeight('Yy', gvFont) div 2;
      spnedtGAF.height := 3 * TextHeight('Yy', gvFont) div 2;
      lblDate.height := 3 * TextHeight('Yy', gvFont) div 2;
      dtpkrEval.height := 3 * TextHeight('Yy', gvFont) div 2;

      btnSave.top := ButtonHeight div 2;
      lblEnterGAF.top := (pnlNewGAF.Height div 2) - (lblEnterGAF.height div 2);
      spnedtGAF.top := (pnlNewGAF.Height div 2) - (spnedtGAF.height div 2);
      lblDate.top := (pnlNewGAF.Height div 2) - (lblDate.height div 2);
      dtpkrEval.top := (pnlNewGAF.Height div 2) - (dtpkrEval.height div 2);

      btnSave.width := ButtonWidth(btnSave.caption);
      lblEnterGAF.width := TextWidth(lblEnterGAF.Caption, gvFont);
      spnedtGAF.width := 5 * ButtonWidthNormal div 8; //TextWidth('XXXX', gvFont);
      lblDate.width := TextWidth(lblDate.caption, gvFont);
      dtpkrEval.width := 4 * ButtonWidthNormal div 3; //TextWidth('XX/XX/XXXXX', gvFont);

      lblEnterGAF.Left := pnlNewGAF.Left + 10;
      spnedtGAF.Left := lblEnterGAF.Left + lblEnterGAF.Width;
      lblDate.Left := spnedtGAF.Left + spnedtGAF.Width + 20;
      dtpkrEval.Left := lblDate.Left + lblDate.Width;
      btnSave.Left := dtpkrEval.Left + dtpkrEval.Width + 20;

      lblHeader.Caption := ' Global Assessment of Functioning Manager';
      lblHeader.Font.Assign(gvFont);
      lblHeader.Font.Size := lblHeaderFontSize;
      lblPatient.Font.Assign(gvFont);
      lblPatient.Font.Size := lblPatientFontSize;

      with chrtGAF do
        begin
          LeftAxis.LabelsFont.Assign(gvFont);
          LeftAxis.Title.Font.Assign(gvFont);
          BottomAxis.LabelsFont.Assign(gvFont);
          Title.Font.Assign(gvFont);
        end;
      Update;
    end;

  if gvUseScreenReader then
    begin
      Left := 0;
      Width := Screen.Width;
      imgBackup.Visible := False;
      Caption := 'GAF manager for patient ' + Patient.Name;
    // Don't call these a "table." JAWS has special keys for reading tables
    // which will not work here.
      grpOldGAFs.Caption := 'The following grid shows GAF ratings. The' +
        ' three columns show the date, GAF rating and the clinician. Navigate' +
        ' using the arrow keys. Press tab to enter grid.';
      grpGAFCriteria.Caption :=
        'The next grid summarizes GAF criteria from low to ' +
        'high scores. Navigate with the arrow keys. Press tab to enter grid.';
      grpOldGAFs.Width := Width - 10;
      grpOldGAFS.TabStop := True;
      grpGAFCriteria.TabStop := True;

      btnSave.caption := btnSave.Caption + ' button';
      btnEditGAF.caption := btnEditGAF.Caption + ' button';

    end;

  InitGAFCriteria;
  InitGrdResults;
end;


function TfrmMHA_GAF.GetGAFScores(aDFN: string): string;
begin
  // Construct the GAF_OPS.ListOfGAFs
  Result := GAF_OPS.GetPreviousGAFRatings(aDFN);
end;

procedure TfrmMHA_GAF.SetSaveButton;
begin
  btnSave.Enabled := not ActiveGAF.IsSaved;
  mnuSave.Enabled := btnSave.Enabled;
  mnuSaveNewRating.Enabled := btnSave.Enabled;
end;

procedure TfrmMHA_GAF.InitGAFCriteria;
var
  i                           : integer;
begin
  with grdGAFCriteria, GUI_Control do
    begin
      WordWrap := true;

      if gvUseScreenReader then
        begin
          SelectionRectangle := False;
          ShowSelection := true;
          Options := [goFixedVertLine, goFixedHorzLine, goHorzLine, goColSizing,
            goRowSelect];
          FixedRowAlways := False;
          FixedColAlways := False;
          FixedRows := 0;
          FixedCols := 0;
          ShowHint := False;
        end
      else
        begin
          Font.Assign(gvFont);
          FixedFont.Assign(gvFont);
          DefaultRowHeight := 3 * TextHeight('Yy', gvFont) div 2;
          SelectionRectangle := false;
          ShowSelection := True;
          Options := [goFixedVertLine, goFixedHorzLine, goVertLine, goHorzLine,
            goDrawFocusSelected, goColSizing, goRowSelect];
          FixedRowAlways := True;
          FixedColAlways := False;
          FixedRows := 1;
          FixedCols := 0;
          // Use DefaultRowHeight: inserting the actual formula does not work.
          FixedRowHeight := DefaultRowHeight;
          ShowHint := True;
        end;

      ColWidths[0] := TextWidth('XXRangeXX', gvFont);
      Cells[0, 0] := 'Range';
      Cells[0, 1] := '1-10';
      Cells[0, 2] := '11-20';
      Cells[0, 3] := '21-30';
      Cells[0, 4] := '31-40';
      Cells[0, 5] := '41-50';
      Cells[0, 6] := '51-60';
      Cells[0, 7] := '61-70';
      Cells[0, 8] := '71-80';
      Cells[0, 9] := '81-90';
      Cells[0, 10] := '91-100';

      Cells[1, 0] := 'Criteria';

      Cells[1, 1] :=
        'Persistent danger of severely hurting self or others (e.g., '
        + 'recurrent violence) OR persistent inability to maintain minimal personal '
        + 'hygiene OR serious suicidal act with clear expectation of death.';

      Cells[1, 2] :=
        'Some danger of hurting self or others (e.g., suicide attempts '
        + 'without clear expectation of death; frequently violent; OR occasionally '
        + 'fails to maintain minimal personal hygiene (e.g., smears feces) OR gross '
        + 'impairment in communication (e.g., largely incoherent or mute).';

      Cells[1, 3] :=
        'Behavior is considerably influenced by delusions or hallucinations OR '
        + 'serious impairment in communication or judgment (e.g., sometime incoherent, '
        + 'acts grossly inappropriately, suicidal preoccupation) OR inability to '
        + 'function in almost all areas (e.g., stays in bed all day; no job, home or friends).';

      Cells[1, 4] :=
        'Some impairment in reality testing or communication (e.g., speech is at '
        + 'times illogical, obscure, or irrelevant) OR major impairment in several '
        + 'areas, such as work or school, family relations, judgment, thinking, or '
        + 'mood (e.g., depressed man avoids friends, neglects family, and is unable '
        + 'to work; child frequently beats up younger children, is defiant at home '
        + 'and is failing at school).';

      Cells[1, 5] :=
        'Serious symptoms (e.g., suicidal ideation, severe obsessional rituals, '
        + 'frequent shoplifting) OR any serious impairment in social, occupational, '
        + 'or school functioning (e.g., no friends, unable to keep a job).';

      Cells[1, 6] :=
        'Moderate symptoms (e.g., flat affect and circumstantial speech, occasional '
        + 'panic attacks) OR moderate difficulty in social, occupational, or school '
        + 'functioning (e.g., few friends, conflicts with peers or co-workers).';

      Cells[1, 7] :=
        'Some mild symptoms (e.g., depressed mood and mild insomnia) OR some '
        + 'difficulty in social, occupational or school functioning (e.g., occasional '
        + 'truancy, or theft within the household), but generally functioning '
        + 'pretty well, has some meaningful interpersonal relationships.';

      Cells[1, 8] :=
        'If symptoms are present, they are transient and expectable reactions to '
        + 'psychosocial stressors (e.g., difficulty concentrating after family '
        + 'argument); no more than slight impairment in social, occupational, or '
        + 'school functioning (e.g., temporarily falling behind in schoolwork).';

      Cells[1, 9] :=
        'Absent or minimal symptoms (e.g., mild anxiety before an exam), good '
        + 'functioning in all areas, interested and involved in a wide range '
        + 'of activities, socially effective, generally satisfied with life, no '
        + 'more than everyday problems or concerns (e.g., an occasional argument '
        + 'with family members).';

      Cells[1, 10] := 'Superior functioning in a wide range of activities, '
        + 'life' + '''' +
        's problems never seem to get out of hand, is sought out '
        + 'by others because of his or her many positive qualitites.  No symptoms.';

      for i := 1 to 10 do
        RowHeights[i] := (1 + (TextWidth(Cells[1, i], gvFont) div ColWidths[1]))
          * (TextHeight('Yy', gvFont)) + (TextHeight('Yy', gvFont) div 3);
    end;
end;


procedure TfrmMHA_GAF.mnuSelectPatientClick(Sender: TObject);
var
  Save_Cursor                 : TCursor;
begin
  if (DataBaseMode = dbVista) then
    begin
      Save_Cursor := Screen.Cursor;
      Screen.Cursor := crHourglass; { Show hourglass cursor }
      try
      { Do some lengthy operation }
        Patient_OPS.SelectUsingCPRS;
      finally
        Screen.Cursor := Save_Cursor; { Always restore to normal }
      end; //try
    end; //dbVista

end;


procedure TfrmMHA_GAF.ClearTempGAF;
begin
  with ActiveGAF do
    begin
      IsSaved := True;
      IENS := '';
      GAFDate := Now;
      DateString := DateToStr(GAFDate);
      Rating := 1;
      Rater := '';
      EnteredInError := False;
      UserCanModify := False;
      CanBeMarkedInError := False;
      CanBeEdited := False;
      CanBeModified := False;
    end;
end;

procedure TfrmMHA_GAF.UpdateAllDisplays;
begin
  lblPatient.Caption := Patient.CaptionInfo;

  DisplayPreviousRatings;

  ClearTempGAF;

  // This little dance is necessary to actually reset the dtpkrEval.Date
  // dtpkrEval.MaxDate := FGAF.GAFDate + 1;
  dtpkrEval.Date := Now;
  dtpkrEval.MaxDate := Date;
  spnedtGAF.Value := ActiveGAF.Rating;
  FspnGAFChange := False;

  if GAF_OPS.ListOfGAFs.Count > 0 then
    begin
      grdGAFResults.Row := 1;
      grdGAFResultsClick(nil);
    end;

  if chrtGAF.Visible then
    begin
      mnuShowGraphLabels.Enabled := True;
      mnuSaveGraph.Enabled := True;
      mnuPrintGraph.Enabled := True;
      mnuCopyGraph.Enabled := True;
    end
  else
    begin
      mnuShowGraphLabels.Enabled := False;
      mnuSaveGraph.Enabled := False;
      mnuPrintGraph.Enabled := False;
      mnuCopyGraph.Enabled := False;
    end;

  SetSaveButton;
  SetEditButton;
end;

procedure TfrmMHA_GAF.DisplayPreviousRatings;
var
  i                           : integer;
begin
  GetGAFScores(Patient.DFN);

  with grdGafResults do
    //if there are previous ratings, write them to string grid
    if GAF_OPS.ListOfGAFs.Count > 0 then
      begin
        grdGafResults.ClearRows(1, RowCount);

        grdGafResults.RowCount := GAF_OPS.ListOfGAFs.Count + 1;
        for i := 0 to GAF_OPS.ListOfGAFs.Count - 1 do
          begin

            Cells[0, i + 1] := TGAF(GAF_OPS.ListOfGAFs[i]).DateString;
            Cells[1, i + 1] := IntToStr(TGAF(GAF_OPS.ListOfGAFs[i]).Rating);
            Cells[2, i + 1] := TGAF(GAF_OPS.ListOfGAFs[i]).Rater;
            Cells[3, i + 1] := TGAF(GAF_OPS.ListOfGAFs[i]).IENS;

            //Set row tag
            Cells[4, i + 1] := '';
            if TGAF(GAF_OPS.ListOfGAFs[i]).EnteredInError then
              Cells[4, i + 1] := 'ERROR';
            if TGAF(GAF_OPS.ListOfGAFs[i]).CanBeEdited then
              Cells[4, i + 1] := 'EDIT';
            if TGAF(GAF_OPS.ListOfGAFs[i]).CanBeMarkedInError then
              Cells[4, i + 1] := 'MARK';
          end; //for i...

        mnuCopy.Enabled := true;
        mnuPrint.Enabled := true;
        mnuSaveAs.Enabled := true;
      end //if previous ratings exist

    else //if there are no previous GAF ratings
      begin
        RowCount := 2;
        Cells[0, 1] := 'None';
        Cells[1, 1] := '';
        Cells[2, 1] := '';

        mnuCopy.Enabled := false;
        mnuPrint.Enabled := false;
        mnuSaveAs.Enabled := False;
      end; //else

  grdGAFResults.SortByColumn(0);
  grdGAFResults.TopRow := 1;
  grdGAFResults.Refresh;

  GraphRatings;
end;


procedure TfrmMHA_GAF.InitGrdResults;
begin
  //init string grid
  with grdGafResults, GUI_Control do
    begin
      if gvUseScreenReader then
        begin
          SelectionRectangle := True;
          ShowSelection := True;
          Options := [goFixedVertLine, goFixedHorzLine, goHorzLine,
            goDrawFocusSelected, goColSizing, goRowSelect];
          FixedRowAlways := False;
          FixedColAlways := False;
          FixedRows := 0;
          FixedCols := 0;
          ShowHint := False;
        end
      else
        begin
          grpOldGAFs.Caption := ' ';
          SelectionRectangle := False;
          ShowSelection := True;
          Options := [goFixedVertLine, goFixedHorzLine, goVertLine, goHorzLine,
            goDrawFocusSelected, goColSizing, goRowSelect];
          Font.Assign(gvFont);
          FixedFont.Assign(gvFont);
          DefaultRowHeight := 3 * TextHeight('Yy', gvFont) div 2;
          FixedRowAlways := True;
          FixedColAlways := False;
          FixedRows := 1;
          FixedCols := 0;
          // Use DefaultRowHeight: inserting the actual formula does not work.
          FixedRowHeight := DefaultRowHeight;
          ShowHint := True;
        end;

      ColCount := 5;
      ColWidths[0] := TextWidth('XXX/XX/XXXXXXX', gvFont); // Date
      ColWidths[1] := TextWidth('XXXXX', gvFont); //40; //Rating
      ColWidths[2] := TextWidth('XXXXXXXXXXXXXXXXXXXXXXXXXXXXX', gvFont);
        //200; //Rater
      ColWidths[3] := 0; //IENS
      ColWidths[4] := 0; //row tag
      Cells[0, 0] := 'Date';
      Cells[1, 0] := 'GAF';
      Cells[2, 0] := 'Clinician';
    end;

end;

procedure TfrmMHA_GAF.spnedtGAFChange(Sender: TObject);
var
  tmpRow                      : integer;
begin
  //Correct for garbage keyboard entries
  with spnedtGAF do
    begin
      if pos('0', Text) = 1 then
        Text := copy(Text, 2, Length(Text) - 1);
      if Text = '' then
        exit;
      if Value > MaxValue then
        Value := MaxValue;
      if Value < MinValue then
        Value := MinValue;
    end;

  //Reset selected row of all criteria string grid
  FspnGAFChange := True;
  tmpRow := ((spnedtGAF.Value - 1) div 10) + 1;
  grdGAFCriteria.Row := tmpRow;
  FspnGAFChange := False;

  //If you got this far, it's a valid rating
  ActiveGAF.Rating := spnedtGAF.Value;
  ActiveGAF.IsSaved := False;
  SetSaveButton;

end;

procedure TfrmMHA_GAF.grdGAFCriteriaClick(Sender: TObject);
var
  LastDigit                   : integer;
begin
  // compute the last digit of the rating
  // otherwise, entering a value via keyboard to spnGAF gets stepped on
  // by this event
  if FspnGAFChange then
    LastDigit := spnedtGAF.Value mod 10
  else
    LastDigit := 5;

  if LastDigit = 0 then
    LastDigit := 10;

  //reset the rating
  spnedtGAF.Value := ((grdGAFCriteria.Row - 1) * 10) + LastDigit;
  ActiveGAF.Rating := spnedtGAF.Value;

  ActiveGAF.IsSaved := False;
  SetSaveButton;

end;


procedure TfrmMHA_GAF.GraphRatings;
var
  i                           : Integer;
begin

  if not GAF_OPS.RatingsCanBeGraphed then
    begin
      chrtGAF.Visible := False;
      Exit;
    end
  else
    chrtGAF.Visible := True;

  with chrtGAF do
    begin
      Title.Visible := False;
      Series2.Clear;

      for i := GAF_OPS.ListOfGAFs.Count - 1 downto 0 do
        begin
          if TGAF(GAF_OPS.ListOfGAFs[i]).EnteredInError then
            continue;

          Series2.AddXy(
            TGAF(GAF_OPS.ListOfGAFs[i]).GAFDate,
            TGAF(GAF_OPS.ListOfGAFs[i]).Rating,
            TGAF(GAF_OPS.ListOfGAFs[i]).DateString, clRed);
        end; // for i
    end; // with
end;


procedure TfrmMHA_GAF.btnSaveClick(Sender: TObject);
const
  tmpCaption                  = 'you want to enter a new GAF rating';
var
  reply                       : string;
begin

  if not EnterDataForDeadPatient(tmpCaption) then
    begin
      ActiveGAF.IsSaved := True;
      Exit;
    end;

  SetGAFDate;

  Reply := GAF_OPS.SaveNew(Patient.DFN, ThisUser.DUZ,
    ActiveGAF.DateString, IntToStr(ActiveGAF.Rating));

  if reply <> OK then
    begin
      MsgDlgFrm(Reply, 'Saving GAF score',
        mtError, [mbOk], 0);
      Exit;
    end;

  gvNameOfInstrument := 'GAF';
(*
 // Show user the saved message.
  try
    frmMHA_Saved := TfrmMHA_Saved.Create(self);
    sleep(1500); // milliseconds
    frmMHA_Saved.Free;
  except
    on E: Exception do
      begin
        MsgDlgFrm(E.Message, 'Form Save',
          mtError, [mbOk], 0);
        exit;
      end;
  end; {-try -}
*)

  UpdateAllDisplays;
  ActiveGAF.IsSaved := True;
  SetSaveButton;

  if gvUseScreenReader then
    ActiveControl := grpOldGAFs
  else
    ActiveControl := grdGAFResults;
end;


procedure TfrmMHA_GAF.SetGAFDate;
begin
  ActiveGAF.GAFDate := dtpkrEval.Date;
  ActiveGAF.DateString := DateToStr(ActiveGAF.GAFDate);
end;

procedure TfrmMHA_GAF.dtpkrEvalChange(Sender: TObject);
begin
  SetGAFDate;
  SetSaveButton;
end;

procedure TfrmMHA_GAF.grdGAFResultsClick(Sender: TObject);
begin
  if GAF_OPS.ListOfGAFs.Count > 0 then
    begin
      // line below causes access when form closes--
      //ActiveGAF := TGAF(GAF_OPS.ListOfGAFs[grdGAFResults.Row - 1]);

      ActiveGAF.Rating :=
        TGAF(GAF_OPS.ListOfGAFs[grdGAFResults.Row - 1]).Rating;
      ActiveGAF.DateString :=
        TGAF(GAF_OPS.ListOfGAFs[grdGAFResults.Row - 1]).DateString;
      ActiveGAF.CanBeModified :=
        TGAF(GAF_OPS.ListOfGAFs[grdGAFResults.Row - 1]).CanBeModified;
      ActiveGAF.CanBeEdited :=
        TGAF(GAF_OPS.ListOfGAFs[grdGAFResults.Row - 1]).CanBeEdited;
      ActiveGAF.CanBeMarkedInError :=
        TGAF(GAF_OPS.ListOfGAFs[grdGAFResults.Row - 1]).CanBeMarkedInError;
      ActiveGAF.IENS :=
        TGAF(GAF_OPS.ListOfGAFs[grdGAFResults.Row - 1]).IENS;
      ActiveGAF.IsSaved := True;
    end;

  SetEditButton;
end;

procedure TfrmMHA_GAF.grdGAFResultsGetCellColor(Sender: TObject; ARow,
  ACol: Integer; AState: TGridDrawState; ABrush: TBrush; AFont: TFont);
begin

  if RowTag(ARow) = 'ERROR' then
    AFont.Style := [fsStrikeOut];

  if RowTag(ARow) = 'EDIT' then
    AFont.Style := [fsBold];
end;

function TfrmMHA_GAF.RowTag(ARow: integer): string;
begin
  Result := grdGAFResults.Cells[4, ARow];
end;

procedure TfrmMHA_GAF.SetEditButton;
begin

  if not ActiveGAF.CanBeModified then
    begin
      pnlOldGAFs.visible := False;
      mnuRevise.Visible := False;
      Exit;
    end;

  if ActiveGAF.CanBeEdited then
    begin
      pnlOldGAFs.visible := True;
      btnEditGAF.Caption := 'Change/Delete &Rating';
      //btnEditGAF.Width := GUI_Control.ButtonWidth(btnEditGAF.Caption + 'XXX');
      mnuRevise.Visible := True;
      mnuRevise.Caption := btnEditGAF.Caption;
      Exit;
    end;

  if ActiveGAF.CanBeMarkedInError then
    begin
      pnlOldGAFs.visible := True;
      btnEditGAF.Caption := 'Mark &Rating "Entered in Error"';
      //btnEditGAF.Width := GUI_Control.ButtonWidth(btnEditGAF.Caption + 'XXX');
      mnuRevise.Visible := True;
      mnuRevise.Caption := btnEditGAF.Caption;
    end;

end;


procedure TfrmMHA_GAF.mnuExitClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmMHA_GAF.mnuCopyTblClick(Sender: TObject);
var
  TempStrList                 : TStringList;
  TempStr                     : string;
  i                           : integer;
begin
  if grdGAFResults.RowCount <= 1 then
    exit;

  TempStrList := TStringList.Create;

  TempStrList.Add(Patient.Name + '  SSN: ' + Patient.FormattedSSN +
    '  GAF Scores   Date Viewed: ' + DateToStr(Date));
  TempStrList.Add(' ');

  ConvertGridToStringList(TempStrList);

  for i := 0 to TempStrList.count - 1 do
    TempStr := TempStr + #13 + TempStrList[i];

  Clipboard.AsText := TempStr;

  MsgDlgFrm('The table has been copied to the Windows clipboard.'
    ,
    MHA_CAPTION, mtInformation, [mbOK], 0);

  TempStrList.Free;
end;

procedure TfrmMHA_GAF.mnuSaveAsTblClick(Sender: TObject);
var
  TempStrList                 : TStringList;
  TempStr                     : string;
  i                           : integer;

begin
  with dlgSave do
    begin
      FileName := 'GAF Scores.txt';
      Filter := 'Text file (*txt)|*.txt';
      if Execute then
        begin
          if grdGAFResults.RowCount <= 1 then
            exit;

          TempStrList := TStringList.Create;

          TempStrList.Add(Patient.Name + '  SSN: ' + Patient.FormattedSSN +
            '  GAF Scores   Date Viewed: ' + DateToStr(Date));
          TempStrList.Add(' ');

          ConvertGridToStringList(TempStrList);

          TempStrList.SaveToFile(dlgSave.FileName);
          TempStrList.Free;
        end;
    end;
end;


procedure TfrmMHA_GAF.ConvertGridToStringList(var List: TStringList);
const
  space                       : string = '     ';
var
  i                           : integer;
  TempStr                     : string;
begin
  List.Add(' ');
  List.Add('Date          ' +
    'GAF' + space +
    'Clinician');
  List.Add(' ');

  for i := 1 to grdGAFResults.RowCount do
    begin
      List.Add(' ');

      if grdGAFResults.Cells[4, i] = 'ERROR' then
        TempStr := 'GAF entered in error'
      else
        TempStr := '';

      List.Add(grdGAFResults.Cells[0, i] + space +
        grdGAFResults.Cells[1, i] + space +
        grdGAFResults.Cells[2, i] + space +
        TempStr);
    end; //for i...
end;

procedure TfrmMHA_GAF.mnuPrintTblClick(Sender: TObject);
var
  TempStrList                 : TStringList;
begin
  if grdGAFResults.RowCount <= 1 then
    exit;

  TempStrList := TStringList.Create;

  ConvertGridToStringList(TempStrList);

  frmMHA_Print := TfrmMHA_Print.Create(nil);
  frmMHA_Print.PrintTable(TempStrList,
    Patient.Name + '  SSN: ' + Patient.FormattedSSN +
    '  GAF Scores  Printed: ' + DateToStr(Date));
  frmMHA_Print.Free;

  TempStrList.Free;

end;

procedure TfrmMHA_GAF.mnuCopyGphClick(Sender: TObject);
var
  TempStr                     : string;
begin
  TempStr := StringReplace(Patient.CaptionInfo, #13, '', [rfReplaceAll]);
  chrtGAF.Title.Visible := True;
  chrtGAF.Title.Text.Add(TempStr);
  chrtGAF.CopyToClipboardBitmap;
  chrtGAF.Title.Text.Clear;
  chrtGAF.Title.Visible := False;

  MsgDlgFrm('The graph has been copied to the Windows clipboard.' + CRLF +
    '' + CRLF +
    'If you like, you may paste it into another document (e.g., an MS Word ' +
    CRLF + 'document).', MHA_CAPTION, mtInformation, [mbOK], 0);

end;

procedure TfrmMHA_GAF.mnuSaveAsGphClick(Sender: TObject);
begin
  with dlgSave do
    begin
      FileName := 'GAF Scores.bmp';
      Filter := 'Bitmap files (*.bmp)|*.bmp';
      if Execute then
        begin
          chrtGAF.Title.Text.Clear;
          chrtGAF.Title.Visible := True;
          chrtGAF.Title.Text.Add(Patient.Name + '  SSN: ' + Patient.FormattedSSN);
          chrtGAF.SaveToBitmapFile(FileName);
          chrtGAF.Title.Text.Clear;
        end;
      chrtGAF.Title.Visible := False;
    end;
end;

procedure TfrmMHA_GAF.mnuPrintGphClick(Sender: TObject);
begin
  frmMHA_Print := TfrmMHA_Print.Create(nil);
  frmMHA_Print.PrintChart(chrtGAF, Patient.Name + '  SSN: ' + Patient.FormattedSSN +
    '  GAF Scores  Printed: ' + DateToStr(Date));
  frmMHA_Print.Free;
  chrtGAF.Foot.Text.Text := '';
end;

procedure TfrmMHA_GAF.mnuOptionsClick(Sender: TObject);
begin
  if gvUseScreenReader then
    begin
      try
        frmMHA_Options_508 := TfrmMHA_Options_508.Create(nil);
      finally
        frmMHA_Options_508.Free;
      end;

    end
  else
    begin
      gvShowOptionTabs := '0'; // Show tab 0 on options form, Fonts
      try
        frmMHA_Options := TfrmMHA_Options.Create(nil);
    //frmMHA_Options.ShowModal;
      finally
        frmMHA_Options.Free;
      end;

      if GUI_Control.NeedGUIUpdate then
        ConfigureForm;
    end;
end;

procedure TfrmMHA_GAF.FormCanResize(Sender: TObject; var NewWidth,
  NewHeight: Integer; var Resize: Boolean);
begin
  Resize := true;
  if NewWidth < 770 then
    NewWidth := 770;

end;

procedure TfrmMHA_GAF.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  WhereMouse                  : TPoint;
begin

  if Key = vk_Escape then
    begin
      Close;
      Key := 0;
    end;

  if Shift = [ssAlt] then
    begin
      if Key = vk_F4 then
        Close;

      if key in [78, 110] then // New GAF score
        begin
          ActiveControl := spnedtGAF;
          WhereMouse.x := frmMHA_GAF.Left + spnedtGAF.left +
            spnedtGAF.width;
          WhereMouse.y := frmMHA_GAF.Top + frmMHA_GAF.Height - 10;
          Mouse.CursorPos := WhereMouse;
          Key := 0;
        end;

      if key in [68, 100] then // Date
        begin
          ActiveControl := dtpkrEval;
          WhereMouse.x := frmMHA_GAF.Left + dtpkrEval.left +
            dtpkrEval.width;
          WhereMouse.y := frmMHA_GAF.Top + frmMHA_GAF.Height - 10;
          Mouse.CursorPos := WhereMouse;
          Key := 0;
        end;
    end;
end;

function TfrmMHA_GAF.EnterDataForDeadPatient(ACaption: string): BOOLEAN;
var
  tmpCaption                  : string;
begin

  Result := True;
  if Patient.IsDead then
    begin
      tmpCaption := ACaption;
      Result := (MsgDlgFrm(Patient.Name + ' died on ' + Patient.DOD +
        '.  Are you sure '
        + tmpCaption + ' for this patient?', MHA_Caption, mtConfirmation,
        [mbYes, mbNo], 0) = mrYes);
    end;

end;

procedure TfrmMHA_GAF.mnuOnlineSupportClick(Sender: TObject);
begin
  VisitURL(MHA_ONLINE_SUPPORT_URL);
end;

procedure TfrmMHA_GAF.mnuAboutClick(Sender: TObject);
begin
  frmMHA_About := TfrmMHA_About.Create(nil);
  try
    frmMHA_About.ShowModal;
  finally
    frmMHA_About.Free;
  end; //try
end;

procedure TfrmMHA_GAF.grdGAFCriteriaGridHint(Sender: TObject; ARow,
  ACol: Integer; var hintstr: string);
begin
  HintStr := lcGAF_Copyright;
end;

procedure TfrmMHA_GAF.mnuCopyrightInfoClick(Sender: TObject);
begin
  MsgDlgFrm('GAF criteria: ' + lcGAF_Copyright, MHA_Caption, mtInformation,
    [mbOK], 0);
end;

procedure TfrmMHA_GAF.btnEditGAFClick(Sender: TObject);
begin

  if not ActiveGAF.CanBeModified then
    Exit;

  if not EnterDataForDeadPatient('you want to modify GAF data') then
    Exit;

  if ActiveGAF.CanBeEdited then
    begin
      try
        frmMHA_EditGAF := TfrmMHA_EditGAF.Create(nil);
      finally
        frmMHA_EditGAF.Free;
      end;

    end; //GAF can be edited

  if ActiveGAF.CanBeMarkedInError then
    if (MsgDlgFrm('Marking a rating as "Entered in Error" cannot be undone.'
      + CRLF + CRLF
      + 'Do you want to continue?',
      MHA_Caption, mtConfirmation, [mbYes, mbNo], 0) =
      mrYes) then
      GAF_OPS.MarkInError(ActiveGAF.IENS, ThisUser.Name);

  UpdateAllDisplays;

end;

procedure TfrmMHA_GAF.mnuReviseClick(Sender: TObject);
begin
  btnEditGAFClick(Sender);
end;

procedure TfrmMHA_GAF.mnuShowGraphLabelsClick(Sender: TObject);
var
  t                           : integer;
begin
  mnuShowGraphLabels.Checked := not mnuShowGraphLabels.Checked;

  if mnuShowGraphLabels.Checked then
    for t := 0 to chrtGAF.SeriesCount - 1 do
      begin
        if chrtGAF.Series[t] is TLineSeries then
          with (chrtGAF.Series[t] as TLineSeries) do
            begin
              Marks.Style := smsValue;
              Marks.Visible := true;
            end
      end
  else
    for t := 0 to chrtGAF.SeriesCount - 1 do
      begin
        if chrtGAF.Series[t] is TLineSeries then
          with (chrtGAF.Series[t] as TLineSeries) do
            Marks.Visible := False;
      end;
end;

procedure TfrmMHA_GAF.spnedtGAFKeyPress(Sender: TObject; var Key: Char);
begin
  ActiveGAF.IsSaved := False;
  SetSaveButton;
end;

procedure TfrmMHA_GAF.spnedtGAFClick(Sender: TObject);
begin
  ActiveGAF.IsSaved := False;
  SetSaveButton;
end;

procedure TfrmMHA_GAF.dtpkrEvalEnter(Sender: TObject);
begin
  ActiveGAF.IsSaved := False;
  SetSaveButton;
end;

procedure TfrmMHA_GAF.imgBackupClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmMHA_GAF.FormResize(Sender: TObject);
begin
  if lvInitialize then
    Exit;

  // Reset these, used in placement of dialogs
  gvLeft := Left;
  gvTop := Top;
  gvHeight := Height;
  gvWidth := Width;
end;

procedure TfrmMHA_GAF.grdGAFCriteriaKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = vk_Tab) or (Key = vk_Return) then
    begin
      Perform(WM_NEXTDLGCTL, 0, 0);
      Key := $00; {- requires "Message" in "uses" -}
    end;
end;

end.

