unit fMHA_SingleInstrumentMenu;

interface

uses

  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  ShellApi,
  StdCtrls,
  ExtCtrls,
  ComCtrls,
  Grids,
  BaseGrid,
  AdvGrid,
  Menus,
  TeEngine,
  Series,
  TeeProcs,
  Chart,
  CheckLst,
  ORCtrls,
  RzLabel,
  RzPanel,
  JvExControls,
  JvComponent,
  JvXPCore,
  JvXPButtons,
  Dialogs;

type

  TfrmMHA_SingleInstrumentMenu = class(TForm)
    MainMenu1: TMainMenu;
    mnuFile: TMenuItem;
    mnuExit: TMenuItem;
    PageControl1: TPageControl;
    tsReport: TTabSheet;
    mnuSelectPatient: TMenuItem;
    mnuNew: TMenuItem;
    mnuView: TMenuItem;
    mnuReport: TMenuItem;
    pnlNarrativeRepTop: TPanel;
    sptNarrativeReport: TSplitter;
    pnlNarrativeRepBottom: TPanel;
    pnlHeader: TRzPanel;
    lblHeader: TRzLabel;
    pnlTop: TPanel;
    N3: TMenuItem;
    DlgSave: TSaveDialog;
    mnuAction: TMenuItem;
    N4: TMenuItem;
    mnuTools: TMenuItem;
    mnuOptions: TMenuItem;
    N5: TMenuItem;
    lblPatient: TRzLabel;
    mnuEdit: TMenuItem;
    mnuCopy: TMenuItem;
    mnuHelp: TMenuItem;
    mnuAbout: TMenuItem;
    mnuOnlineSupport: TMenuItem;
    mnuSaveAs: TMenuItem;
    mnuSaveReport: TMenuItem;
    mnuSaveGraph: TMenuItem;
    mnuPrint: TMenuItem;
    mnuPrintReport: TMenuItem;
    mnuPrintGraph: TMenuItem;
    mnuCopyReport: TMenuItem;
    mnuCopyGraph: TMenuItem;
    tsGraphs: TTabSheet;
    pnlGraphOuter: TPanel;
    spltHorizontal: TSplitter;
    chrtScores: TChart;
    Series3: TLineSeries;
    Series2: TLineSeries;
    Series1: TLineSeries;
    LineSeries1: TLineSeries;
    Series4: TLineSeries;
    Series5: TLineSeries;
    Series9: TLineSeries;
    Series10: TLineSeries;
    Series6: TLineSeries;
    Series7: TLineSeries;
    Series8: TLineSeries;
    Series11: TLineSeries;
    Series12: TLineSeries;
    memReport: TRichEdit;
    pnlLeftTop: TPanel;
    mnuGraphTable: TMenuItem;
    mnuOtherInstruments: TMenuItem;
    mnuMetric: TMenuItem;
    mnuAppendComments: TMenuItem;
    N7: TMenuItem;
    mnuSaveTable: TMenuItem;
    mnuCopyTable: TMenuItem;
    mnuPrintTable: TMenuItem;
    grpAdministrations: TRzGroupBox;
    grdAdministrations: TAdvStringGrid;
    grpScores: TRzGroupBox;
    grdScores: TAdvStringGrid;
    mnuShowGraphLabels: TMenuItem;
    btnNew: TJvXPButton;
    btnEdit: TJvXPButton;
    mnuPrintBlank: TMenuItem;

    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ConfigureForm;

    procedure PageControl1Change(Sender: TObject);
    procedure PageControl1Changing(Sender: TObject;
      var AllowChange: Boolean);

    procedure grdScoresClickCell(Sender: TObject; ARow, ACol: Integer);

    procedure mnuExitClick(Sender: TObject);
    procedure mnuReportClick(Sender: TObject);
    procedure mnuSelectPatientClick(Sender: TObject);
    procedure mnuOtherInstrumentsClick(Sender: TObject);
    procedure mnuMetricClick(Sender: TObject);
    procedure mnuAppendCommentsClick(Sender: TObject);
    procedure mnuGraphTableClick(Sender: TObject);
    procedure mnuCopyReportClick(Sender: TObject);
    procedure mnuCopyGraphClick(Sender: TObject);
    procedure mnuSaveTableClick(Sender: TObject);
    procedure mnuPrintGraphClick(Sender: TObject);
    procedure mnuSaveGraphClick(Sender: TObject);
    procedure mnuCopyTableClick(Sender: TObject);
    procedure mnuPrintTblClick(Sender: TObject);
    procedure mnuOptionsClick(Sender: TObject);
    procedure mnuSaveReportClick(Sender: TObject);
    procedure mnuOnlineSupportClick(Sender: TObject);
    procedure mnuAboutClick(Sender: TObject);

    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);

    procedure btnNewClick(Sender: TObject);
    procedure btnEditClick(Sender: TObject);
    procedure DisplayScores;
    procedure mnuPrintReportClick(Sender: TObject);
    //procedure cbxStaffNeedData(Sender: TObject; const StartFrom: string;
    //  Direction, InsertAt: Integer);
    procedure FormDestroy(Sender: TObject);
    procedure mnuShowGraphLabelsClick(Sender: TObject);
    procedure UpdateAllDisplays;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure mnuPrintBlankClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure PrepareNewAdministration;
    procedure StaffEntry;
    procedure PatientEntry;
    procedure ShowAllItems;
    procedure ShowOneItem;
    procedure grdAdministrationsRowChanging(Sender: TObject; OldRow,
      NewRow: Integer; var Allow: Boolean);
    procedure grdAdministrationsGetCellColor(Sender: TObject; ARow,
      ACol: Integer; AState: TGridDrawState; ABrush: TBrush; AFont: TFont);
    procedure grdAdministrationsClickCell(Sender: TObject; ARow,
      ACol: Integer);
    procedure FormActivate(Sender: TObject);

  private
    { Private declarations }

    procedure Startva_SecureDesktop;
    procedure SendEMailToOrderer;
    procedure InitPreviousInterviewsGrids;
    procedure InitGrdScores;
    procedure LoadPreviousAdministrations;
    procedure DisplayReport(aIEN: string; CanDisplay: string; aRow: integer);
    procedure DisplayGrid;
    procedure InitChart(grp: Integer);
    procedure GraphScores(IsMultiScale: Boolean; aTitle: string);
    procedure GraphSingleScale(aTitle: string);
    procedure GraphSeveralScales(aTitle: string);
    function DetermineGroup(const aTitle: string): Integer;
    function GetXLabel(aScaleName: string): string;
    function EnterDataForDeadPatient(ACaption: string): BOOLEAN;
    procedure ShowAdmin;
    function GetScores: string;
    function GetItemIndex(aQuestionID, ChoiceID: string): string;
  public
    { Public declarations }
  end;

var
  frmMHA_SingleInstrumentMenu : TfrmMHA_SingleInstrumentMenu;

implementation

uses
  Printers,
  uIA_Const,
  uMHA_Const,
  uMHA_Registry,
  uIA_GUIControl,
  uMHA_Administration,
  uMHA_Administration_OPS,
  uIA_Instrument,
  uIA_AvailableInstrument,
  uMHA_Instrument_OPS,
  uIA_Question,
  uIA_Answer,
  uIA_ThisUser,
  uIA_Staff_OPS,
  fMHA_Progress,
  uMHA_LocalFiles,
  uMHA_ResourceFile_OPS,
  uMHA_Report_OPS,
  uIA_Scale,
  uIA_ScaleGroup,
  uIA_Scales_IO,
  uIA_Utils,
  fIA_Dialogs,
  uMHA_Proctor,
  uIA_Patient,
  uIA_Patient_OPS,
  uMHA_AResult,
  uMHA_Result_OPS,
  fMHA_SelectPatient,
  fMHA_Options,
  fMHA_Options_508,
  fMHA_About,
  fMHA_Main,
  fMHA_Admin,
  fMHA_AppendComments,
  fMHA_AdministerAllItems,
  fMHA_AdministerOneItem,
  //fMHA_Print_Blank,
  uMHA_DM,
  fMHA_SD_warning,
  fMHA_Print_Blank;

{$R *.DFM}

const
//  COLOR_ITEMREPORT            = $F0FBFF;
//  lcIndent                    = '   ';
//  clSkyBlue                   = TColor($F0CAA6);
//  clCream                     = TColor($F0FBFF);
//  clWorkspace                 = TColor($F0FBDA);
//  clMedGray                   = TColor($A4A0A0);
//  clMoneyGreen                = TColor($C0DCC0);

  INCOMPLETEEDIT              : string = 'Incomplete: Editable';
  INCOMPLETE                  : string = 'Incomplete: Non-editable';
  COMPLETE                    : string = 'Complete';

var
  lvDateColWidth,
    lvTypeColWidth,
    lvOldPageIndex            : Integer;

  lvInitialize,
    lvCancelled,
    lvIsStaffEntry,
    lvIsAllItems,
    lvInstrumentHasScales,
    lvIsFirstViewOfGraph      : BOOLEAN;
  lvInstrument                : TInstrument;
  lvAdministration            : TAdministration;


procedure TfrmMHA_SingleInstrumentMenu.FormCreate(Sender: TObject);

begin

  lvInitialize := True;

  // Keep Position out of ConfigureForm when ConfigureForm can be called
  // more than once with the form.
  Position := poDesigned;

  gvID := '';
  gvCurrentResult := 0;

  if (gvNameOfInstrument = '') or (gvNameOfInstrument = ' ') then
    begin
      MsgDlgFrm(' Sorry, there is an error. The name of the instrument is blank.',
        MHA_Caption, mtError, [mbOK], 0);
      Close;
      Exit;
    end;

//---
  lvInstrument := TInstrument.Create;

  memReport.Color := clInfoBk;
  mnuMetric.Enabled := (DataBaseMode = dbVista);

  // Default setting for presentation of graphs, once a report is loaded
  // these settings may change.
  lvInstrumentHasScales := false;

  ConfigureForm;

end;

procedure TfrmMHA_SingleInstrumentMenu.FormShow(Sender: TObject);
var
  reply                       : string;
  i                           : integer;
begin
  lvInitialize := True;
  btnNew.Enabled := true;
  btnEdit.Enabled := true;

  reply := Instrument_OPS.LoadListOfAvailableInstruments(ThisUser.AccessKeys);
  if reply <> OK then
    begin
      MsgDlgFrm(' Sorry, there is an error loading the instruments: ' + #13 + reply,
        MHA_Caption, mtError, [mbOK], 0);
      Close;
      Exit;
    end;

  for i := 0 to Instrument_OPS.ListOfInstruments.Count - 1 do
    if TAvailableInstrument(Instrument_OPS.ListOfInstruments[i]).AvailInstrumentName =
      gvNameOfInstrument then
      if not TAvailableInstrument(Instrument_OPS.ListOfInstruments[i]).CanBeAdministered then
        begin
          btnNew.Enabled := false;
          btnEdit.Enabled := false;
        end;

  lvInstrument.InstrumentName := gvNameOfInstrument;

  if not ResourceFile_OPS.ReadResourceFile(lvInstrument) then
    Instrument_OPS.Load(lvInstrument);

  //UpdateAllDisplays;

  if gvUseScreenReader then
    begin
      Caption := lvInstrument.InstrumentName + ' for ' + Patient.Name;
      // Don't call this a "table." JAWS has special keys for reading tables
      // which will not work here.
      grpAdministrations.Caption :=
        ' The following grid has four columns: the date of administration,' +
        ' the date saved, staff''s name and status of instrument. Navigate' +
        ' with the arrow keys, select with the enter key, then press tab key' +
        ' to read report. To enter grid press tab key.';

      grpScores.Caption := ' The next grid shows scale scores in two columns:' +
        ' the first is the date of administration, the second is the scale and' +
        ' its score. Navigate with the arrow keys. Enter grid with tab key. Press' +
        ' escape key when done.';

      chrtScores.Visible := False;
      spltHorizontal.Visible := False;
    end;

  Screen.Cursor := crDefault;
end;

procedure TfrmMHA_SingleInstrumentMenu.FormActivate(Sender: TObject);
begin

  if lvInitialize then
    begin
      UpdateAllDisplays;
      if gvUseScreenReader then
        ActiveControl := grpAdministrations
      else
        ActiveControl := grdAdministrations;
    end;
end;

procedure TfrmMHA_SingleInstrumentMenu.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  gvSingleWidth := Width;
  gvSingleHeight := Height;
  gvLeft := Left;
  gvTop := Top;

  MHA_Registry.SaveRegistry;

  Action := caFree;
end;


procedure TfrmMHA_SingleInstrumentMenu.FormDestroy(Sender: TObject);
begin
  // This will take care of freeing lvAdministration
  Administration_OPS.Administrations.Clear;

  if lvInstrument <> nil then
    lvInstrument.Free;
end;


procedure TfrmMHA_SingleInstrumentMenu.ConfigureForm;
// Set the parent-font, size and position of form
begin
  Caption := MHA_Caption + ' in use by ' + ThisUser.Name;
  MHA_Registry.ReadRegistry;

  with GUI_Control do
    begin
      Scaled := True;
      AutoScroll := False;
      AutoSize := False;
      PixelsPerInch := 120;
      KeyPreview := True;
      HorzScrollBar.Range := 0; // Ensures that buttons will move when re-sized
      VertScrollBar.Range := 0;
      Font.Assign(gvFont);

      Left := gvLeft;
      if Left < 0 then
        Left := 1;
      Top := gvTop;
      if Top < 0 then
        Top := 1;

      Height := GetHeight(gvSingleHeight);
      Width := GetWidth(gvSingleWidth);

      if CheckWidth(Width) or CheckHeight(Height) then
        WindowState := wsMaximized;
      Refresh; // resets alClient dimensions

      // Form is designed for font.size = 8; all other sizes are enlarged from that
      // yardstick.
      // 80 for Font.size 8
      lvDateColWidth := TextWidth('XXX/XX/XXXXX', gvFont);
      // 70 for Font.size 8
      lvTypeColWidth := TextWidth('XXXXXXXXXX', gvFont);
      if gvFont.Size > 10 then
        memReport.Scrollbars := ssBoth
      else
        memReport.Scrollbars := ssVertical;

      pnlHeader.Height := pnlHeaderHeight;

      with lblPatient do
        begin
          Font.Assign(gvFont);
          Font.Size := lblPatientFontSize;
          Font.Color := clBlack;
          Color := clWhite;
          Layout := tlCenter;
          Align := alRight;
          AutoSize := false;
          Caption := Patient.CaptionInfo;
          Width := TextWidth(Caption, Font);
         // Left := 3 * Width div 5;
        end;

      with lblHeader do
        begin
          Caption := '   ' + gvNameOfInstrument;
          Hint := lvInstrument.PrintTitle;
          ShowHint := True;
          Font.Assign(gvFont);
          Font.Size := lblHeaderFontSize;
          Font.Color := clBlack;
          AutoSize := True;
          Layout := tlCenter;
          Align := alLeft;
          Color := clWhite;
          //Width := pnlHeader.Width - lblpatient.Left - 5;
        end;

      btnNew.Height := ButtonHeight;
      btnNew.Width := ButtonWidthNormal;
      btnNew.Hint := 'New ' + lvInstrument.InstrumentName;

      btnEdit.Height := ButtonHeight;
      btnEdit.Width := ButtonWidthNormal;
      btnEdit.Top := (2 * btnNew.Top) + btnNew.Height;
      btnEdit.Hint := 'Edit highlighted ' + lvInstrument.InstrumentName;

      pnlLeftTop.Width := (2 * btnNew.Left) + btnNew.Width;
      grpAdministrations.Caption := '  Administrations ';
      grpScores.Caption := '  Scores  ';

      if gvUseScreenReader then
        begin
          Left := 0;
          Width := Screen.Width;
          btnNew.caption := btnNew.Caption + ' button';
          btnEdit.caption := btnEdit.Caption + ' button';
        end;
    end; // with GUI Control
end;


procedure TfrmMHA_SingleInstrumentMenu.InitPreviousInterviewsGrids;
begin
  with grdAdministrations do
    begin
      Clear;
      RowCount := 2;
      Font.Assign(gvFont);
      DefaultRowHeight := 3 * (GUI_Control.TextHeight('Yy', gvFont))
        div 2;

      if gvUseScreenReader then
        begin
          SelectionRectangle := True;
          ShowSelection := True;
          Options := [goHorzLine, goDrawFocusSelected, goColSizing,
            goRowSelect];
          FixedRowAlways := False;
          FixedColAlways := False;
          FixedRowHeight := DefaultRowHeight;
          FixedRows := 1;
          FixedCols := 0;
        end
      else
        begin
          SelectionRectangle := False;
          ShowSelection := True;
          Options := [goFixedVertLine, goFixedHorzLine, goVertLine, goHorzLine,
            goDrawFocusSelected, goColSizing, goRowSelect];
          FixedFont.Assign(gvFont);
          FixedRowAlways := True;
          FixedColAlways := false;
          FixedRows := 1;
          FixedCols := 0;
          FixedRowHeight := DefaultRowHeight;
          FixedColWidth := lvDateColWidth;
        end;

      FixedRowHeight := DefaultRowHeight;
      ColCount := 7;

      ColWidths[0] := lvDateColWidth; // Date Given
      ColWidths[1] := lvDateColWidth; // Date Saved
      ColWidths[2] := lvTypeColWidth + lvDateColWidth; // Interviewer
      ColWidths[3] := 2 * lvDateColWidth; // Completed
      ColWidths[4] := 0; // Admin.ID
      ColWidths[5] := 0; // Bold On/Off
      ColWidths[6] := 0; // TestIENS for MHA2 entry

      // The width of Col[3] will vary depending on the width of the panel.
      ColumnSize.StretchColumn := 3;
      ColumnSize.Stretch := True;

      Cells[0, 0] := 'Date Given';
      Cells[1, 0] := 'Date Saved';
      Cells[2, 0] := 'Ordered By';
      Cells[3, 0] := 'Status';
    end; //with Grid
end;

procedure TfrmMHA_SingleInstrumentMenu.mnuSelectPatientClick(Sender: TObject);
var
  OldDFN                      : string;
  Save_Cursor                 : TCursor;
begin
  if (DataBaseMode = dbVista) then
    begin
      Save_Cursor := Screen.Cursor;
      Screen.Cursor := crHourglass; { Show hourglass cursor }
      try
        { Do some lengthy operation }
        Patient_OPS.SelectUsingCPRS;
      finally
        Screen.Cursor := Save_Cursor; { Always restore to normal }
      end; //try
    end //dbVista
  else
    begin
      OldDFN := Patient.DFN;

      frmMHA_SelectPatient := TfrmMHA_SelectPatient.Create(nil);
      try
        frmMHA_SelectPatient.ShowModal;
      finally
        frmMHA_SelectPatient.Free;
      end;

      if not (OldDFN = Patient.DFN) then
        UpdateAllDisplays;
    end;
end;


procedure TfrmMHA_SingleInstrumentMenu.UpdateAllDisplays;
var
  Allow                       : boolean;
begin
  lvInitialize := false;
  lblPatient.Caption := Patient.CaptionInfo;

  // This clears the previous patient's list of interviews and reports before
  // loading of new data, so the user no longer sees old data.
  memReport.Clear;
  PageControl1.ActivePageIndex := 0;
  mnuReport.Enabled := false;

  InitPreviousInterviewsGrids;
  LoadPreviousAdministrations;

  if grdAdministrations.RowCount > 1 then
    begin
      grdAdministrations.Row := 1;
      Allow := true;
      //grdAdministrationsClickCell(self, 1, 0);
      grdAdministrationsRowChanging(Self, 0 {Old}, 1 {New}, Allow);

      mnuAppendComments.Enabled :=
        (grdAdministrations.Cells[3, grdAdministrations.Row] = COMPLETE);
    end;

  tsGraphs.TabVisible := lvInstrumentHasScales;
  mnuGraphTable.Enabled := lvInstrumentHasScales;
  mnuShowGraphLabels.Enabled := lvInstrumentHasScales;
  mnuCopyTable.Enabled := lvInstrumentHasScales;
  mnuCopyGraph.Enabled := lvInstrumentHasScales;
  mnuPrintTable.Enabled := lvInstrumentHasScales;
  mnuPrintGraph.Enabled := lvInstrumentHasScales;
end;

procedure TfrmMHA_SingleInstrumentMenu.LoadPreviousAdministrations;
var
  TempUser                    : TThisUser;
  i, j                        : integer;
  reply                       : string;

begin
  TempUser := TThisUser.Create;

  frmMHA_Progress := TfrmMHA_Progress.Create(nil);
  try
    Reply := Result_OPS.LoadCompleteResults(Patient.DFN);

    if reply <> OK then
      begin
        MsgDlgFrm(' Sorry, there is an error loading the results: ' + #13 + reply,
          MHA_Caption, mtError, [mbOK], 0);
        Close;
        Exit;
      end;

    frmMHA_Progress.SetupProgressBar(' Searching results. . .',
      Result_OPS.ListOfResults.Count);

    gvID := NO_ID;
    j := 0;

    for i := 0 to Result_OPS.ListOfResults.Count - 1 do
      begin
        with TAResult(Result_OPS.ListOfResults[i]) do
          begin
            frmMHA_Progress.IncreaseProgressBar;
            if InstrumentName = gvNameOfInstrument then
              begin
                Inc(j);
                grdAdministrations.Cells[0, j] := DateGiven;
                grdAdministrations.Cells[1, j] := DateSaved;
                TempUser.Load(OrderedBy, DataModule1.RPCBroker1);
                grdAdministrations.Cells[2, j] := MixedCase(TempUser.Name);
                grdAdministrations.Cells[3, j] := COMPLETE;
                grdAdministrations.Cells[4, j] := AdministrationIENS;
                grdAdministrations.Cells[5, j] := 'False'; // Bold
                grdAdministrations.Cells[6, j] := IntToStr(TestIENS);
              end; // if name
          end; // with TAResult(Result_OPS.ListOfResults[i])
      end; // for i

    Administration_OPS.ListOfIncompletes.Clear;
     // Find incompletes for this user (User is orderer in previous results).
    Administration_OPS.ReadIncompleteResults(Patient.DFN, ThisUser.DUZ);

    if Administration_OPS.ListOfIncompletes.Count > 0 then
      begin
        frmMHA_Progress.SetupProgressBar(' Searching incomplete results. . .',
          Administration_OPS.ListOfIncompletes.Count);

        for i := 0 to Administration_OPS.ListOfIncompletes.Count - 1 do
          with TAdministration(Administration_OPS.ListOfIncompletes[i]) do
            begin
              if InstrumentName = gvNameOfInstrument then
                begin
                  Inc(j);
                  grdAdministrations.Cells[0, j] := FormatDateTime('mm/dd/yyyy',
                    DateGiven);
                  grdAdministrations.Cells[1, j] := FormatDateTime('mm/dd/yyyy',
                    DateSaved);
                  grdAdministrations.Cells[2, j] := ThisUser.Name;
                  grdAdministrations.Cells[3, j] := INCOMPLETEEDIT;
                  grdAdministrations.Cells[4, j] := ID;
                  grdAdministrations.Cells[5, j] := 'True'; // Bold On
                end; // if name
            end;
      end;

  finally
    frmMHA_Progress.Free;
  end; //try

  TempUser.Free;

  grdAdministrations.RowCount := j + 1;

  if grdAdministrations.RowCount > 1 then
    begin
      grdAdministrations.SortByColumn(0);
      gvID := grdAdministrations.Cells[4, 1];
    end
  else
    begin
      grdAdministrations.Cells[2, 1] := 'No previous administrations';
      btnEdit.Enabled := false;
    end;
end;

function TfrmMHA_SingleInstrumentMenu.GetItemIndex(aQuestionID, ChoiceID: string): string;
var
  j, i                        : Integer;
begin
  result := ChoiceID;

  if (ChoiceID = NOT_ASKED) or (ChoiceID = SKIPPED) or
    (ChoiceID = CHOICE_ID_OF_SKIPPED_QUESTION) or
    (ChoiceID = CHOICE_ID_OF_SKIPPED_BY_RULE_QUESTION) or
    (ChoiceID = CHOICE_ID_OF_SKIPPED_REQUIRED_QUESTION) then
    Exit;

  for i := 0 to MHA_Report_OPS.ListOfQuestionsForReport.Count - 1 do
    if aQuestionID = TQuestion(MHA_Report_OPS.ListOfQuestionsForReport[i]).QuestionID then
      if TQuestion(MHA_Report_OPS.ListOfQuestionsForReport[i]).ResponseType = rtMultiChoice then
        for j := 0 to TQuestion(MHA_Report_OPS.ListOfQuestionsForReport[i]).MultiChoice.choices.Count - 1 do
          if Piece(TQuestion(MHA_Report_OPS.ListOfQuestionsForReport[i]).MultiChoice.choices[j], U, 2) =
            ChoiceID then
            result := IntToStr(j);
end;

procedure TfrmMHA_SingleInstrumentMenu.DisplayReport(aIEN: string;
  CanDisplay: string; aRow: integer);
var
  i                           : Integer;
  InstName,
  AnswerString,
    ResultString              : string;
  ReportStrList               : TStringList;
  dllHandle                   : THandle;
  TempDate                    : TDateTime;

  procedure HandleGroomedAnswers;
  var
    ii                        : Integer;
    TempStr                   : string;
  begin
    // AnswerString format:
    // QuestionID=ItemIndex^AnswerText^AnswerID

    for ii := 0 to MHA_Report_OPS.ListOfAnswersForReport.Count - 1 do
      AnswerString := AnswerString +
        TAnswer(MHA_Report_OPS.ListOfAnswersForReport[ii]).QuestionID + EQ +
        GetItemIndex(TAnswer(MHA_Report_OPS.ListOfAnswersForReport[ii]).QuestionID,
        TAnswer(MHA_Report_OPS.ListOfAnswersForReport[ii]).AnswerValue) + U +
        TAnswer(MHA_Report_OPS.ListOfAnswersForReport[ii]).AnswerValue + U +
        TAnswer(MHA_Report_OPS.ListOfAnswersForReport[ii]).AnswerID +
        RECORD_END;

    if Assigned(GroomAnswersDLL) then
      GroomAnswersDLL(
        TAResult(Result_OPS.ListOfResults[gvCurrentResult]).InstrumentName,
        Patient.Name,
        Patient.DOB,
        Patient.Sex,
        AnswerString,
        ResultString);

    if (ResultString = '') or
      (ResultString = AnswerString) then
      begin
        ResultString := '';
        Exit;
      end
    else
      begin
          // Place new answer values in current list of answer values.
        AnswerString := '';
        for ii := 0 to MHA_Report_OPS.ListOfAnswersForReport.Count - 1 do
          begin
            TempStr := Piece(ResultString, RECORD_END, i);
            TAnswer(MHA_Report_OPS.ListOfAnswersForReport[ii]).AnswerValue :=
              Piece(Piece(TempStr, EQ, 2), U, 1);
            TAnswer(MHA_Report_OPS.ListOfAnswersForReport[ii]).AnswerText :=
              Piece(Piece(TempStr, EQ, 2), U, 2);

            AnswerString := AnswerString +
              TAnswer(MHA_Report_OPS.ListOfAnswersForReport[ii]).QuestionID + EQ +
              GetItemIndex(TAnswer(MHA_Report_OPS.ListOfAnswersForReport[ii]).QuestionID,
              TAnswer(MHA_Report_OPS.ListOfAnswersForReport[ii]).AnswerValue) + U +
              TAnswer(MHA_Report_OPS.ListOfAnswersForReport[ii]).AnswerValue + U +
              TAnswer(MHA_Report_OPS.ListOfAnswersForReport[ii]).AnswerID + RECORD_END;
          end;
      end; // else
  end;

begin
  with MemReport do
    begin
      Hide;
      Clear;
      Font.Name := 'Courier New';
      Font.Size := gvFont.Size;
      Font.Color := gvFont.color;
      Font.Style := gvFont.style;

    end;

  if CanDisplay <> COMPLETE then
    begin
      MemReport.Text := ' Incomplete instruments do not have reports.';
      memReport.Show;
      exit;
    end;

  AnswerString := '';
  ResultString := '';

//--- Legacy tests, entered with MHA2 ----
// These results do not have AdministrationIENS.
  if grdAdministrations.Cells[4, grdAdministrations.Row] = '' then
    begin

      if grdAdministrations.Cells[6, aRow] = '' then
        begin
          Screen.Cursor := crDefault;
          MsgDlgFrm('The results of this legacy instrument cannot be accessed. ' + #13 +
            'The testIEN is missing.  ',
            MHA_CAPTION, mtInformation, [mbOK], 0);
          tsGraphs.TabVisible := false;
        end;

       // The order of the instruments can be changed by user: synch with ListOfResults
      for i := 0 to Result_OPS.ListOfResults.Count - 1 do
        begin
          TempDate := StrToDateTime(TAResult(Result_OPS.ListOfResults[i]).DateGiven);

          if (TAResult(Result_OPS.ListOfResults[i]).AdministrationIENS = '') and
            (grdAdministrations.Cells[6, aRow] =
            IntToStr(TAResult(Result_OPS.ListOfResults[i]).TestIENS)) and
            (FormatDateTime('mm/dd/yyyy', TempDate) =
            grdAdministrations.Cells[0, aRow]) then
            begin
              gvCurrentResult := i;
              break;
            end;
        end;

//--- Legacy tests, entered with MHA2 ----
    end
  else
//--- MHA3 entered instruments, legacy and non-legacy
    begin

     // The order of the instruments can be changed by user: synch with ListOfResults
      for i := 0 to Result_OPS.ListOfResults.Count - 1 do
        if grdAdministrations.Cells[4, aRow] =
          TAResult(Result_OPS.ListOfResults[i]).AdministrationIENS then
          begin
            gvCurrentResult := i;
            break;
          end;
    end;
(*
  // The order of the instruments can be changed by user: synch with ListOfResults
  for i := 0 to Result_OPS.ListOfResults.Count - 1 do
    if aIEN =
      TAResult(Result_OPS.ListOfResults[i]).AdministrationIENS then
      begin
        gvCurrentResult := i;
        break;
      end; *)

  with TAResult(Result_OPS.ListOfResults[gvCurrentResult]) do
    begin
      // This will find out if the instrument has any scales:
      // Don't show graph Tab if without scales.

      ListOfScores := Result_OPS.LoadScores(
        AnswersAreInLegacyFile, AdministrationIENS,
        InstrumentName, Patient.DFN, DateSaved);

      if NumberOfPieces(ListOfScores, EQ) = 0 then
        begin
          Kind := irNoScales;
          lvInstrumentHasScales := false;
        end
      else
        lvInstrumentHasScales := true;

      tsGraphs.TabVisible := lvInstrumentHasScales;
      mnuGraphTable.Enabled := lvInstrumentHasScales;
      mnuShowGraphLabels.Enabled := lvInstrumentHasScales;
      mnuCopyTable.Enabled := lvInstrumentHasScales;
      mnuCopyGraph.Enabled := lvInstrumentHasScales;
      mnuPrintTable.Enabled := lvInstrumentHasScales;
      mnuPrintGraph.Enabled := lvInstrumentHasScales;


      if not UserHasPermissionToView then
        begin
          memReport.Text := '  This is a restricted report.';
          memReport.MaxLength := Length(memReport.Text);
          memReport.Show;
          Exit;
        end;

      if AdministrationIENS <> '' then
        begin
          if not MHA_Report_OPS.BuildAllReportLists(InstrumentName,
            AdministrationIENS) then
            Exit;
        end;

    	  // patch 105 added gvAuxFile which = proper C:\Program Files dir for the YS_MHA_AUX file llh
        dllHandle := LoadLibrary(PChar(gvAuxFile));

        if dllHandle = 0 then
          begin
            // patch 105 added gvAuxFile, removed C:\Program Files llh
            MsgDlgFrm('Could not find DLL used for displaying instruments.' +
              'The file YS_MHA_AUX.DLL is usually located in ' + gvAuxFile , MHA_CAPTION,
              mtWarning, [mbOk], 0)
          end
      else
        begin
          try
            @GroomAnswersDLL := GetProcAddress(dllHandle, 'GroomAnswers');

            if @GroomAnswersDLL = nil then
             // function not found, continue below
            else
              HandleGroomedAnswers;
          finally
            FreeLibrary(dllHandle);
          end; {try..finally}
        end; // if dllHandle

      // patch 105 added gvAuxFile which = proper C:\Program Files dir for the YS_MHA_AUX file llh
      dllHandle := LoadLibrary(PChar(gvAuxFile));

      // Check for hard coded scoring to add to report
      if dllHandle = 0 then
      else
        begin
          try
            @ProgressNoteDLL := GetProcAddress(dllHandle, 'ProgressNote');

            if @ProgressNoteDLL = nil then
            else
            if gvUseScreenReader then
                      InstName := InstrumentName + '-SR'
                    else
                      InstName := InstrumentName;

              if Assigned(ProgressNoteDLL) then
                ProgressNoteDLL(InstName,
                  Patient.Name,
                  Patient.DOB,
                  Patient.Sex,
                  AnswerString,
                  ResultString);
          finally
            FreeLibrary(dllHandle);
          end; {try..finally}
        end;

      ReportStrList := TStringList.Create;

      if MHA_Report_OPS.LoadReport(
        InstrumentName,
        AdministrationIENS,
        AdminBy,
        OrderedBy,
        Location, // uses LocationIEN
        DateGiven,
        DateSaved,
        TestIENS,
        False, // ForceWrap -- Used for progress notes
        Kind = irLegacy,
        WriteFullText,
        ResultString, // from YS_MHA_AUX.dll if used
        ReportStrList) = 'ERROR' then
        begin
          MsgDlgFrm('An error has occured while generating this report.',
            MHA_CAPTION, mtError, [mbOK], 0);
          ReportStrList.Free;
          Exit;
        end;

      with memReport do
        begin
          Clear;
          Lines.AddStrings(ReportStrList);

          // remove excessive blank lines
          Text := StringReplace(Text, #13#10#13#10#13#10, #13,
            [rfReplaceAll, rfIgnoreCase]);
          Text := StringReplace(Text, #13#13#13, #13,
            [rfReplaceAll, rfIgnoreCase]);
          Text := StringReplace(Text, #13#13#13, #13,
            [rfReplaceAll, rfIgnoreCase]);
          MaxLength := Length(Text);
          Show;

          SetFocus;
        end; // with MemReport

      ReportStrList.Free;
    end;
end;

procedure TfrmMHA_SingleInstrumentMenu.InitGrdScores;
// Screen readers will have a different table configuration.
var
  arow, i, j                  : integer;

const
  lcIndent                    = '   ';

begin

  with grdScores do
    begin
      Clear;
      Font.Assign(gvFont);

      DefaultRowHeight := 3 * (GUI_Control.TextHeight('Yy', gvFont))
        div 2;
      grpScores.Caption := ' Scores ';

      SelectionRectangle := False;
      ShowSelection := True;
      Options := [goFixedVertLine, goFixedHorzLine, goVertLine, goHorzLine,
        goDrawFocusSelected, goRowSelect]; //goColSizing,
      FixedFont.Assign(gvFont);
      FixedRowAlways := True;
      FixedColAlways := True;
      FixedRows := 1;
      FixedCols := 1;
      FixedRowHeight := DefaultRowHeight;
      FixedColWidth := lvDateColWidth;
      SelectionColor := clHighlight;
      SelectionTextColor := clHighlightText;
      ShowHint := True;
      // This number is too large, it will be lowered later when the actual
      // number of dates are known.
      ColCount := Result_OPS.ListOfResults.Count;
      ColWidths[0] := (5 * lvDateColWidth) div 2;

      RowCount := Result_OPS.ListOfScales.Count + Result_OPS.ListOfScaleGroups.Count;
      SelectionColor := clWindow;
      SelectionTextColor := clWindowText;
      arow := 1;

      if Result_OPS.ListOfScaleGroups.Count > 1 then
        begin
          FontStyles[0, 1] := [fsBold];
          for i := 0 to Result_OPS.ListOfScaleGroups.Count - 1 do
            begin
              Cells[0, arow] := TScaleGroup(Result_OPS.ListOfScaleGroups[i]).GroupName;
              inc(arow);
              for j := 0 to Result_OPS.ListOfScales.Count - 1 do
                begin
                  if (TScale(Result_OPS.ListOfScales[j]).GroupIEN =
                    TScaleGroup(Result_OPS.ListOfScaleGroups[i]).IEN) then
                    begin
                      Cells[0, arow] := lcIndent + TScale(Result_OPS.ListOfScales[j]).ScaleName;
                      inc(arow);
                    end;
                end;
            end;
        end
      else
        begin
          FontStyles[0, 1] := [fsBold];
          Cells[0, arow] := TScaleGroup(Result_OPS.ListOfScaleGroups[0]).GroupName;
          inc(arow);
          for j := 0 to Result_OPS.ListOfScales.Count - 1 do
            begin
              Cells[0, arow] := ' ' + TScale(Result_OPS.ListOfScales[j]).ScaleName;
              inc(arow);
            end;
        end;
      RowCount := arow;

      ColumnSize.Stretch := False;
    end; //with grdScores

end;


procedure TfrmMHA_SingleInstrumentMenu.DisplayGrid;
// Alternative for screen readers.
var
  i, j, arow                  : integer;
  TempStr,
    TempStr1                  : string;
begin

  with grdScores do
    begin
      Clear;
      Font.Assign(gvFont);

      SelectionRectangle := True;
      ShowSelection := True;
      Options := [goHorzLine, goDrawFocusSelected, goColSizing, goRowSelect];
      FixedRowAlways := False;
      FixedColAlways := False;
      FixedRows := 0;
      FixedCols := 0;
      ShowHint := False;
      ColCount := 2;
      ColWidths[0] := lvDateColWidth;

      // The order of the instruments can be changed by user: synch with ListOfResults
      for i := 0 to Result_OPS.ListOfResults.Count - 1 do
        if grdAdministrations.Cells[2, grdAdministrations.Row] =
          TAResult(Result_OPS.ListOfResults[i]).AdministrationIENS then
          begin
            gvCurrentResult := i;
            break;
          end;

      arow := 0;
      for i := 0 to Result_OPS.ListOfResults.Count - 1 do
        begin
          if TAResult(Result_OPS.ListOfResults[gvCurrentResult]).InstrumentName =
            TAResult(Result_OPS.ListOfResults[i]).InstrumentName then
            begin
              TAResult(Result_OPS.ListOfResults[i]).ListOfScores := Result_OPS.LoadScores(
                TAResult(Result_OPS.ListOfResults[i]).AnswersAreInLegacyFile,
                TAResult(Result_OPS.ListOfResults[i]).AdministrationIENS,
                TAResult(Result_OPS.ListOfResults[i]).InstrumentName,
                Patient.DFN,
                TAResult(Result_OPS.ListOfResults[i]).DateSaved);

              for j := 1 to NumberOfPieces(TAResult(Result_OPS.ListOfResults[i]).ListOfScores,
                Record_End) do
                begin

                  TempStr := Piece(TAResult(Result_OPS.ListOfResults[i]).ListOfScores, Record_End, j);
                  TempStr1 := Piece(TempStr, EQ, 2);

                  if NumberOfPieces(TempStr1, U) > 0 then
                    TempStr1 := Piece(TempStr1, U, 2);
                  if TempStr1 = '' then
                    TempStr1 := Piece(Piece(TempStr, EQ, 2), U, 1);
                  grdScores.Cells[0, arow] := TAResult(Result_OPS.ListOfResults[i]).DateSaved;
                  grdScores.Cells[1, arow] := Piece(TempStr, EQ, 1) + ' ' +
                    TempStr1;
                  Inc(arow);
                end; // for j

            end; // This instrument
        end; // for i

      RowCount := arow;
      ColumnSize.Stretch := True;
    end; //with grdScores
end;

procedure TfrmMHA_SingleInstrumentMenu.DisplayScores;
var
  TempStr                     : string;
  i                           : integer;
begin

  if gvUseScreenReader then
    begin
      DisplayGrid;
      ActiveControl := grpScores;
      Exit;
    end;

  if Result_OPS.LoadScaleGroupsAndScales(TAResult(Result_OPS.ListOfResults[gvCurrentResult]).InstrumentName) = BAD_DATA then //uMHA_Scales_IO
    begin
      ShowMessage('Unable to read scales.');
      Exit;
    end;

  InitGrdScores;

  TempStr := GetScores; //uMHA_InstrumentResults_IO

  // Returns "OK" with proper functioning
  if Pos(BAD_DATA, TempStr) > 0 then
    begin
      ShowMessage('Unable to read scores: ' + #13 + TempStr);
    end;

  TAResult(Result_OPS.ListOfResults[gvCurrentResult]).IsMultiScale :=
    Result_OPS.ListOfScales.Count > 1;

  InitChart(0);

  if TAResult(Result_OPS.ListOfResults[gvCurrentResult]).IsMultiScale then
    begin
      grdScores.ShowHint := true;
      for i := 1 to grdScores.ColCount do
        grdScores.FontStyles[i, 0] := [fsBold];
      // Show Clinical scales for MMPI2, first scale group otherwise
      if TAResult(Result_OPS.ListOfResults[gvCurrentResult]).InstrumentName = 'MMPI2' then
        begin
          for i := 1 to grdScores.RowCount do
            grdScores.FontStyles[0, i] := [];
          grdScores.FontStyles[0, 16] := [fsBold];
          grdScores.SelectRows(16, 1);
        end
      else
        begin
          grdScores.FontStyles[0, 1] := [fsBold];
          grdScores.Row := 1;
        end;

      GraphScores(True, 'ByDate');

    end
  else
    begin
      grdScores.ShowHint := false;
      grdScores.Row := 2;
      GraphScores(False, {title} grdscores.cells[0, 2]);
    end;
  (*
  if gvUseScreenReader then
    begin
      DisplayGrid;
      ActiveControl := grpScores;
      Exit;
    end;

  if Result_OPS.LoadScaleGroupsAndScales(lvInstrument.InstrumentName) = BAD_DATA then
    begin
      ShowMessage('Unable to read scales.');
      Exit;
    end;

  InitGrdScores;

  TempStr := GetScores; //uMHA_InstrumentResults_IO
  if Pos(BAD_DATA, TempStr) > 0 then
    begin
      ShowMessage('Unable to read scores: ' + #13 + TempStr);
    end;

  TAResult(Result_OPS.ListOfResults[gvCurrentResult]).IsMultiScale :=
    Result_OPS.ListOfScales.Count > 1;

  InitChart(0);

  if TAResult(Result_OPS.ListOfResults[gvCurrentResult]).IsMultiScale then
    GraphScores(False, grdscores.cells[0, 2])
  else
    GraphScores(False, grdscores.cells[0, 1]);
   *)
end;


procedure TfrmMHA_SingleInstrumentMenu.InitChart(grp: Integer);
var
  i                           : integer;
begin

  //clear the chart
  with chrtScores do
    begin
      Legend.Visible := False;
      Legend.FirstValue := 0;
      with LeftAxis do
        begin
          AutomaticMaximum := False;
          Minimum := -1;
          Maximum := 1;

          for i := 0 to 12 do
            begin
              SeriesList.Series[i].Clear;
              SeriesList.Series[i].Active := False;
            end;

          if Result_OPS.ListOfScaleGroups.Count = 0 then
            Exit;

          Maximum := TScaleGroup(Result_OPS.ListOfScaleGroups[grp]).OrdinateMax;
          if Maximum = -1 then
            AutomaticMaximum := True;
          if TScaleGroup(Result_OPS.ListOfScaleGroups[grp]).OrdinateMin <= Maximum then
            Minimum := TScaleGroup(Result_OPS.ListOfScaleGroups[grp]).OrdinateMin;
          Title.Caption := TScaleGroup(Result_OPS.ListOfScaleGroups[grp]).OrdinateTitle;
          if TScaleGroup(Result_OPS.ListOfScaleGroups[grp]).OrdinateIncrement = -1 then
            increment := 1
          else
            Increment := TScaleGroup(Result_OPS.ListOfScaleGroups[grp]).OrdinateIncrement;
        end; //with LeftAxis

    end; //with chrtTestGraph
end;

function TfrmMHA_SingleInstrumentMenu.GetXLabel(aScaleName: string): string;
var
  i                           : Integer;
begin
  Result := '';

  for i := 0 to Result_OPS.ListOfScales.Count - 1 do

    if TScale(Result_OPS.ListOfScales[i]).ScaleName = aScaleName then
      begin
        result := TScale(Result_OPS.ListOfScales[i]).xLabel;
        if result = '' then
          result := Copy(aScaleName, 1, 3);
        break;
      end;
end;

function TfrmMHA_SingleInstrumentMenu.DetermineGroup(const aTitle: string): Integer;
var
  i, j                        : Integer;
  TempTitle,
    TempIEN                   : string;
begin
  result := -1;

  if not TAResult(Result_OPS.ListOfResults[gvCurrentResult]).IsMultiScale then
    begin
      result := 0;
      Exit;
    end;

  TempTitle := Trim(aTitle);
  for i := 0 to Result_OPS.ListOfScaleGroups.Count - 1 do
    if TempTitle = TScaleGroup(Result_OPS.ListOfScaleGroups[i]).GroupName then
      begin
        result := i;
        Exit;
      end;

  for i := 0 to Result_OPS.ListOfScales.Count - 1 do
    if CompareStr(TempTitle, TScale(Result_OPS.ListOfScales[i]).ScaleName) = 0 then
      begin
        TempIEN := TScale(Result_OPS.ListOfScales[i]).GroupIEN;
        for j := 0 to Result_OPS.ListOfScaleGroups.Count - 1 do
          if TempIEN = TScaleGroup(Result_OPS.ListOfScaleGroups[j]).IEN then
            begin
              result := j;
              Exit;
            end;
      end;
end;


procedure TfrmMHA_SingleInstrumentMenu.GraphScores(IsMultiScale: Boolean;
  aTitle: string);
begin

  if gvUseScreenReader then
    Exit;

  if IsMultiScale then
    GraphSeveralScales(aTitle)
  else
    GraphSingleScale(aTitle);

end;


(*procedure TfrmMHA_SingleInstrumentMenu.GraphSeveralScales(aTitle: string);
var
  grp, i, StartHere, c,
    iseries, ordinate         : integer;
  MyColor                     : TColor;
  TempStr, TempStr1,
    xlabel, CellValue         : string;

begin

  StartHere := 0;

  with chrtScores do
    begin
      if aTitle = 'ByDate' then
        begin

          //if grdScores.ColCount < 2 then
          //  Exit;
          // Get first group-scale info
          TempStr := '';
          for i := 1 to grdScores.RowCount do
            begin
              if grdScores.FontStyles[0, i] = [fsBold] then
                begin
                  TempStr := grdScores.Cells[0, i];

                  if TempStr[1] <> ' ' then
                    begin
                      Title.Text.Text := TempStr;
                      grdScores.FontStyles[0, i] := [fsBold];
                      StartHere := i;
                      Break;
                    end;
                end;
            end; // for i

          if TempStr <> '' then
            begin
              grp := DetermineGroup(TempStr);
              if grp = -1 then
                begin
                  ShowMessage('Unable to determine the Scale-Group.');
                  Exit;
                end;

              iseries := 3; // Grid lines are 0,1,2
              InitChart(grp);
              Legend.Visible := True;

              for c := 1 to grdScores.ColCount do
                begin
                  if grdScores.FontStyles[c, 0] = [fsBold] then
                    begin
                      SeriesList.Series[iseries].Active := True;
                      MyColor := SeriesList.Series[iseries].SeriesColor;
                      // Date
                      SeriesList.Series[iseries].Title :=
                        grdScores.Cells[c {Col}, 0 {Row}];

                      for i := StartHere + 1 to grdScores.RowCount do
                        begin
                          TempStr1 := grdScores.Cells[0, i];
                          if Length(Tempstr1) > 1 then
                            if TempStr1[1] = ' ' then
                              begin
                                CellValue := Trim(grdScores.Cells[c, i]);

                              //be sure the cell contains an integer
                                if (StrToInt64Def(CellValue, -1) > -1) then
                                  begin
                                    ordinate := StrToInt(CellValue);
                                  // Scale name to XLabel
                                    xlabel := GetXLabel(Trim(TempStr1));

                                    SeriesList.Series[iseries].AddXy(i, ordinate,
                                      xLabel, MyColor);
                                  end; //if cell contains an integer
                              end // If a scale
                            else
                              break;
                        end; // for i
                    end; // bold

                  Inc(iseries);
                  if iseries > 13 then
                    Exit;
                end; // for c
            end; //  TempStr not blank
        end; // ByDate

    end; // with ChartScores
end;

procedure TfrmMHA_SingleInstrumentMenu.GraphSingleScale(aTitle: string);
var
  i, grp                      : Integer;

  procedure DrawGridLines;
  var
    GridOrdinate              : array[0..2] of integer;
    ii, jj                    : integer;
  begin

    GridOrdinate[0] := TScaleGroup(Result_OPS.ListOfScaleGroups[grp]).Grid1Ordinate;
    GridOrdinate[1] := TScaleGroup(Result_OPS.ListOfScaleGroups[grp]).Grid2Ordinate;
    GridOrdinate[2] := TScaleGroup(Result_OPS.ListOfScaleGroups[grp]).Grid3Ordinate;

    for ii := 0 to 2 do
      begin
        if (GridOrdinate[ii] > -1) then
          begin
            chrtScores.SeriesList.Series[ii].Active := true;

            for jj := 1 to grdScores.ColCount - 1 do
              chrtScores.SeriesList.Series[ii].AddXY(
                StrToDateTime(grdScores.Cells[jj, 0]),
                GridOrdinate[ii],
                grdScores.Cells[jj, 0],
                clBlack);
          end
        else
          chrtScores.SeriesList.Series[ii].Active := False;
      end;
  end;

begin
  grp := DetermineGroup(aTitle);

  if grp = -1 then
    begin
      ShowMessage('Unable to determine the Scale-Group.');
      Exit;
    end;

  InitChart(grp);

  with chrtScores do
    begin
      Legend.Visible := False;
      Title.Text.Text := aTitle;
      SeriesList.Series[3].Active := True;

      for i := 1 to grdScores.ColCount - 1 do
        begin
          SeriesList.Series[3].AddXY(StrToDateTime(grdScores.Cells[i, 0]),
            StrToInt64Def(grdScores.Cells[i, grdScores.row], 0),
            grdScores.Cells[i, 0], clred);
        end;
    end; //with chrtScores
  DrawGridLines;
end;*)

procedure TfrmMHA_SingleInstrumentMenu.GraphSeveralScales(aTitle: string);
var
  grp, i, StartHere, c,
  //  icol, irow,
  iseries, ordinate           : integer;
  MyColor                     : TColor;
  TempStr, TempStr1,
    xlabel, CellValue         : string;

(*  procedure DrawGridLines(XValue: integer; XLabel: string);
  var
    DrawGrid                  : BOOLEAN;
    GridOrdinate              : array[0..2] of integer;
    ii                        : integer;
  begin

    GridOrdinate[0] := TScaleGroup(Result_OPS.ListOfScaleGroups[grp]).Grid1Ordinate;
    GridOrdinate[1] := TScaleGroup(Result_OPS.ListOfScaleGroups[grp]).Grid2Ordinate;
    GridOrdinate[2] := TScaleGroup(Result_OPS.ListOfScaleGroups[grp]).Grid3Ordinate;

    for ii := 0 to 2 do
      begin
        DrawGrid := (GridOrdinate[ii] > -1);
        chrtScores.SeriesList.Series[ii].Active := DrawGrid;

        if DrawGrid then
          chrtScores.SeriesList.Series[ii].AddXY(XValue, GridOrdinate[ii],
            Xlabel, clBlack);
      end;
  end;*)


begin
  StartHere := 0;

  with chrtScores do
    begin
      if aTitle = 'ByDate' then
        begin
          if grdScores.ColCount < 2 then
            Exit;

          // Get first group-scale info
          TempStr := '';
          for i := 1 to grdScores.RowCount do
            begin
              if grdScores.FontStyles[0, i] = [fsBold] then
                begin
                  TempStr := grdScores.Cells[0, i];

                  if TempStr[1] <> ' ' then
                    begin
                      Title.Text.Text := TempStr;
                      //grdScores.FontStyles[0, i] := [fsBold];
                      StartHere := i;
                      Break;
                    end;
                end;
            end; // for i

          if TempStr <> '' then
            begin
              grp := DetermineGroup(TempStr);
              if grp = -1 then
                begin
                  ShowMessage('Unable to determine the Scale-Group.');
                  Exit;
                end;

              iseries := 3; // Grid lines are 0,1,2
              InitChart(grp);
              Legend.Visible := True;

              for c := 1 to grdScores.ColCount - 1 do
                begin
                  if grdScores.FontStyles[c, 0] = [fsBold] then
                    begin
                      SeriesList.Series[iseries].Active := True;
                      MyColor := SeriesList.Series[iseries].SeriesColor;
                      // Date
                      SeriesList.Series[iseries].Title :=
                        grdScores.Cells[c {Col}, 0 {Row}];

                      for i := StartHere + 1 to grdScores.RowCount do
                        begin
                          TempStr1 := grdScores.Cells[0, i];
                          if Length(Tempstr1) > 1 then
                            if TempStr1[1] = ' ' then
                              begin
                                CellValue := Trim(grdScores.Cells[c, i]);

                              //be sure the cell contains an integer
                                if (StrToInt64Def(CellValue, -1) > -1) then
                                  begin
                                    ordinate := StrToInt(CellValue);
                                  // Scale name to XLabel
                                    xlabel := GetXLabel(Trim(TempStr1));

                                    SeriesList.Series[iseries].AddXy(i, ordinate,
                                      xLabel, MyColor);
                                  end; //if cell contains an integer
                              end // If a scale
                            else
                              break;
                        end; // for i
                    end; // bold

                  Inc(iseries);
                  if iseries > 13 then
                    Exit;
                end; // for c
            end; //  TempStr not blank
        end // ByDate
      else
        // Group Scale Name
        begin


        end;

    end; // with ChartScores

end;

procedure TfrmMHA_SingleInstrumentMenu.GraphSingleScale(aTitle: string);
var
  i, grp                      : Integer;

  procedure DrawGridLines;
  var
    GridOrdinate              : array[0..2] of integer;
    ii, jj                    : integer;
  begin

    GridOrdinate[0] := TScaleGroup(Result_OPS.ListOfScaleGroups[grp]).Grid1Ordinate;
    GridOrdinate[1] := TScaleGroup(Result_OPS.ListOfScaleGroups[grp]).Grid2Ordinate;
    GridOrdinate[2] := TScaleGroup(Result_OPS.ListOfScaleGroups[grp]).Grid3Ordinate;

    for ii := 0 to 2 do
      begin
        if (GridOrdinate[ii] > -1) then
          begin
            chrtScores.SeriesList.Series[ii].Active := true;

            for jj := 1 to grdScores.ColCount - 1 do
              chrtScores.SeriesList.Series[ii].AddXY(
                StrToDateTime(grdScores.Cells[jj, 0]),
                GridOrdinate[ii],
                grdScores.Cells[jj, 0],
                clBlack);
          end
        else
          chrtScores.SeriesList.Series[ii].Active := False;
      end;
  end;

begin
  grp := DetermineGroup(aTitle);

  if grp = -1 then
    begin
      ShowMessage('Unable to determine the Scale-Group.');
      Exit;
    end;

  InitChart(grp);

  with chrtScores do
    begin
      Legend.Visible := False;
      Title.Text.Text := aTitle;
      SeriesList.Series[3].Active := True;

      for i := 1 to grdScores.ColCount - 1 do
        begin
          grdScores.FontStyles[i, 0] := [];
          SeriesList.Series[3].AddXY(StrToDateTime(grdScores.Cells[i, 0]),
            StrToInt64Def(grdScores.Cells[i, grdScores.row], 0),
            grdScores.Cells[i, 0], clred);
        end;
    end; //with chrtScores

  DrawGridLines;
end;

procedure TfrmMHA_SingleInstrumentMenu.PageControl1Change(Sender: TObject);
begin
  case PageControl1.ActivePageIndex of
    0:
      begin
        if gvUseScreenReader then
          ActiveControl := grpAdministrations;
      end;
    1:
      begin
        mnuAppendComments.Enabled := false;
        if lvIsFirstViewOfGraph then
          begin
            Application.ProcessMessages;
            DisplayScores;
            lvIsFirstViewOfGraph := False;
          end;

        if gvUseScreenReader then
          ActiveControl := grpScores;
      end;
  end; // case

  mnuReport.Enabled := (PageControl1.ActivePageIndex = 1);
  mnuGraphTable.Enabled := (PageControl1.ActivePageIndex = 0);

end;

procedure TfrmMHA_SingleInstrumentMenu.mnuReportClick(Sender: TObject);
begin
  //NB: Contrary to expectation, resetting the ActivePageIndex changes
  //the tab that is seen but does not invoke the PageControlChange event,
  //so it has to be called separately.  Go figure!
  PageControl1.ActivePageIndex := 0;
  PageControl1Change(Self);
end;

procedure TfrmMHA_SingleInstrumentMenu.PageControl1Changing(Sender: TObject;
  var AllowChange: Boolean);
begin

  if (PageControl1.ActivePageIndex = 0) then
    AllowChange := TAResult(Result_OPS.ListOfResults[gvCurrentResult]).UserHasPermissionToView;
  lvOldPageIndex := PageControl1.ActivePageIndex;
end;

procedure TfrmMHA_SingleInstrumentMenu.mnuOnlineSupportClick(Sender: TObject);
begin
  VisitURL(MHA_ONLINE_SUPPORT_URL);
end;


procedure TfrmMHA_SingleInstrumentMenu.grdScoresClickCell(Sender: TObject;
  ARow, ACol: Integer);
var
  i                           : Integer;
  TempStr                     : string;
begin
// Click changes only the multi-scale graphs
  if not TAResult(Result_OPS.ListOfResults[gvCurrentResult]).IsMultiScale then
    exit;

  grdScores.SelectionColor := clHighlight;
  grdScores.SelectionTextColor := clHighlightText;

  if (ARow = 0) then // Date selected
    begin
      if grdScores.FontStyles[aCol, 0] = [fsBold] then
        grdScores.FontStyles[aCol, 0] := []
      else
        begin
          grdScores.FontStyles[aCol, 0] := [fsBold];
          grdScores.SelectCols(aCol, 1);
        end;
      GraphScores(true, 'ByDate');
    end
  else // Scale or Scale-Group selected
    begin
      for i := 0 to grdScores.ColCount - 1 do
        grdScores.FontStyles[i, 0] := [];
      grdScores.row := ARow;

      TempStr := grdScores.Cells[0, grdScores.row];
      if TempStr <> '' then
        if TempStr[1] = ' ' then // scale name
          GraphScores(false, TempStr)
        else
          begin
            for i := 0 to grdScores.RowCount - 1 do
              grdScores.FontStyles[0, i] := [];
            grdScores.FontStyles[0, aRow] := [fsBold];
            GraphScores(true, TempStr);
          end;
    end;
end;


procedure TfrmMHA_SingleInstrumentMenu.mnuOptionsClick(Sender: TObject);
begin
  if gvUseScreenReader then
    begin
      try
        frmMHA_Options_508 := TfrmMHA_Options_508.Create(nil);
      finally
        frmMHA_Options_508.Free;
      end;

    end
  else
    begin
      gvShowOptionTabs := '0'; // Show tab 0 on options form, Fonts
      GUI_Control.NeedGUIUpdate := False;

      try
        frmMHA_Options := TfrmMHA_Options.Create(nil);
    //frmMHA_Options.ShowModal;
      finally
        frmMHA_Options.Free;
      end;

      if GUI_Control.NeedGUIUpdate then
        begin
          ConfigureForm;
          UpdateAllDisplays;
          PageControl1.Font.Assign(gvFont);
          GUI_Control.NeedGUIUpdate := False;
        end;
    end;
end;

procedure TfrmMHA_SingleInstrumentMenu.FormKeyDown(Sender: TObject; var Key:
  Word;
  Shift: TShiftState);
begin
  if (Shift = [ssALT]) and (Key = vk_F4) then
    Close;

//  if ActiveControl = grdAdministrations then
//    if Key = vk_Return then
//      grdAdministrationsClickCell(Sender, grdAdministrations.Row, 0);

  if ActiveControl = grdScores then
    if Key = vk_Escape then
      begin
        PageControl1.ActivePageIndex := 0;
        PageControl1Change(Self);
      end;

end;

function TfrmMHA_SingleInstrumentMenu.EnterDataForDeadPatient(ACaption:
  string): Boolean;
var
  tmpCaption                  : string;
begin

  Result := True;
  if Patient.IsDead then
    begin
      tmpCaption := ACaption;
      Result := (MsgDlgFrm(Patient.Name + ' died on ' + Patient.DOD +
        '.  Are you sure '
        + 'you want to ' + tmpCaption + ' for this patient?', MHA_Caption,
        mtConfirmation, [mbYes, mbNo], 0) = mrYes);
    end;

end;

procedure TfrmMHA_SingleInstrumentMenu.btnNewClick(Sender: TObject);

begin
  if not EnterDataForDeadPatient('enter a new ' + lvInstrument.InstrumentName) then
    Exit;

  Administration_OPS.Administrations.Clear;
  lvAdministration := TAdministration.Create;

  PrepareNewAdministration;
  ShowAdmin;

end;

procedure TfrmMHA_SingleInstrumentMenu.btnEditClick(Sender: TObject);
begin
  if not EnterDataForDeadPatient('edit ' + lvInstrument.InstrumentName) then
    Exit;

  Administration_OPS.Administrations.Clear;
  lvAdministration := TAdministration.Create;

  lvAdministration.ID := grdAdministrations.Cells[4, grdAdministrations.Row];
  gvID := lvAdministration.ID; // Used in fMHA_Admin
  lvAdministration.InstrumentName := gvNameOfInstrument;
  lvAdministration.PatientID := Patient.DFN;
  gvDateGiven := StrToDateTime(grdAdministrations.Cells[0, grdAdministrations.row]);
  lvAdministration.DateGiven := gvDateGiven;
  lvAdministration.OrdererDUZ := ThisUser.DUZ;
  lvAdministration.AdministeredBy := ThisUser.DUZ;
  lvAdministration.DaysToRestart := lvInstrument.DaysToRestart;

  ShowAdmin;
end;

procedure TfrmMHA_SingleInstrumentMenu.ShowAdmin;
begin
  Hide;

  try
    frmMHA_Admin := TfrmMHA_Admin.Create(nil);
    frmMHA_Admin.ShowModal;

    lvCancelled := frmMHA_Admin.Cancelled;
    lvIsStaffEntry := frmMHA_Admin.IsStaffEntry;
    lvIsAllItems := frmMHA_Admin.IsAllItems;

    if gvID = NO_ID then
      begin
        lvAdministration.OrdererDUZ :=
          frmMHA_Admin.OrderedByDUZ;
        lvAdministration.AdministeredBy := frmMHA_Admin.InterviwerDUZ;
        lvAdministration.DateGiven := StrToDateTime(frmMHA_Admin.DateGiven);
        lvAdministration.LocationStr := frmMHA_Admin.LocationName;
        lvAdministration.LocationIEN := frmMHA_Admin.LocationIEN;
      end;

  finally
    frmMHA_Admin.Free;
  end;

  if not lvCancelled then
    begin
      Administration_OPS.Administrations.Add(lvAdministration);

      if lvIsStaffEntry then
        StaffEntry
      else
        PatientEntry;
    end;

  Show;

  UpdateAllDisplays; // This will refresh the grid of results
  if gvUseScreenReader then
    ActiveControl := grpAdministrations
  else
    ActiveControl := grdAdministrations;
end;

procedure TfrmMHA_SingleInstrumentMenu.mnuOtherInstrumentsClick(
  Sender: TObject);
begin
  gvID := 'Return';
  Close;
end;

procedure TfrmMHA_SingleInstrumentMenu.mnuMetricClick(Sender: TObject);
begin
  VisitURL(MetricURL);
end;

procedure TfrmMHA_SingleInstrumentMenu.mnuAppendCommentsClick(
  Sender: TObject);
begin
  frmMHA_AppendComments := TfrmMHA_AppendComments.Create(nil);
  try
    frmMHA_AppendComments.DisplayOldComments(
      TAResult(Result_OPS.ListOfResults[gvCurrentResult]).InstrumentName + '   ' +
      TAResult(Result_OPS.ListOfResults[gvCurrentResult]).DateGiven,
      TAResult(Result_OPS.ListOfResults[gvCurrentResult]).AdministrationIENS);
    frmMHA_AppendComments.ShowModal;
  finally
    frmMHA_AppendComments.Free;
  end;

  DisplayReport(TAResult(Result_OPS.ListOfResults[gvCurrentResult]).AdministrationIENS,
    COMPLETE, grdAdministrations.Row);

end;

procedure TfrmMHA_SingleInstrumentMenu.mnuExitClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmMHA_SingleInstrumentMenu.mnuAboutClick(Sender: TObject);
begin
  frmMHA_About := TfrmMHA_About.Create(nil);
  try
    frmMHA_About.ShowModal;
  finally
    frmMHA_About.Free;
  end; //try
end;

procedure TfrmMHA_SingleInstrumentMenu.mnuGraphTableClick(
  Sender: TObject);
begin
  PageControl1.SelectNextPage(True);
end;

procedure TfrmMHA_SingleInstrumentMenu.mnuCopyReportClick(Sender: TObject);
begin
  with memReport do
    begin
      SelectAll;
      CopyToClipboard;
    end;

  MsgDlgFrm('The report has been copied to the Windows clipboard.' + CRLF + CRLF
    + 'If you like, you may paste it into an open text document.',
    MHA_CAPTION, mtInformation, [mbOK], 0);
end;

procedure TfrmMHA_SingleInstrumentMenu.mnuCopyGraphClick(Sender: TObject);
begin
  chrtScores.Title.Visible := True;
  chrtScores.Title.Text.Add(Patient.Name + '  SSN: ' + Patient.FormattedSSN);
  chrtScores.CopyToClipboardBitmap;
  chrtScores.Title.Text.Clear;

  MsgDlgFrm('The graph has been copied to the Windows clipboard.' + CRLF +
    '' + CRLF +
    'If you like, you may paste it into another document (e.g., an MS Word ' +
    CRLF + 'document).', MHA_CAPTION, mtInformation, [mbOK], 0);
end;

procedure TfrmMHA_SingleInstrumentMenu.mnuSaveReportClick(Sender: TObject);
begin
  with dlgSave do
    begin
      FileName := 'Test Report.rtf';
      Filter := 'Rich text file (*rtf)|*.rtf';
      if Execute then
        memReport.Lines.SaveToFile(FileName);
    end;
end;

procedure TfrmMHA_SingleInstrumentMenu.mnuSaveTableClick(Sender: TObject);
begin
  with dlgSave do
    begin
      FileName := 'Test Scores.xls';
      Filter := 'Excel file (*xls)|*.xls';
      if Execute then
        begin
          grdScores.cells[0, 0] := Patient.Name + '  SSN: ' + Patient.FormattedSSN;
          grdScores.SaveToXLS(FileName);
          grdScores.cells[0, 0] := '';
        end;
    end;
end;

procedure TfrmMHA_SingleInstrumentMenu.mnuPrintGraphClick(Sender: TObject);
begin
  with chrtScores do
    begin
      Foot.Text.Text := Patient.Name + '           SSN: ' + Patient.FormattedSSN;
      PrintLandscape;
      Foot.Text.Text := '';
    end;
end;

procedure TfrmMHA_SingleInstrumentMenu.mnuSaveGraphClick(Sender: TObject);
begin
  with dlgSave do
    begin
      FileName := 'Test Scores.bmp';
      Filter := 'Bitmap files (*.bmp)|*.bmp';
      if Execute then
        begin
          chrtScores.Title.Text.Clear;
          chrtScores.Title.Visible := True;
          chrtScores.Title.Text.Add(Patient.Name + '  SSN: ' + Patient.FormattedSSN);
          chrtScores.SaveToBitmapFile(FileName);
          chrtScores.Title.Text.Clear;
        end;
    end;
end;

procedure TfrmMHA_SingleInstrumentMenu.mnuCopyTableClick(Sender: TObject);
begin
  grdScores.cells[0, 0] := Patient.Name + '  SSN: ' + Patient.FormattedSSN;
  grdScores.CopyToClipBoard;
  grdScores.cells[0, 0] := '';

  MsgDlgFrm('The table has been copied to the Windows clipboard.' + CRLF +
    '' + CRLF +
    'If you like, you may paste it into an open MS Excel spreadsheet.',
    MHA_CAPTION, mtInformation, [mbOK], 0);
end;

procedure TfrmMHA_SingleInstrumentMenu.mnuPrintTblClick(Sender: TObject);
begin
  grdScores.PrintSettings.Font.Size := 10;
  grdScores.PrintSettings.TitleText := Caption;
  grdScores.Print;
end;

procedure TfrmMHA_SingleInstrumentMenu.mnuPrintReportClick(Sender: TObject);
var
  presX, presY                : Integer;
begin
  with memReport do
    begin
      PlainText := true;
      presX := GetDeviceCaps(printer.handle, LOGPIXELSX);
      presY := GetDeviceCaps(printer.handle, LOGPIXELSY);

      with pagerect do
        begin
          Left := 3 * presX div 4; // .75 inch left margin
          Top := presY; // 1 inch top margin
          Right := Printer.PageWidth - (3 * presX div 4);
            // .75 inch right margin
          Bottom := Printer.PageHeight - presY; // 1 inch bottom margin
        end;

      memReport.Print(lvInstrument.InstrumentName + ' Report');

    end;
end;


procedure TfrmMHA_SingleInstrumentMenu.mnuShowGraphLabelsClick(
  Sender: TObject);
var
  t                           : integer;
begin
  mnuShowGraphLabels.Checked := not mnuShowGraphLabels.Checked;

  if mnuShowGraphLabels.Checked then
    for t := 0 to chrtScores.SeriesCount - 1 do
      begin
        if chrtScores.Series[t] is TLineSeries then
          with (chrtScores.Series[t] as TLineSeries) do
            begin
              Marks.Style := smsValue;
              Marks.Visible := true;
            end
      end
  else
    for t := 0 to chrtScores.SeriesCount - 1 do
      begin
        if chrtScores.Series[t] is TLineSeries then
          with (chrtScores.Series[t] as TLineSeries) do
            Marks.Visible := False;
      end;
end;

function TfrmMHA_SingleInstrumentMenu.GetScores: string;
var
  TempStr,
    TempStr1, TempStr2        : string;
  i, j, icol, Grp             : integer;
begin
  result := OK;
  icol := 1;

  for i := Result_OPS.ListOfResults.Count - 1 downto 0 do
    begin
      with TAResult(Result_OPS.ListOfResults[i]) do
        begin

          if InstrumentName = TAResult(Result_OPS.ListOfResults[gvCurrentResult]).InstrumentName then
            begin
              // StringList within AResult:
              // ScoreName1=ScoreValue1~ScoreName2=ScoreValue2...
              if ListOfScores = '' then
                ListOfScores :=
                  Result_OPS.LoadScores(AnswersAreInLegacyFile, AdministrationIENS,
                  InstrumentName, Patient.DFN, DateSaved);

              if Pos(BAD_DATA, ListOfScores) = 0 then
                begin
                  grdScores.Cells[icol, 0] := DateGiven;
                  Grp := 0;
                  for j := 1 to NumberOfPieces(ListOfScores, RECORD_END) do
                    begin
                      TempStr := Piece(ListOfScores, RECORD_END, j);
                      TempStr := Piece(TempStr, EQ, 2);
                      // Some have two scores: Raw and percent (or t-score), or,
                      // raw plus a label ("severe" "mild")
                      if (NumberOfPieces(TempStr, U) > 0) then
                        begin
                          TempStr2 := Piece(TempStr, U, 2);
                          if (TempStr2 = '') or not (TempStr2[1] in ['0'..'9']) then
                            TempStr := Piece(TempStr, U, 1)
                          else
                            TempStr := Piece(TempStr, U, 2);
                        end;
                      TempStr1 := grdScores.Cells[0, j + Grp];
                      // Scale-Group name is not lcIndented: No scores are associated
                      // with that row.
                      if TempStr1 <> '' then
                        if TempStr1[1] <> ' ' then
                          Inc(Grp);
                      grdScores.Cells[icol, j + Grp] := TempStr;
                      grdScores.ColWidths[icol] := lvDateColWidth;
                    end;

                  Inc(icol);
                  grdScores.Refresh;
                end;
            end;
        end; // with
    end; // for i

  grdScores.ColCount := icol;
  grdScores.IntegralHeight := True;

end;

procedure TfrmMHA_SingleInstrumentMenu.mnuPrintBlankClick(Sender: TObject);
begin

  try
    frmPrint_Instrument := TfrmPrint_Instrument.Create(nil);
  finally
    frmPrint_Instrument.Free;
  end; //try

end;

procedure TfrmMHA_SingleInstrumentMenu.FormResize(Sender: TObject);
begin
  if lvInitialize then
    Exit;

  // Reset these, used in placement of dialogs
  gvLeft := Left;
  gvTop := Top;
  gvHeight := Height;
  gvWidth := Width;
end;

procedure TfrmMHA_SingleInstrumentMenu.PrepareNewAdministration;
begin
  gvID := NO_ID;
  gvDateGiven := Now;
  gvProgressNoteIEN := '';

  with lvAdministration do
    begin
      InstrumentName := gvNameOfInstrument;
      ID := NO_ID;
      NumberAnswered := 0;
      NumberSkipped := 0;
      NumberStillRequired := 0;
      RecordID := NO_ID;
      PatientID := Patient.DFN;
      Signed := False;
      DateSaved := Now;
      DateGiven := Now; //lvAdministration.DateGiven;
      //IsComplete := False;
      //IsRestartable := False;
      DaysToRestart := lvInstrument.DaysToRestart;
      IsaLegacy := lvInstrument.IsLegacy;
      LocationIEN := ''; //lvAdministration.LocationIEN;
      LocationStr := ''; //lvAdministration.LocationStr;
      OrdererDUZ := ThisUser.DUZ;
      AdministeredBy := ThisUser.DUZ;
    end;
end;


procedure TfrmMHA_SingleInstrumentMenu.StartVA_SecureDesktop;
var
  NullString                  : array[0..512] of Char;
begin
  frmMHA_SD_Warning := TfrmMHA_SD_Warning.Create(nil);
  try
    frmMHA_SD_Warning.lblNotice.Alignment := taCenter;
    frmMHA_SD_Warning.lblNotice.Caption := CRLF +
      'USE ONLY ALPHA-NUMERIC KEYS ON THE KEYBOARD.' + CRLF + CRLF +

    'Using any other keys may cause the test to abort. ' + CRLF +
      'All keystrokes are monitored for security violations.';

    frmMHA_SD_Warning.btnYes.Visible := False;
    frmMHA_SD_Warning.btnNo.Caption := '&OK';

    frmMHA_SD_Warning.ShowModal;
  finally
    frmMHA_SD_Warning.free;
  end;

  StrPCopy(NullString, LocalFiles.MHAPath + 'YS_MHA_VASD.exe');
  ShellExecute(Handle, 'open', NullString,
    nil, nil, SW_SHOWNORMAL);
end;


procedure TfrmMHA_SingleInstrumentMenu.StaffEntry;
begin
  Proctor.DataEntryMode := emStaff;

  if lvIsAllItems then
    ShowAllItems
  else
    ShowOneItem;

  SendEMailToOrderer;
end;

procedure TfrmMHA_SingleInstrumentMenu.PatientEntry;
begin
  frmMHA_SD_Warning := TfrmMHA_SD_Warning.Create(nil);
  try
    frmMHA_SD_Warning.lblNotice.Caption := CRLF +
      'From this point on, the veteran will be answering questions on the ' +
      'instruments selected. To maintain security, all other functions on ' +
      'this computer will be unavailable.' + CRLF + CRLF +
      'All unsaved work in other programs should be saved and the programs ' +
      'closed before continuing.' + CRLF + CRLF +

    'AFTER COMPLETING THE TEST(S), USER IS AUTOMATICALLY LOGGED OFF THE ' +
      'SYSTEM.' + CRLF + CRLF +
      'Do you wish to continue?';

    frmMHA_SD_Warning.ShowModal;
  finally
    frmMHA_SD_Warning.free;
  end;

  if frmMHA_SD_Warning.ModalResult = mrCancel then
    exit;

  Proctor.DataEntryMode := emPatient;

  StartVA_SecureDesktop;

  if lvIsAllItems then
    ShowAllItems
  else
    ShowOneItem;

  SendEMailToOrderer
end;

procedure TfrmMHA_SingleInstrumentMenu.ShowOneItem;
begin
  try
    frmMHA3_AdministerSingleItems := TfrmMHA3_AdministerSingleItems.Create(nil);
  finally
    frmMHA3_AdministerSingleItems.Free;
  end;
end;

procedure TfrmMHA_SingleInstrumentMenu.ShowAllItems;
begin

  try
    frmMHA3_AdministerAllItems := TfrmMHA3_AdministerAllItems.Create(nil);
  finally
    frmMHA3_AdministerAllItems.Free;
  end;
end;

procedure TfrmMHA_SingleInstrumentMenu.SendEMailToOrderer;
var
  Reply                       : string;
begin

  if not (DatabaseMode = dbVista) then
    Exit;

  Reply := Administration_OPS.NotifyOrderer(lvAdministration.Orderer.DUZ, Patient.DFN, gvNameOfInstrument); // uMHA_Administration

  if (Reply = OK) then
    Exit;

  Reply := 'MHA was unable to notify the person who ordered this test '
    + 'session.  Please do so yourself.' + CRLF + CRLF + Reply;

  MsgDlgFrm(Reply, MHA_Caption, mtWarning, [mbOK], 0);

end;

procedure TfrmMHA_SingleInstrumentMenu.grdAdministrationsRowChanging(
  Sender: TObject; OldRow, NewRow: Integer; var Allow: Boolean);
var
  aRow                        : integer;
begin
  aRow := NewRow;

  if (ARow = 0) then
    begin
      allow := false;
      Exit;
    end;

  Allow := true;

  if lvInstrumentHasScales then
    begin
      // Allow graphs and tables for completed instruments
      mnuGraphTable.Enabled := (grdAdministrations.Cells[3, ARow] = COMPLETE);
      mnuCopyTable.Enabled := mnuGraphTable.Enabled;
      mnuCopyGraph.Enabled := mnuGraphTable.Enabled;
      mnuSaveTable.Enabled := mnuGraphTable.Enabled;
      mnuSaveGraph.Enabled := mnuGraphTable.Enabled;
      mnuPrintTable.Enabled := mnuGraphTable.Enabled;
      mnuPrintGraph.Enabled := mnuGraphTable.Enabled;
      tsGraphs.TabVisible := mnuGraphTable.Enabled;
    end;

  mnuAppendComments.Enabled := mnuGraphTable.Enabled;
  btnEdit.Enabled := (grdAdministrations.Cells[3, ARow] = INCOMPLETEEDIT);

  // Because a new instrument result has been selected...
  lvIsFirstViewOfGraph := True;

  if (ARow > 0) then
    begin
      gvID := grdAdministrations.Cells[4, ARow];
      DisplayReport(gvID, grdAdministrations.Cells[3, ARow], ARow);
    end;

  if gvUseScreenReader then
    ActiveControl := memReport
  else
    grdAdministrations.SetFocus;

end;

procedure TfrmMHA_SingleInstrumentMenu.grdAdministrationsGetCellColor(
  Sender: TObject; ARow, ACol: Integer; AState: TGridDrawState;
  ABrush: TBrush; AFont: TFont);
begin
  if (UpperCase(grdAdministrations.Cells[5, ARow]) = 'TRUE') then
    AFont.Style := [fsBold]
  else
    AFont.Style := [];
end;

procedure TfrmMHA_SingleInstrumentMenu.grdAdministrationsClickCell(
  Sender: TObject; ARow, ACol: Integer);
begin
// This does not handle the case where the user presses the arrow keys to
// navigate the grid.

  if (ARow = 0) then
    begin
      with grdAdministrations do
        begin
          if (ACol = 0) then
            SortSettings.Direction := sdDescending
          else
            SortSettings.Direction := sdAscending;

          SortByColumn(ACol);
          Row := 1;
        end;
    end;
end;



end.

