unit fMHA_Update;

interface

uses
  Windows,
  Messages,
  SysUtils,
  DateUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  IpUtils,
  IpSock,
  IpFtp,
  StdCtrls;

type
  TfrmMHA_Update = class(TForm)
    IpFtpClient1: TIpFtpClient;
    ReplyMemo: TMemo;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure IpFtpClient1FtpStatus(Sender: TObject;
      StatusCode: TIpFtpStatusCode; const Info: string);
    procedure IpFtpClient1FtpReply(Sender: TObject; ReplyCode: Integer;
      const Reply: string);
    procedure IpFtpClient1FtpError(Sender: TObject; ErrorCode: Integer;
      const Error: string);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure CheckForUpdates;
  end;

var
  frmMHA_Update               : TfrmMHA_Update;

implementation

{$R *.dfm}

uses
  uMHA_Const;

var
  lvTempDate : TDateTime;


procedure TfrmMHA_Update.FormCreate(Sender: TObject);
begin
  CheckForUpdates;
  showmodal;
end;

procedure TfrmMHA_Update.CheckForUpdates;
// Check for updates every week

begin
  lvTempDate := gvUpdate;
//  ShowMessage('current series ' + gvUpdateSeries + #13 +
//    datetostr(gvUpdate) + #13+
//    'Days between ' + inttostr(DaysBetween(strtodate('04/01/2009'), gvUpdate)));

  if DaysBetween(strtodate('04/01/2009'), gvUpdate) > 6 then
    begin
      IpFtpClient1.PassiveMode := True;
      IpFtpClient1.Login('ftp.fo-albany.domain.ext',
        'anonymous', '', '');
      IpFtpClient1.FileType := ftAscii;
      IpFtpClient1.TransferTimeout := 1092;

      //Sleep(10000); {- 10 seconds -}

    end;

end;

procedure TfrmMHA_Update.IpFtpClient1FtpStatus(Sender: TObject;
  StatusCode: TIpFtpStatusCode; const Info: string);
begin
  case StatusCode of
    fscLogin: Button3Click(Sender);

    fscCurrentDir: Button1Click(Sender);
    fscTransferOK: Button2Click(Sender);

//    fscClose :      Caption := 'Close';
//    fscOpen :       Caption := ' connected to ' + IpFtpClient1.ServerAddress;
//    fscComplete :   if (MultiFileOp = mfoDelete) then
//                      DeleteNext;
//    fscCurrentDir : Caption := Info;
//    fscLogin :      Caption := IpFtpClient1.UserName + ' logged on to ' + IpFtpClient1.ServerAddress;
//    fscLogout :     Caption := IpFtpClient1.UserName + ' logged out';
//    fscDirList :    ReplyMemo.Lines.Add(Info);
//    fscProgress :   Caption := IntToStr(IpFtpClient1.BytesTransferred) + ' bytes Transferred';
//    fscTransferOK : begin
//                      Caption := IntToStr(IpFtpClient1.BytesTransferred) + ' - transfer complete';
                      //if (MultiFileOp = mfoRetrieve) then
                      //  RetrieveNext;
                   // end;
    fscTimeout: ShowMessage('Transfer timed out');
  end;
end;

procedure TfrmMHA_Update.IpFtpClient1FtpReply(Sender: TObject; ReplyCode: Integer;
  const Reply: string);
begin
  ReplyMemo.Lines.Add(Reply);
end;


procedure TfrmMHA_Update.IpFtpClient1FtpError(Sender: TObject; ErrorCode: Integer;
  const Error: string);
begin
  MessageDlg(Error, mtError, [mbOK], 0);
  Screen.Cursor := crDefault;
end;

procedure TfrmMHA_Update.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  IpFtpClient1.Logout;
end;

procedure TfrmMHA_Update.Button3Click(Sender: TObject);
begin
  IpFtpClient1.ChangeDir('ANONYMOUS');
end;

procedure TfrmMHA_Update.Button2Click(Sender: TObject);
begin
  gvUpdate := IncDay(lvTempDate, 7);
  Close;
end;

procedure TfrmMHA_Update.Button1Click(Sender: TObject);
begin
  IpFtpClient1.Retrieve('\YS_MHA.TXT;1',
    'C:\Projects\Patch 101 MHA3 D7\' + 'YS_MHA.TXT',
    TIpFtpRetrieveMode(1), 0);
end;



end.

