unit uMHA_ASI_Build;

interface

uses
  Classes,
  ComCtrls,
  Controls,
  fIA_Dialogs,
  ExtCtrls,
  Forms,
  Graphics,
  Mask,
  Messages,
  RzCmboBx,
  RzEdit,
  RzPanel,
  RzRadGrp,
  RzSplit,
  StdCtrls,
  Windows,
  StExpr,
  ORCtrls,
  Fmcmpnts,
  Fmcntrls,
  SysUtils,
  Buttons;

//type
//  TASI_Build = class(TObject)
//  private
//    procedure LoadCommentFields(WhichIEN: string);
//  protected
//  public
    //constructor Create;
//    procedure AdjustForm;
procedure ASI_BuildBasics;
procedure ASI_InsertItems;
procedure ASI_BuildForm;
procedure ASI_SetupComboBoxItems;
procedure ASI_DefaultValuesForItems;
procedure ASI_SetupFull;
procedure ASI_SetupLite;
procedure ASI_SetupFollowup;
procedure ASI_PositionItems(WhichForm: Char);
procedure ASI_MakePartialList;

    //destructor Destroy; override;
//  published
//  end;    { TASI_Build }

//var
//  ASI_Build         : TASI_Build;

implementation

uses
  fMHA_ASI_Main,
  fMHA_ASI_Entry,
  uMHA_ASI,
  uMHA_ASI_OPS,
  uMHA_Registry,
  uIA_ThisUser,
  uIA_Utils,
  uIA_Const,
  uMHA_Const,
  uMHA_Answer_IO,
  uMHA_DM; //For datamodule

var
  lvPartialList               : TStringList;

(*
constructor TASI_Build.Create;
begin
  inherited Create;
end;

destructor TASI_Build.Destroy;
begin
  inherited Destroy;
end; *)

(*procedure TASI_Build.AdjustForm;
var
  r                 : TRect;
begin
  with frmMHA_ASI_Entry do
    begin
  // Set form size
      if mnuDefaultSize.Checked then
        begin
    //set form top and height to work area (i.e., desktop size minus task bars)
          SystemParametersInfo(SPI_GetWorkArea, 0, @r, 0);
          BoundsRect := r;
          Top := r.Top;
          Height := r.Bottom - r.Top;

    //set form width to 638 and center it
          Width := 638;
          Left := (r.Right - Width) div 2;
        end
      else
        begin
          WindowState := wsNormal;
    // Use the main form's dimensions & location to ensure overlap
          Top := frmMHA_ASI_Main.Top;
          Left := frmMHA_ASI_Main.Left;
          Height := frmMHA_ASI_Main.Height;
          Width := frmMHA_ASI_Main.Width;
        end;
    end;
end;*)


procedure ASI_BuildBasics;
begin
  //AdjustForm;
   // Run-time constructon of most combo box strings
  ASI_SetupComboBoxItems;

  with frmMHA_ASI_Entry do
    begin
      dtpG5.DateTime := Date;

    // Window title bar
//   Caption := 'Addiction Severity Index for '
//    + ' ' + MixedCase(Piece(Patient.Name, ',', 2))
//    + ' ' + MixedCase(Piece(Patient.Name, ',', 1))
//    + '  SSN: ' + Patient.FormattedSSN;

  // Prepare the interviewer's combo box with dark-side list
      cbxG11OrderedByx.InitLongList(ThisUser.Name);
      cbxG11OrderedByx.SelectByIEN(StrToInt(ThisUser.DUZ));
      cbxG11Interviewerx.InitLongList(ThisUser.Name);
      cbxG11Interviewerx.SelectByIEN(StrToInt(ThisUser.DUZ));

  // Setup Default values
      dtpG4.MaxDate := Now;
      dtpG5.MaxDate := Now;
      dtpG4.DateTime := Date;
      dtpG5.DateTime := Date;

      ASI_DefaultValuesForItems;

(*
  //Get list for "program" choices from Vista.
  with MHA_DataModule.FMLister1 do begin
    RPCBroker := RPCBrokerv;
    FileNumber := '604.26';
    FieldNumbers.Clear;
    DisplayFields.Clear;
    FieldNumbers.Add('1');
    DisplayFields.Add('1');
      //screen out programs that are inactive.
    Screen := 'I $P(^(0),U,3)''=0';
    GetList(nil);
  end; *)

      with cbxG3.Items do
        begin
          Clear;
     //Type 7: G3
          Add('1=Consultation/Liaison');
          Add('2=Early Intervention/Education/Referral');
          Add('3=Detoxification Services');
          Add('4=Ambulatory except Opioid Substitution');
          Add('5=Opioid Substitution');
          Add('6=Inpatient Acute Care');
          Add('7=Substance Abuse Residential Rehabilitation Treatment Program');
          Add('8=Compensated Work Therapy/Transitional Residence');
          Add('9=Therapeutic Community');
          Add('10=Domiciliary');
          Add('11=VA Halfway House (Not Contracted)');
          Add('12=Combination: Inpatient Acute, Residential, Ambulatory Care');
          Add('13=Combination: Inpatient Acute Care, Ambulatory');
          Add('14=Combination: Inpatient Acute Care, Residential');
          Add('15=Combination: Residential, Ambulatory');
          Add('16=Primary Care (Non-Substance Abuse)');
          Add('17=General Medicine');
          Add('18=General Psychiatry');
          Add('19=General Surgery');
          Add('20=Domiciliary (Non-Substance Abuse)');
          Add('21=SCI Program');
        end;
(*
  //Converts FMLister contents (internal) to program name (external).
  for i := 0 to MHA_DataModule.FMLister1.Results.Count - 1 do
  begin
    Tempien := MHA_DataModule.FMLister1.Results[i];
    TempName := MHA_DataModule.FMLister1.GetRecord(tempien).GetField('1').FMDBExternal;
    cbxG3.Items.Add(tempien + '^' + TempName);
  end;
 *)
      if ((gvLastASIProgram < 0) or (gvLastASIProgram > 100)) then
        gvLastASIProgram := 0;
      cbxG3.Text := Piece(cbxG3.Items[gvLastASIProgram], U, 2);

  // Hide the verify window
      pnlVerify.Height := 0;

  // setttings from Windows registry

      SpltGeneral.percent := gvASIGeneral;
      SpltMedical.percent := gvASIMedical;
      SpltEmploy.percent := gvASIEmploy;
      SpltDrug.percent := gvASIDrug;
      SpltLegal.percent := gvASILegal;
      SpltFamily.percent := gvASIFamily;
      SpltSocial.percent := gvASISocial;
      SpltPsych.percent := gvASIPsych;

  // default settings
      sbGeneral.VertScrollBar.Position := 0;
      sbMedical.VertScrollBar.Position := 0;
      sbEmploy.VertScrollBar.Position := 0;
      sbLegal.VertScrollBar.Position := 0;
      sbDrug.VertScrollBar.Position := 0;
      sbFamily.VertScrollBar.Position := 0;
      sbSocial.VertScrollBar.Position := 0;
      sbPsych.VertScrollBar.Position := 0;
      pgctrlASI.ActivePage := TabGeneral;

    end;
end;

procedure ASI_LoadCommentFields(WhichIEN: string);

  function CleanText(TextIn: string): string;
  // M-side strings have ^ as hard carriage return. Not needed here.
  var
    TempStr                   : string;
  begin
    Result := '';
    if Trim(TextIn) = BAD_DATA then
      Exit;
    if Length(TextIn) = 0 then
      Exit;
    TempStr := TextIn;
    // Mark the double carriage returns. This keeps the paragraphs intact.
    TempStr := StringReplace(TempStr, '^^', #240, [rfReplaceAll, rfIgnoreCase]);
    // Remove all carriage returns
    TempStr := StringReplace(TempStr, '^', '', [rfReplaceAll, rfIgnoreCase]);
    // Replace the paragraph markers
    TempStr := StringReplace(TempStr, #240, #13 + #13, [rfReplaceAll, rfIgnoreCase]);
    Result := TempStr;
  end;

begin
  with frmMHA_ASI_Entry.memGeneral.Lines do
    begin
      Clear;
      Add(AnswerReadComment('604', '.6', WhichIEN, DataModule1.RPCBroker1));
      Text := CleanText(Text);
    end;
  with frmMHA_ASI_Entry.MemMedical.Lines do
    begin
      Clear;
      Add(AnswerReadComment('604', '8.5', WhichIEN, DataModule1.RPCBroker1));
      Text := CleanText(Text);
    end;
  with frmMHA_ASI_Entry.MemEmploy.Lines do
    begin
      Clear;
      Add(AnswerReadComment('604', '9.5', WhichIEN, DataModule1.RPCBroker1));
      Text := CleanText(Text);
    end;
  with frmMHA_ASI_Entry.MemDrug.Lines do
    begin
      Clear;
      Add(AnswerReadComment('604', '10.5', WhichIEN, DataModule1.RPCBroker1));
      Text := CleanText(Text);
    end;
  with frmMHA_ASI_Entry.MemLegal.Lines do
    begin
      Clear;
      Add(AnswerReadComment('604', '14.5', WhichIEN, DataModule1.RPCBroker1));
      Text := CleanText(Text);
    end;
  with frmMHA_ASI_Entry.MemFamily.Lines do
    begin
      Clear;
      Add(AnswerReadComment('604', '16.5', WhichIEN, DataModule1.RPCBroker1));
      Text := CleanText(Text);
    end;
  with frmMHA_ASI_Entry.MemSocial.Lines do
    begin
      Clear;
      Add(AnswerReadComment('604', '18.5', WhichIEN, DataModule1.RPCBroker1));
      Text := CleanText(Text);
    end;
  with frmMHA_ASI_Entry.MemPsych.Lines do
    begin
      Clear;
      Add(AnswerReadComment('604', '19.5', WhichIEN, DataModule1.RPCBroker1));
      Text := CleanText(Text);
    end;
  with frmMHA_ASI_Entry.MemSpirit.Lines do
    begin
      Clear;
      Add(AnswerReadComment('604', '188', WhichIEN, DataModule1.RPCBroker1));
      Text := CleanText(Text);
    end;
  with frmMHA_ASI_Entry.MemLeisure.Lines do
    begin
      Clear;
      Add(AnswerReadComment('604', '187', WhichIEN, DataModule1.RPCBroker1));
      Text := CleanText(Text);
    end;
end;

procedure ASI_MakePartialList;
// The broker calls are limited to 80 fields at a time.
// This list uses three calls and contains the fields for
// Full, Lite or Follow-up ASI.
// The IEN is found in frmMain.grdOldASI.Cells[5, frmMain.grdOldASI.Row]
var
  n                           : integer;
  S                           : string;

  procedure ReadAnswer(StringIn: string);
  var
    i                         : integer;
  begin
    with frmMHA_ASI_Entry do
      begin
    // the end of the list as been reached.
        if StringIn = 'Done' then
          begin
            DataModule1.ASI_FMGets1.FieldNumbers.Clear;
            DataModule1.ASI_FMGets1.AddField(S);
            DataModule1.ASI_FMGets1.GetData;
            for i := 0 to DataModule1.ASI_FMGets1.Results.Count - 1 do
              lvPartialList.Add(DataModule1.ASI_FMGets1.results[i] + ';' +
                DataModule1.ASI_FMGets1.GetField(DataModule1.ASI_FMGets1.Results[i]).FMDBInternal);
            exit;
          end;
    // add the new item to the growing string
        S := S + StringIn;
    // Keep track of how many items, no more than 80
        Inc(n);
        if n > 80 then
          begin
            DataModule1.ASI_FMGets1.FieldNumbers.Clear;
            DataModule1.ASI_FMGets1.AddField(S);
            DataModule1.ASI_FMGets1.GetData;
            for i := 0 to DataModule1.ASI_FMGets1.Results.Count - 1 do
              lvPartialList.Add(DataModule1.ASI_FMGets1.results[i] + ';' +
                DataModule1.ASI_FMGets1.GetField(DataModule1.ASI_FMGets1.Results[i]).FMDBInternal);
            S := '';
            n := 0;
          end;
      end;
  end;

begin

  with frmMHA_ASI_Entry do
    begin
      lvPartialList := TStringList.Create;
      lvPartialList.Clear;

      DataModule1.RPCBroker1.CreateContext('YS BROKER1');
      DataModule1.ASI_FMGets1.FileNumber := '604';

      DataModule1.ASI_FMGets1.IENS :=
        TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).IENS;

      S := '';
      n := 0;

  // General  17 items -------------------------------------------
  //'NAME
      ReadAnswer('.02;');
  //INTRCODE
      ReadAnswer('.81;');
  //ORDEREDBY
      ReadAnswer('.09;');
  //PROGRAM
      ReadAnswer('2;');
  //ADMITED
      ReadAnswer('1;');
  //INTDATE
      ReadAnswer('.05;');
  //CLASS
      ReadAnswer('.04;');
  //CONTACT
      ReadAnswer('.07;');
  //SPECIAL
      ReadAnswer('.11;');
  //  ReadComboBoxYEARS
      ReadAnswer('1.201;');
  //  ReadComboBoxMONTS
      ReadAnswer('1.202;');
  //  OWNHOME
      ReadAnswer('1.203;');
  //  RACE
      ReadAnswer('.16;');
  //RELIGION
      ReadAnswer('.17;');
  //CONENV
      ReadAnswer('2.01;');
  //OTHER
      ReadAnswer('2.02;');
  //CONENTIM
      ReadAnswer('2.03;');


  // Medical 15 items ----------------------------------------------
  //HOSPLIFE
      ReadAnswer('8.01;');
//DC    if frmMain.Partial_ASI = 'A' then // Full
      if (TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itFull) then
        begin
      //HOSPYEAR
          ReadAnswer('8.02;');
      //HOSPMONT
          ReadAnswer('8.025;');
        end;
//    if ((frmMain.Partial_ASI = 'A') or (frmMain.Partial_ASI = 'L')) then
      if ((TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itFull) or
        (TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itLite)) then
        begin
      //CHRONMED
          ReadAnswer('8.03;');
      //CHRONMEDSPEC
          ReadAnswer('8.04;');
        end;
  //MEDICATS
      ReadAnswer('8.05;');
  //PHYSDIS
      ReadAnswer('8.06;');
  //PHYSDISSPEC
      ReadAnswer('8.07;');
  //DAYMEDP
      ReadAnswer('8.08;');
  //TROUBLED
      ReadAnswer('8.09;');
  //IMPTMT
      ReadAnswer('8.11;');
 //DC   if ((frmMain.Partial_ASI = 'A') or (frmMain.Partial_ASI = 'F')) then
      if ((TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itFull) or
        (TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itFU)) then
    //ISRMED
        ReadAnswer('8.12;');
  //MPATMISR
      ReadAnswer('8.14;');
  //MEDUNDER
      ReadAnswer('8.15;');

  // Employment 27 Items ----------------------------------------------
  //EDUCYEAR
      ReadAnswer('9.01;');
  //EDUCMONT
      ReadAnswer('9.02;');
  //TRAINING
      ReadAnswer('9.03;');
//DC    if frmMain.Partial_ASI = 'A' then
      if (TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itFull) then
        begin
      //PROFN
          ReadAnswer('9.04;');
     //SPECPTS
          ReadAnswer('9.05;');
        end;
  //LICENSE
      ReadAnswer('9.06;');
  //CAR
      ReadAnswer('9.09;');
//DC    if ((frmMain.Partial_ASI = 'A') or (frmMain.Partial_ASI = 'L')) then
      if ((TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itFull) or
        (TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itLite)) then
        begin
      //JOBYEAR
          ReadAnswer('9.11;');
      //JOBMONTH
          ReadAnswer('9.12;');
        end;
  //OCCUP
      ReadAnswer('9.14;');
  //SPECOCCUP
      ReadAnswer('9.145;');
//DC    if ((frmMain.Partial_ASI = 'A') or (frmMain.Partial_ASI = 'F')) then
      if ((TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itFull) or
        (TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itFU)) then
        begin
      //SUPPORT
          ReadAnswer('9.15;');
        end;
   //MAJORITY
      ReadAnswer('9.16;');

//DC    if ((frmMain.Partial_ASI = 'A') or (frmMain.Partial_ASI = 'L')) then
      if ((TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itFull) or
        (TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itLite)) then
  //PATTERNS
        ReadAnswer('9.17;');
  //DAYSPAID
      ReadAnswer('9.18;');
  //EMPL$
      ReadAnswer('9.19;');
  //UNEMPLOY
      ReadAnswer('9.21;');
  //DPA
      ReadAnswer('9.22;');
  //PENSION
      ReadAnswer('9.23;');
  //FAMILY
      ReadAnswer('9.24;');
  //ILLEGAL
      ReadAnswer('9.25;');
  //DEPENDS
      ReadAnswer('9.29;');
//DC    if ((frmMain.Partial_ASI = 'A') or (frmMain.Partial_ASI = 'F')) then
      if ((TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itFull) or
        (TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itFU)) then
        begin
      //EMPROB
          ReadAnswer('9.31;');
      //EMPTROUB
          ReadAnswer('9.32;');
        end;
  //EMPCOUNS
      ReadAnswer('9.33;');

//DC    if ((frmMain.Partial_ASI = 'A') or (frmMain.Partial_ASI = 'F')) then
      if ((TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itFull) or
        (TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itFU)) then
    //EMPLOYRA
        ReadAnswer('9.34;');
  //EPATMISR
      ReadAnswer('9.35;');
  //EMPUNDER
      ReadAnswer('9.36;');

  // Drug and Alcohol 65 items ----------------------------------------
  //ALC30
      ReadAnswer('10.01;');
  //ALCLIYR
      ReadAnswer('10.02;');
  //ALCRT
      ReadAnswer('10.03;');
  //ALCIN30
      ReadAnswer('10.04;');
  //ALCINLIY
      ReadAnswer('10.05;');
  //INTOXRT
      ReadAnswer('10.06;');
  //HEROIN30
      ReadAnswer('10.07;');
  //HERONLIY
      ReadAnswer('10.08;');
  //HERNRT
      ReadAnswer('10.09;');
  //METHDN30
      ReadAnswer('10.11;');
  //METDNLIY
      ReadAnswer('10.12;');
  //METHRT
      ReadAnswer('10.14;');
  //OPIAT30
      ReadAnswer('10.15;');
  //OPIATLIY
      ReadAnswer('10.16;');
  //OPIRT
      ReadAnswer('10.17;');
  //BARB30
      ReadAnswer('10.18;');
  //BARBLIFY
      ReadAnswer('10.19;');
  //BARBRT
      ReadAnswer('10.21;');
  //SEDS30
      ReadAnswer('10.22;');
  //SEDLIFYR
      ReadAnswer('10.23;');
  //SEDSRT
      ReadAnswer('10.24;');
  //COCAN30
      ReadAnswer('10.25;');
  //COCLIFYR
      ReadAnswer('10.26;');
  //COCAINRT
      ReadAnswer('10.27;');
  //AMPH30
      ReadAnswer('10.28;');
  //AMPLIFYR
      ReadAnswer('10.29;');
  //AMPRT
      ReadAnswer('10.31;');
  //MJ30
      ReadAnswer('10.32;');
  //MJLIFEYR
      ReadAnswer('10.33;');
  //MJRT
      ReadAnswer('10.34;');
  //HALLU30
      ReadAnswer('10.35;');
  //HALLIFYR
      ReadAnswer('10.36;');
  //HALRT
      ReadAnswer('10.37;');
  //INHA30
      ReadAnswer('10.38;');
  //INHALIYR
      ReadAnswer('10.39;');
  //INHALRT
      ReadAnswer('10.41;');
  //GT130
      ReadAnswer('10.42;');
  //GT1LIYR
      ReadAnswer('10.43;');
//DC    if ((frmMain.Partial_ASI = 'A') or (frmMain.Partial_ASI = 'F')) then
      if ((TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itFull) or
        (TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itFU)) then
    //MAJPROB
        ReadAnswer('10.45;');
//DC      if rgrpG8.ItemIndex = 0 {Full} then
      if (TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itFull) then
        begin
        //LONGABST
          ReadAnswer('11.01;');
        //LASTABST
          ReadAnswer('11.02;');
        end;
//    if ((frmMain.Partial_ASI = 'A') or (frmMain.Partial_ASI = 'F')) then
      if ((TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itFull) or
        (TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itFU)) then
        begin
      //DTS
          ReadAnswer('11.03;');
      //ODS
          ReadAnswer('11.04;');
        end;
  //ALCTXS
      ReadAnswer('11.05;');
  //DRUGTXS
      ReadAnswer('11.06;');
//DC    if ((frmMain.Partial_ASI = 'A') or (frmMain.Partial_ASI = 'F')) then
      if ((TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itFull) or
        (TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itFU)) then
        begin
        //ALDETOX
          ReadAnswer('11.07;');
        //DRUDETOX
          ReadAnswer('11.08;');
        end;
  //ALCMONEY
      ReadAnswer('11.09;');
  //DRUMONEY
      ReadAnswer('11.11;');
  //OPDAYS
      ReadAnswer('11.12;');
  //ALPROBS
      ReadAnswer('11.14;');
  //DRUPROBS
      ReadAnswer('11.15;');
  //ALBOTHR
      ReadAnswer('11.16;');
  //DRUGBOTH
      ReadAnswer('11.17;');
  //ALTMT
      ReadAnswer('11.165;');
  //DRUTMT
      ReadAnswer('11.175;');
//DC    if ((frmMain.Partial_ASI = 'A') or (frmMain.Partial_ASI = 'F')) then
      if ((TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itFull) or
        (TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itFU)) then
        begin
      //ISRALC
          ReadAnswer('11.18;');
      //ISRDRUG
          ReadAnswer('11.185;');
        end;
  //DAMISREP
      ReadAnswer('11.19;');
  //DAUNDER
      ReadAnswer('11.21;');

  // Legal  34 Items -----------------------------------------------------
//DC    if ((frmMain.Partial_ASI = 'A') or (frmMain.Partial_ASI = 'L')) then
      if ((TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itFull) or
        (TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itLite)) then
    //CJINVOLV
        ReadAnswer('14.01;');
  //ONPROBAT
      ReadAnswer('14.02;');
  //SHOPLIFT
      ReadAnswer('14.03;');
  //PAROLVIL
      ReadAnswer('14.04;');
  //DRUGCHAR
      ReadAnswer('14.05;');
  //FORGE
      ReadAnswer('14.06;');
  //WEAPONS
      ReadAnswer('14.07;');
  //B_N_E
      ReadAnswer('14.08;');
  //ROBBERY
      ReadAnswer('14.09;');
  //ASSAULT
      ReadAnswer('14.11;');
  //ARSON
      ReadAnswer('14.12;');
  //RAPE
      ReadAnswer('14.14;');
  //MURDER
      ReadAnswer('14.15;');
  //PROSTITU
      ReadAnswer('14.16;');
  //CONTEMPT
      ReadAnswer('14.17;');
  //OTHER
      ReadAnswer('14.18;');
  //CONVICTS
      ReadAnswer('14.19;');
  //DISORDER
      ReadAnswer('14.21;');
  //DWI
      ReadAnswer('14.22;');
  //DRIVING
      ReadAnswer('14.23;');
  //INCARLI
      ReadAnswer('14.24;');
//DC    if ((frmMain.Partial_ASI = 'A') or (frmMain.Partial_ASI = 'F')) then
      if ((TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itFull) or
        (TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itFU)) then
        begin
        //LASTINCA
          ReadAnswer('14.25;');
        //REASONIN
          ReadAnswer('14.26;');
        end;
  //WAITRIAL
      ReadAnswer('14.27;');
  //REASTRIA
      ReadAnswer('14.28;');
  //DETAIN30
      ReadAnswer('14.29;');
  //ILLDAY30
      ReadAnswer('14.31;');
  //PRALEGAL
      ReadAnswer('14.32;');
  //PRACOUNS
      ReadAnswer('14.33;');
//DC    if ((frmMain.Partial_ASI = 'A') or (frmMain.Partial_ASI = 'F')) then
      if ((TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itFull) or
        (TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itFU)) then
    //ISRLEGAL
        ReadAnswer('14.34;');
  //LPMISREP
      ReadAnswer('14.35;');
  //LPTUNDER
      ReadAnswer('14.36;');

  // Family History 37 Items ------------------------------------------
//DC    if frmMain.Partial_ASI = 'A' then
      if (TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itFull) then
        begin
  //FHMGM
          ReadAnswer('15.01;');
  //FHMGM
          ReadAnswer('15.02;');
  //FHMGM
          ReadAnswer('15.03;');
  //FHMGF
          ReadAnswer('15.04;');
  //FHMGF
          ReadAnswer('15.05;');
  //FHMGF
          ReadAnswer('15.06;');
  //FHMM
          ReadAnswer('15.07;');
  //FHMM
          ReadAnswer('15.08;');
  //FHMM
          ReadAnswer('15.09;');
  //FHMA
          ReadAnswer('15.11;');
  //FHMA
          ReadAnswer('15.12;');
  //FHMA
          ReadAnswer('15.14;');
  //FHMU
          ReadAnswer('15.15;');
  //FHMU
          ReadAnswer('15.16;');
  //FHMU
          ReadAnswer('15.17;');
  //FHFGM
          ReadAnswer('15.18;');
  //FHFGM
          ReadAnswer('15.19;');
  //FHFGM
          ReadAnswer('15.21;');
  //FHFGF
          ReadAnswer('15.22;');
  //FHFGF
          ReadAnswer('15.23;');
  //FHFGF
          ReadAnswer('15.24;');
  //FHFF
          ReadAnswer('15.25;');
  //FHFF
          ReadAnswer('15.26;');
  //FHFF
          ReadAnswer('15.27;');
  //FHFA
          ReadAnswer('16.01;');
  //FHFA
          ReadAnswer('16.02;');
  //FHFA
          ReadAnswer('16.03;');
  //FHFU
          ReadAnswer('16.04;');
  //FHFU
          ReadAnswer('16.05;');
  //FHFU
          ReadAnswer('16.06;');
  //FHIBB
          ReadAnswer('16.07;');
  //FHIBB
          ReadAnswer('16.08;');
  //FHIBB
          ReadAnswer('16.09;');
  //FHIBS
          ReadAnswer('16.11;');
  //FHIBS
          ReadAnswer('16.12;');
  //FHIBS
          ReadAnswer('16.14;');
        end; // Full ASI

  // Social 53 items -----------------------------------------------
  //MARSTAT
      ReadAnswer('17.01;');
//DC    if frmMain.Partial_ASI = 'A' then
      if (TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itFull) then
        begin
      //MARYRS
          ReadAnswer('17.02;');
      //MARMOS
          ReadAnswer('17.03;');
        end;
  //MARSATF
      ReadAnswer('17.04;');
  //LIVARRGN
      ReadAnswer('17.05;');
//DC    if frmMain.Partial_ASI = 'A' then
      if (TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itFull) then
        begin
      //LIVYRS
          ReadAnswer('17.06;');
      //LIVMONTH
          ReadAnswer('17.07;');
        end;
  //LIVSATF
      ReadAnswer('17.08;');
  //LIVWALC
      ReadAnswer('17.09;');
  //LIVWDRUG
      ReadAnswer('17.11;');
//DC    if ((frmMain.Partial_ASI = 'A') or (frmMain.Partial_ASI = 'F')) then
      if ((TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itFull) or
        (TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itFU)) then
        begin
      //FREETIME
          ReadAnswer('17.12;');
      //FREESATF
          ReadAnswer('17.14;');
      //CLOSFREN
          ReadAnswer('17.15;');
        end;
//DC    if frmMain.Partial_ASI = 'A' then
      if (TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itFull) then
        begin
      //CLOSMOTR
          ReadAnswer('17.16;');
      //CLOSFATR
          ReadAnswer('17.17;');
      //CLOSSIBS
          ReadAnswer('17.18;');
      //CLOSPRTN
          ReadAnswer('17.19;');
      //CLOSKIDS
          ReadAnswer('17.21;');
      //CLOSFREN
          ReadAnswer('17.22;');
        end;
  //MOM30
      ReadAnswer('18.01;');
  //MOMLIFE
      ReadAnswer('18.02;');
  //DAD30
      ReadAnswer('18.03;');
  //DADLIFE
      ReadAnswer('18.04;');
  //SIBS30
      ReadAnswer('18.05;');
  //SIBSLIFE
      ReadAnswer('18.06;');
  //SPOUS30
      ReadAnswer('18.07;');
  //SPOULIFE
      ReadAnswer('18.08;');
  //KIDS30
      ReadAnswer('18.09;');
  //KIDSLIFE
      ReadAnswer('18.11;');
  //OTHFAM30
      ReadAnswer('18.12;');
  //OTHFAMLI
      ReadAnswer('18.14;');
  //FREN30
      ReadAnswer('18.15;');
  //FRENLIFE
      ReadAnswer('18.16;');
  //NEIGH30
      ReadAnswer('18.17;');
  //NEIGHLIF
      ReadAnswer('18.18;');
    //COWOR30
      ReadAnswer('18.185;');
  //COWORLIF
      ReadAnswer('18.186;');
//DC    if ((frmMain.Partial_ASI = 'A') or (frmMain.Partial_ASI = 'F')) then
      if ((TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itFull) or
        (TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itFU)) then
    //EMOABU30
        ReadAnswer('18.19;');
  //EMOABULI
      ReadAnswer('18.195;');
  //PHYABU30
      ReadAnswer('18.21;');
  //PHYABULI
      ReadAnswer('18.215;');
  //SEXABU30
      ReadAnswer('18.22;');
  //SEXABULI
      ReadAnswer('18.225;');
  //FAMCONFL
      ReadAnswer('18.23;');
  //OTHCONFL
      ReadAnswer('18.24;');
  //PRAFPROB
      ReadAnswer('18.25;');
//DC    if ((frmMain.Partial_ASI = 'A') or (frmMain.Partial_ASI = 'F')) then
      if ((TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itFull) or
        (TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itFU)) then
    //PRASPROB
        ReadAnswer('18.26;');
  //FAMTMT
      ReadAnswer('18.27;');
//DC    if ((frmMain.Partial_ASI = 'A') or (frmMain.Partial_ASI = 'F')) then
      if ((TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itFull) or
        (TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itFU)) then
        begin
      //SOCTMT
          ReadAnswer('18.28;');
      //ISRFS
          ReadAnswer('18.29;');
        end;
  //FSMISREP
      ReadAnswer('18.31;');
  //FSPUND
      ReadAnswer('18.32;');

  // Psych ----------------------------------------------------------
  //INPSYC
      ReadAnswer('19.01;');
  //OUTPSYC
      ReadAnswer('19.02;');
  //PSYCPEN
      ReadAnswer('19.03;');
  //DEPR30
      ReadAnswer('19.04;');
  //DEPRLIFE
      ReadAnswer('19.05;');
  //ANXT30
      ReadAnswer('19.06;');
  //ANXTLIFE
      ReadAnswer('19.07;');
  //HALL30
      ReadAnswer('19.08;');
  //HALLLIFE
      ReadAnswer('19.09;');
  //UNDER30
      ReadAnswer('19.11;');
  //UNDERLIF
      ReadAnswer('19.12;');
  //VIOL30
      ReadAnswer('19.14;');
  //VIOLLIFE
      ReadAnswer('19.15;');
  //SUITH30
      ReadAnswer('19.16;');
  //SUITHLIF
      ReadAnswer('19.17;');
  //SUIAT30
      ReadAnswer('19.18;');
  //SUIATLIF
      ReadAnswer('19.19;');
  //PMED30
      ReadAnswer('19.21;');
  //PMEDLIFE
      ReadAnswer('19.22;');
  //PSYCDAYS
      ReadAnswer('19.23;');
  //PRATPSY
      ReadAnswer('19.24;');
  //PSYTMT
      ReadAnswer('19.25;');
//DC    if ((frmMain.Partial_ASI = 'A') or (frmMain.Partial_ASI = 'F')) then
      if ((TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itFull) or
        (TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itFU)) then
        begin
      //DEPNOW
          ReadAnswer('19.26;');
      //HOSTNOW
          ReadAnswer('19.27;');
      //ANXNOW
          ReadAnswer('19.28;');
      //REALNOW
          ReadAnswer('19.29;');
      //COMPRNOW
          ReadAnswer('19.31;');
      //SUICNOW
          ReadAnswer('19.32;');
      //ISRPSYC
          ReadAnswer('19.33;');
        end;
  //PMISREP
      ReadAnswer('19.34;');
  //PSPUND
      ReadAnswer('19.35;');
      ReadAnswer('Done');
//      lvPartialList.SaveToFile('aaaParital.txt');

    end;

end;

procedure ASI_InsertItems;
// This puts the data from the dark-side into the ASI form. This occurs when the
// user wants to edit and/or sign a uncomplete ASI.
var
  Response                    : string;
  S                           : string[10];
  i                           : integer;
label
  Skip;

  procedure RadioGroup(Item: TRzRadioGroup; Start, X, N: integer; Answer: string);
  var
    j                         : integer;
  begin
    with frmMHA_ASI_Entry do
      begin
        for j := 0 to ComponentCount - 1 do
          if Components[j] is TRzRadioGroup then
            if TRzRadioGroup(Components[j]) = Item then
              begin
          // Legal List code 604.3, unique for these items
                if ((UpperCase(TRzRadioGroup(Components[j]).Name) = 'RGRPL23') or
                  (UpperCase(TRzRadioGroup(Components[j]).Name) = 'RGRPL25')) then
                  begin
                    if Answer = '3' then
                      TRzRadioGroup(Components[j]).ItemIndex := 0;
                    if Answer = '4' then
                      TRzRadioGroup(Components[j]).ItemIndex := 1;
                    if Answer = '5' then
                      TRzRadioGroup(Components[j]).ItemIndex := 2;
                    if Answer = '6' then
                      TRzRadioGroup(Components[j]).ItemIndex := 3;
                    if Answer = '7' then
                      TRzRadioGroup(Components[j]).ItemIndex := 4;
                    if Answer = '8' then
                      TRzRadioGroup(Components[j]).ItemIndex := 5;
                    if Answer = '9' then
                      TRzRadioGroup(Components[j]).ItemIndex := 6;
                    if Answer = '10' then
                      TRzRadioGroup(Components[j]).ItemIndex := 7;
                    if Answer = '11' then
                      TRzRadioGroup(Components[j]).ItemIndex := 8;
                    if Answer = '12' then
                      TRzRadioGroup(Components[j]).ItemIndex := 9;
                    if Answer = '13' then
                      TRzRadioGroup(Components[j]).ItemIndex := 10;
                    if Answer = '14.1' then
                      TRzRadioGroup(Components[j]).ItemIndex := 11;
                    if Answer = '14.2' then
                      TRzRadioGroup(Components[j]).ItemIndex := 12;
                    if Answer = '14.3' then
                      TRzRadioGroup(Components[j]).ItemIndex := 13;
                    if Answer = '16' then
                      TRzRadioGroup(Components[j]).ItemIndex := 14;
                    if Answer = '17' then
                      TRzRadioGroup(Components[j]).ItemIndex := 15;
                    if Answer = '18' then
                      TRzRadioGroup(Components[j]).ItemIndex := 16;
                    if Answer = '21' then
                      TRzRadioGroup(Components[j]).ItemIndex := 17;
                    if Answer = '20' then
                      TRzRadioGroup(Components[j]).ItemIndex := 18;
                    exit;
                  end;

                if UpperCase(TRzRadioGroup(Components[j]).Name) = 'RGRPD14' then
                  begin
                    if Answer = '100' then
                      TRzRadioGroup(Components[j]).ItemIndex := 0;
                    if Answer = '1' then
                      TRzRadioGroup(Components[j]).ItemIndex := 1;
                    if Answer = '2' then
                      TRzRadioGroup(Components[j]).ItemIndex := 2;
                    if Answer = '3' then
                      TRzRadioGroup(Components[j]).ItemIndex := 3;
                    if Answer = '4' then
                      TRzRadioGroup(Components[j]).ItemIndex := 4;
                    if Answer = '5' then
                      TRzRadioGroup(Components[j]).ItemIndex := 5;
                    if Answer = '6' then
                      TRzRadioGroup(Components[j]).ItemIndex := 6;
                    if Answer = '7' then
                      TRzRadioGroup(Components[j]).ItemIndex := 7;
                    if Answer = '8' then
                      TRzRadioGroup(Components[j]).ItemIndex := 8;
                    if Answer = '9' then
                      TRzRadioGroup(Components[j]).ItemIndex := 9;
                    if Answer = '10' then
                      TRzRadioGroup(Components[j]).ItemIndex := 10;
                    if Answer = '11' then
                      TRzRadioGroup(Components[j]).ItemIndex := 11;
                    if Answer = '12' then
                      TRzRadioGroup(Components[j]).ItemIndex := 12;
                    if Answer = '15' then
                      TRzRadioGroup(Components[j]).ItemIndex := 13;
                    if Answer = '16' then
                      TRzRadioGroup(Components[j]).ItemIndex := 14;
                    if Answer = 'X' then
                      TRzRadioGroup(Components[j]).ItemIndex := 15;
                    if Answer = 'N' then
                      TRzRadioGroup(Components[j]).ItemIndex := 16;
                    exit;
                  end;

                if Answer = 'X' then
                  begin
                    TRzRadioGroup(Components[j]).ItemIndex := X;
                    exit;
                  end;
                if Answer = 'N' then
                  begin
                    TRzRadioGroup(Components[j]).ItemIndex := N;
                    exit;
                  end;

                if ((Answer = '') or (Answer = ' ')) then
                  Answer := '-1';
                TRzRadioGroup(Components[j]).ItemIndex := StrToInt(Answer);
            // The follow makes no sense but it is necessary.
                if ((TRzRadioGroup(Components[j]).Name = 'rgrpG8') or
                  (TRzRadioGroup(Components[j]).Name = 'rgrpG9') or
                  (TRzRadioGroup(Components[j]).Name = 'rgrpG12') or
                  (TRzRadioGroup(Components[j]).Name = 'rgrpG17') or
                  (TRzRadioGroup(Components[j]).Name = 'rgrpG18') or
                  (TRzRadioGroup(Components[j]).Name = 'rgrpG19') or
                  (TRzRadioGroup(Components[j]).Name = 'rgrpM7') or
                  (TRzRadioGroup(Components[j]).Name = 'rgrpM8') or
                  (TRzRadioGroup(Components[j]).Name = 'rgrpE7') or
                  (TRzRadioGroup(Components[j]).Name = 'rgrpE10') or
                  (TRzRadioGroup(Components[j]).Name = 'rgrpE20') or
                  (TRzRadioGroup(Components[j]).Name = 'rgrpE21') or
                  (TRzRadioGroup(Components[j]).Name = 'rgrpD28') or
                  (TRzRadioGroup(Components[j]).Name = 'rgrpD29') or
                  (TRzRadioGroup(Components[j]).Name = 'rgrpD30') or
                  (TRzRadioGroup(Components[j]).Name = 'rgrpD31') or
                  (TRzRadioGroup(Components[j]).Name = 'rgrpL28') or
                  (TRzRadioGroup(Components[j]).Name = 'rgrpL29') or
                  (TRzRadioGroup(Components[j]).Name = 'rgrpF1') or
                  (TRzRadioGroup(Components[j]).Name = 'rgrpF4') or
                  (TRzRadioGroup(Components[j]).Name = 'rgrpF9') or
                  (TRzRadioGroup(Components[j]).Name = 'rgrpF32') or
                  (TRzRadioGroup(Components[j]).Name = 'rgrpF33') or
                  (TRzRadioGroup(Components[j]).Name = 'rgrpF34') or
                  (TRzRadioGroup(Components[j]).Name = 'rgrpF35') or
                  (TRzRadioGroup(Components[j]).Name = 'rgrpP12') or
                  (TRzRadioGroup(Components[j]).Name = 'rgrpP13')) then
                  TRzRadioGroup(Components[j]).ItemIndex := StrToInt(Answer) - 1;
              end;
      end;
  end; // Radio Group

  procedure ComboBox(Item: TRzComboBox; X, N: integer; Answer: string);
  var
    m, z                      : integer;
    valid                     : boolean;
  begin
    with frmMHA_ASI_Entry do
      begin
        if Length(Answer) > 2 then
          exit;
        for m := 0 to ComponentCount - 1 do
          if Components[m] is TRzComboBox then
            if TRzComboBox(Components[m]) = Item then
              begin
          // cbxD1r...cbxD12r use '98' to refer to 'X'
                if Answer = '98' then
                  begin
                    TRzComboBox(Components[m]).ItemIndex := X;
                    exit;
                  end;
                if Answer = 'X' then
                  begin
                    TRzComboBox(Components[m]).ItemIndex := X;
                    exit;
                  end;
                if Answer = 'N' then
                  begin
                    TRzComboBox(Components[m]).ItemIndex := N;
                    exit;
                  end;

                Valid := false;
                for z := 1 to Length(Answer) do
                  if Answer[z] in ['0'..'9'] then
                    Valid := true
                  else
                    Valid := false;

                if Valid then
                  TRzComboBox(Components[m]).ItemIndex := StrToInt(Answer) - 1
                else
                  TRzComboBox(Components[m]).ItemIndex := -1;
              end;
      end;
  end; // TRzComboBox

  procedure Combo(Item: TComboBox; Answer: string);
  var
    h                         : integer;
  begin
    with frmMHA_ASI_Entry do
      begin
        if Length(Answer) = 0 then
          exit;
        for h := 0 to ComponentCount - 1 do
          if Components[h] is TComboBox then
            if TComboBox(Components[h]) = Item then
              TComboBox(Components[h]).text := Answer;
      end;
  end; // Combo

  procedure ORCombo(Item: TORComboBox; Answer: string);
  // This is the IENS for the program or staff item
  var
    h                         : integer;
  begin
    with frmMHA_ASI_Entry do
      begin
        if Length(Answer) = 0 then
          exit;
        for h := 0 to ComponentCount - 1 do
          if Components[h] is TORComboBox then
            if TORComboBox(Components[h]) = Item then
              begin
                if TORComboBox(Components[h]).Name = 'cbxG3' then
                  cbxG3.SelectByIEN(StrToInt(Answer));

//            if TORComboBox(Components[h]).Name = 'cbxG11' then
//            begin
//                // Get staff name, we have IEN already (i.e., Answer)
//                    DataModule1.ASI_FMGets1.FieldNumbers.Clear;
//                    DataModule1.ASI_FMGets1.AddField('.09');
//                    DataModule1.ASI_FMGets1.GetData;
//                    cbxG11.InitLongList(DataModule1.ASI_FMGets1.GetField('.09').FMDBExternal);
//                    cbxG11.SelectByIEN(StrToInt(Answer));
//            end;

              end;
      end;
  end; // ORCombo

  procedure Edit(Item, Answer: string);
  var
    k                         : integer;
  begin
    with frmMHA_ASI_Entry do
      begin
        if Length(Answer) < 1 then
          exit;

        for k := 0 to ComponentCount - 1 do
          begin
            if Components[k].ClassName = 'TRzEdit' then
              if TRzEdit(Components[k]).Name = Item then
                TRzEdit(Components[k]).text := Answer;

            if Components[k].ClassName = 'TEdit' then
              if TEdit(Components[k]).Name = Item then
                TEdit(Components[k]).text := Answer;
          end;
      end;
  end; // Edit

  procedure Date(Item: TDateTimePicker; Answer: string);
  //date is string of numbers, M style.
  var
    l                         : integer;
  begin
    with frmMHA_ASI_Entry do
      begin
        if Length(Answer) < 1 then
          exit;
        for l := 0 to ComponentCount - 1 do
          begin
            if Components[l] is TDateTimePicker then
              if TDateTimePicker(Components[l]) = Item then
                TDateTimePicker(Components[l]).date :=
                  FMDateTimeToDateTime(StrToFloat(Answer)); //Convert M date to Tdate
          end;
      end;
  end; // Date


begin
  with frmMHA_ASI_Entry do
    begin
      ASI_MakePartialList;

      for i := 0 to lvPartialList.Count - 1 do
        begin
          S := '';
          Response := '';
          S := Piece(lvPartialList[i], ';', 1);
          Response := Piece(lvPartialList[i], ';', 2);
      // ignore the blank responses
          if Response = '' then
            goto Skip;

// General ----------------------------------------------------
          if S = '1' then
            Date(dtpG4, Response);
          if S = '2' then
            ORCombo(cbxG3, Response);
//*    if S = '.02' then Patient.DFN := Response;
          if S = '.04' then
            RadioGroup(rgrpG8, 1, -1, -1, Response);
          if S = '.05' then
            Date(dtpG5, Response);
          if S = '.07' then
            RadioGroup(rgrpG9, 1, -1, -1, Response);
          if S = '.81' then // Interviewer
            ORCombo(cbxG11Interviewerx, Response);
          if S = '.09' then // Ordered by
            ORCombo(cbxG11OrderedByx, Response);
          if S = '.11' then
            RadioGroup(rgrpG12, 1, -1, 3, Response);
          if S = '1.201' then
            Edit('edtG14y', Response);
          if S = '1.202' then
            Edit('edtG14m', Response);
          if S = '1.203' then
            RadioGroup(rgrpG15, 0, 2, -1, Response);
          if S = '.16' then
            RadioGroup(rgrpG17, 1, -1, -1, Response);
          if S = '.17' then
            RadioGroup(rgrpG18, 1, -1, -1, Response);
          if S = '2.01' then
            RadioGroup(rgrpG19, 1, 6, 7, Response);
          if S = '2.02' then
            Edit('edtG19e', Response);
          if S = '2.03' then
            Edit('edtG20', Response);

// Medical ----------------------------------------------------
          if S = '8.01' then
            Edit('edtM1', Response);
          if S = '8.02' then
            Edit('edtM2y', Response);
          if S = '8.025' then
            Edit('edtM2m', Response);
          if S = '8.03' then
            RadioGroup(rgrpM3, 0, 2, -1, Response);
          if S = '8.04' then
            Edit('edtM3e', Response);
          if S = '8.05' then
            RadioGroup(rgrpM4, 0, 2, -1, Response);
          if S = '8.06' then
            RadioGroup(rgrpM5, 0, 2, -1, Response);
          if S = '8.07' then
            Edit('edtM5e', Response);
          if S = '8.08' then
            Edit('edtM6', Response);
          if S = '8.09' then
            RadioGroup(rgrpM7, 0, 5, -1, Response);
          if S = '8.11' then
            RadioGroup(rgrpM8, 0, 5, -1, Response);
          if S = '8.12' then
            RadioGroup(rgrpM9, 0, 10, -1, Response);
          if S = '8.14' then
            RadioGroup(rgrpM10, 0, 2, -1, Response);
          if S = '8.15' then
            RadioGroup(rgrpM11, 0, 2, -1, Response);
      // Comment field is below

// Education --------------------------------------------------
          if S = '9.01' then
            Edit('edtE1y', Response);
          if S = '9.02' then
            Edit('edtE1m', Response);
          if S = '9.03' then
            Edit('edtE2', Response);
          if S = '9.04' then
            RadioGroup(rgrpE3, 0, 2, -1, Response);
          if S = '9.05' then
            Edit('edtE3e', Response);
          if S = '9.06' then
            RadioGroup(rgrpE4, 0, 2, -1, Response);
          if S = '9.09' then
            RadioGroup(rgrpE5, 0, 2, -1, Response);
          if S = '9.11' then
            Edit('edtE6y', Response);
          if S = '9.12' then
            Edit('edtE6m', Response);
          if S = '9.14' then
            RadioGroup(rgrpE7, 1, -1, 9, Response);
          if S = '9.145' then
            Edit('edtE7e', Response);
          if S = '9.15' then
            RadioGroup(rgrpE8, 0, 2, -1, Response);
          if S = '9.16' then
            RadioGroup(rgrpE9, 0, 2, 3, Response);
          if S = '9.17' then
            RadioGroup(rgrpE10, 1, 8, 9, Response);
          if S = '9.18' then
            Edit('edtE11', Response);
          if S = '9.19' then
            Edit('edtE12', Response);
          if S = '9.21' then
            Edit('edtE13', Response);
          if S = '9.22' then
            Edit('edtE14', Response);
          if S = '9.23' then
            Edit('edtE15', Response);
          if S = '9.24' then
            Edit('edtE16', Response);
          if S = '9.25' then
            Edit('edtE17', Response);
          if S = '9.29' then
            Edit('edtE18', Response);
          if S = '9.31' then
            Edit('edtE19', Response);
          if S = '9.32' then
            RadioGroup(rgrpE20, 0, 5, 6, Response);
          if S = '9.33' then
            RadioGroup(rgrpE21, 0, 5, 6, Response);
          if S = '9.34' then
            RadioGroup(rgrpE22, 0, 10, -1, Response);
          if S = '9.35' then
            RadioGroup(rgrpE23, 0, 2, -1, Response);
          if S = '9.36' then
            RadioGroup(rgrpE24, 0, 2, -1, Response);
       // Comment field is below

// Drug -----------------------------------------------------
          if S = '10.01' then
            Edit('edtD1d', Response);
          if S = '10.02' then
            Edit('edtD1y', Response);
          if S = '10.03' then
            ComboBox(cbxD1r, 5, -1, Response);
          if S = '10.04' then
            Edit('edtD2d', Response);
          if S = '10.05' then
            Edit('edtD2y', Response);
          if S = '10.06' then
            ComboBox(cbxD2r, 5, -1, Response);
          if S = '10.07' then
            Edit('edtD3d', Response);
          if S = '10.08' then
            Edit('edtD3y', Response);
          if S = '10.09' then
            ComboBox(cbxD3r, 5, -1, Response);
          if S = '10.11' then
            Edit('edtD4d', Response);
          if S = '10.12' then
            Edit('edtD4y', Response);
          if S = '10.14' then
            ComboBox(cbxD4r, 5, -1, Response);
          if S = '10.15' then
            Edit('edtD5d', Response);
          if S = '10.16' then
            Edit('edtD5y', Response);
          if S = '10.17' then
            ComboBox(cbxD5r, 5, -1, Response);
          if S = '10.18' then
            Edit('edtD6d', Response);
          if S = '10.19' then
            Edit('edtD6y', Response);
          if S = '10.21' then
            ComboBox(cbxD6r, 5, -1, Response);
          if S = '10.22' then
            Edit('edtD7d', Response);
          if S = '10.23' then
            Edit('edtD7y', Response);
          if S = '10.24' then
            ComboBox(cbxD7r, 5, -1, Response);
          if S = '10.25' then
            Edit('edtD8d', Response);
          if S = '10.26' then
            Edit('edtD8y', Response);
          if S = '10.27' then
            ComboBox(cbxD8r, 5, -1, Response);
          if S = '10.28' then
            Edit('edtD9d', Response);
          if S = '10.29' then
            Edit('edtD9y', Response);
          if S = '10.31' then
            ComboBox(cbxD9r, 5, -1, Response);
          if S = '10.32' then
            Edit('edtD10d', Response);
          if S = '10.33' then
            Edit('edtD10y', Response);
          if S = '10.34' then
            ComboBox(cbxD10r, 5, -1, Response);
          if S = '10.35' then
            Edit('edtD11d', Response);
          if S = '10.36' then
            Edit('edtD11y', Response);
          if S = '10.37' then
            ComboBox(cbxD11r, 5, -1, Response);
          if S = '10.38' then
            Edit('edtD12d', Response);
          if S = '10.39' then
            Edit('edtD12y', Response);
          if S = '10.41' then
            ComboBox(cbxD12r, 5, -1, Response);
          if S = '10.42' then
            Edit('edtD13d', Response);
          if S = '10.43' then
            Edit('edtD13y', Response);
          if S = '10.45' then
            RadioGroup(rgrpD14, 0, -1, -1, Response);

          if S = '11.01' then
            Edit('edtD15', Response);
          if S = '11.02' then
            Edit('edtD16', Response);
          if S = '11.03' then
            Edit('edtD17', Response);
          if S = '11.04' then
            Edit('edtD18', Response);
          if S = '11.05' then
            Edit('edtD19', Response);
          if S = '11.06' then
            Edit('edtD20', Response);
          if S = '11.07' then
            Edit('edtD21', Response);
          if S = '11.08' then
            Edit('edtD22', Response);
          if S = '11.09' then
            Edit('edtD23', Response);
          if S = '11.11' then
            Edit('edtD24', Response);
          if S = '11.12' then
            Edit('edtD25', Response);
          if S = '11.14' then
            Edit('edtD26', Response);
          if S = '11.15' then
            Edit('edtD27', Response);
          if S = '11.16' then
            RadioGroup(rgrpD28, 0, 5, 6, Response);
          if S = '11.165' then
            RadioGroup(rgrpD29, 0, 5, 6, Response);
          if S = '11.17' then
            RadioGroup(rgrpD30, 0, 5, 6, Response);
          if S = '11.175' then
            RadioGroup(rgrpD31, 0, 5, 6, Response);
          if S = '11.18' then
            RadioGroup(rgrpD32, 0, 10, 11, Response);
          if S = '11.185' then
            RadioGroup(rgrpD33, 0, 10, -1, Response);
          if S = '11.19' then
            RadioGroup(rgrpD34, 0, 2, -1, Response);
          if S = '11.21' then
            RadioGroup(rgrpD35, 0, -1, -1, Response);
    // Comment field is below

//Legal -------------------------------------------------------
          if S = '14.01' then
            RadioGroup(rgrpL1, 0, 2, -1, Response);
          if S = '14.02' then
            RadioGroup(rgrpL2, 0, 2, -1, Response);
          if S = '14.03' then
            Edit('edtL3', Response);
          if S = '14.04' then
            Edit('edtL4', Response);
          if S = '14.05' then
            Edit('edtL5', Response);
          if S = '14.06' then
            Edit('edtL6', Response);
          if S = '14.07' then
            Edit('edtL7', Response);
          if S = '14.08' then
            Edit('edtL8', Response);
          if S = '14.09' then
            Edit('edtL9', Response);
          if S = '14.11' then
            Edit('edtL10', Response);
          if S = '14.12' then
            Edit('edtL11', Response);
          if S = '14.14' then
            Edit('edtL12', Response);
          if S = '14.15' then
            Edit('edtL13', Response);
          if S = '14.16' then
            Edit('edtL14', Response);
          if S = '14.17' then
            Edit('edtL15', Response);
          if S = '14.18' then
            Edit('edtL16', Response);
          if S = '14.19' then
            Edit('edtL17', Response);
          if S = '14.21' then
            Edit('edtL18', Response);
          if S = '14.22' then
            Edit('edtL19', Response);
          if S = '14.23' then
            Edit('edtL20', Response);
          if S = '14.24' then
            Edit('edtL21', Response);
          if S = '14.25' then
            Edit('edtL22', Response);
          if S = '14.26' then
            RadioGroup(rgrpL23, 0, 0, 0, Response);
          if S = '14.27' then
            RadioGroup(rgrpL24, 0, 2, -1, Response);
          if S = '14.28' then
            RadioGroup(rgrpL25, 0, 0, 0, Response);
          if S = '14.29' then
            Edit('edtL26', Response);
          if S = '14.31' then
            Edit('edtL27', Response);
          if S = '14.32' then
            RadioGroup(rgrpL28, 0, 5, 6, Response);
          if S = '14.33' then
            RadioGroup(rgrpL29, 0, 5, 6, Response);
          if S = '14.34' then
            RadioGroup(rgrpL30, 0, 10, -1, Response);
          if S = '14.35' then
            RadioGroup(rgrpL31, 0, 2, -1, Response);
          if S = '14.36' then
            RadioGroup(rgrpL32, 0, 2, -1, Response);
       // Comment field is below

// Family -----------------------------------------------------
          if S = '15.01' then
            ComboBox(cbxH1a, 2, 3, Response);
          if S = '15.02' then
            ComboBox(cbxH1d, 2, 3, Response);
          if S = '15.03' then
            ComboBox(cbxH1p, 2, 3, Response);
          if S = '15.04' then
            ComboBox(cbxH2a, 2, 3, Response);
          if S = '15.05' then
            ComboBox(cbxH2d, 2, 3, Response);
          if S = '15.06' then
            ComboBox(cbxH2p, 2, 3, Response);
          if S = '15.07' then
            ComboBox(cbxH3a, 2, 3, Response);
          if S = '15.08' then
            ComboBox(cbxH3d, 2, 3, Response);
          if S = '15.09' then
            ComboBox(cbxH3p, 2, 3, Response);
          if S = '15.11' then
            ComboBox(cbxH4a, 2, 3, Response);
          if S = '15.12' then
            ComboBox(cbxH4d, 2, 3, Response);
          if S = '15.14' then
            ComboBox(cbxH4p, 2, 3, Response);
          if S = '15.15' then
            ComboBox(cbxH5a, 2, 3, Response);
          if S = '15.16' then
            ComboBox(cbxH5d, 2, 3, Response);
          if S = '15.17' then
            ComboBox(cbxH5p, 2, 3, Response);
          if S = '15.18' then
            ComboBox(cbxH6a, 2, 3, Response);
          if S = '15.19' then
            ComboBox(cbxH6d, 2, 3, Response);
          if S = '15.21' then
            ComboBox(cbxH6p, 2, 3, Response);
          if S = '15.22' then
            ComboBox(cbxH7a, 2, 3, Response);
          if S = '15.23' then
            ComboBox(cbxH7d, 2, 3, Response);
          if S = '15.24' then
            ComboBox(cbxH7p, 2, 3, Response);
          if S = '15.25' then
            ComboBox(cbxH8a, 2, 3, Response);
          if S = '15.26' then
            ComboBox(cbxH8d, 2, 3, Response);
          if S = '15.27' then
            ComboBox(cbxH8p, 2, 3, Response);

          if S = '16.01' then
            ComboBox(cbxH9a, 2, 3, Response);
          if S = '16.02' then
            ComboBox(cbxH9d, 2, 3, Response);
          if S = '16.03' then
            ComboBox(cbxH9p, 2, 3, Response);
          if S = '16.04' then
            ComboBox(cbxH10a, 2, 3, Response);
          if S = '16.05' then
            ComboBox(cbxH10d, 2, 3, Response);
          if S = '16.06' then
            ComboBox(cbxH10p, 2, 3, Response);
          if S = '16.07' then
            ComboBox(cbxH11a, 2, 3, Response);
          if S = '16.08' then
            ComboBox(cbxH11d, 2, 3, Response);
          if S = '16.09' then
            ComboBox(cbxH11p, 2, 3, Response);
          if S = '16.11' then
            ComboBox(cbxH12a, 2, 3, Response);
          if S = '16.12' then
            ComboBox(cbxH12d, 2, 3, Response);
          if S = '16.14' then
            ComboBox(cbxH12p, 2, 3, Response);
       // Comment field is below

// Social -----------------------------------------------------
          if S = '17.01' then
            RadioGroup(rgrpF1, 1, 6, -1, Response);
          if S = '17.02' then
            Edit('edtF2y', Response);
          if S = '17.03' then
            Edit('edtF2m', Response);
          if S = '17.04' then
            RadioGroup(rgrpF3, 0, 3, 4, Response);
          if S = '17.05' then
            RadioGroup(rgrpF4, 1, 9, 10, Response);
          if S = '17.06' then
            Edit('edtF5y', Response);
          if S = '17.07' then
            Edit('edtF5m', Response);
          if S = '17.08' then
            RadioGroup(rgrpF6, 0, 3, 4, Response);
          if S = '17.09' then
            RadioGroup(rgrpF7, 0, 2, -1, Response);
          if S = '17.11' then
            RadioGroup(rgrpF8, 0, 2, -1, Response);
          if S = '17.12' then
            RadioGroup(rgrpF9, 1, 3, 4, Response);
          if S = '17.14' then
            RadioGroup(rgrpF10, 0, 3, 4, Response);
          if S = '17.15' then
            Edit('edtF11', Response);
          if S = '17.16' then
            ComboBox(cbxF12, 2, 3, Response);
          if S = '17.17' then
            ComboBox(cbxF13, 2, 3, Response);
          if S = '17.18' then
            ComboBox(cbxF14, 2, 3, Response);
          if S = '17.19' then
            ComboBox(cbxF15, 2, 3, Response);
          if S = '17.21' then
            ComboBox(cbxF16, 2, 3, Response);
          if S = '17.22' then
            ComboBox(cbxF17, 2, 3, Response);

          if S = '18.01' then
            RadioGroup(rgrpF18, 0, 2, 3, Response);
          if S = '18.02' then
            RadioGroup(rgrpF18l, 0, 2, 3, Response);
          if S = '18.03' then
            RadioGroup(rgrpF19, 0, 2, 3, Response);
          if S = '18.04' then
            RadioGroup(rgrpF19l, 0, 2, 3, Response);
          if S = '18.05' then
            RadioGroup(rgrpF20, 0, 2, 3, Response);
          if S = '18.06' then
            RadioGroup(rgrpF20l, 0, 2, 3, Response);
          if S = '18.07' then
            RadioGroup(rgrpF21, 0, 2, 3, Response);
          if S = '18.08' then
            RadioGroup(rgrpF21l, 0, 2, 3, Response);
          if S = '18.09' then
            RadioGroup(rgrpF22, 0, 2, 3, Response);
          if S = '18.11' then
            RadioGroup(rgrpF22l, 0, 2, 3, Response);
          if S = '18.12' then
            RadioGroup(rgrpF23, 0, 2, 3, Response);
          if S = '18.14' then
            RadioGroup(rgrpF23l, 0, 2, 3, Response);
          if S = '18.15' then
            RadioGroup(rgrpF24, 0, 2, 3, Response);
          if S = '18.16' then
            RadioGroup(rgrpF24l, 0, 2, 3, Response);
          if S = '18.17' then
            RadioGroup(rgrpF25, 0, 2, 3, Response);
          if S = '18.18' then
            RadioGroup(rgrpF25l, 0, 2, 3, Response);
          if S = '18.185' then
            RadioGroup(rgrpF26, 0, 2, 3, Response);
          if S = '18.186' then
            RadioGroup(rgrpF26l, 0, 2, 3, Response);
          if S = '18.19' then
            RadioGroup(rgrpF27, 0, 2, 3, Response);
          if S = '18.195' then
            RadioGroup(rgrpF27l, 0, 2, 3, Response);
          if S = '18.21' then
            RadioGroup(rgrpF28, 0, 2, 3, Response);
          if S = '18.215' then
            RadioGroup(rgrpF28l, 0, 2, 3, Response);
          if S = '18.22' then
            RadioGroup(rgrpF29, 0, 2, 3, Response);
          if S = '18.225' then
            RadioGroup(rgrpF29l, 0, 2, 3, Response);
          if S = '18.23' then
            Edit('edtF30', Response);
          if S = '18.24' then
            Edit('edtF31', Response);
          if S = '18.25' then
            RadioGroup(rgrpF32, 0, 5, 6, Response);
          if S = '18.26' then
            RadioGroup(rgrpF33, 0, 5, 6, Response);
          if S = '18.27' then
            RadioGroup(rgrpF34, 0, 5, 6, Response);
          if S = '18.28' then
            RadioGroup(rgrpF35, 0, 5, 6, Response);
          if S = '18.29' then
            RadioGroup(rgrpF36, 0, 10, -1, Response);
          if S = '18.31' then
            RadioGroup(rgrpF37, 0, 2, -1, Response);
          if S = '18.32' then
            RadioGroup(rgrpF38, 0, 2, -1, Response);
       // Comment field is below

// Psych ------------------------------------------------------
          if S = '19.01' then
            Edit('edtP1a', Response);
          if S = '19.02' then
            Edit('edtP1b', Response);
          if S = '19.03' then
            RadioGroup(rgrpP2, 0, 2, -1, Response);
          if S = '19.04' then
            RadioGroup(rgrpP3, 0, 2, -1, Response);
          if S = '19.05' then
            RadioGroup(rgrpP3l, 0, 2, -1, Response);
          if S = '19.06' then
            RadioGroup(rgrpP4, 0, 2, -1, Response);
          if S = '19.07' then
            RadioGroup(rgrpP4l, 0, 2, -1, Response);
          if S = '19.08' then
            RadioGroup(rgrpP5, 0, 2, -1, Response);
          if S = '19.09' then
            RadioGroup(rgrpP5l, 0, 2, -1, Response);
          if S = '19.11' then
            RadioGroup(rgrpP6, 0, 2, -1, Response);
          if S = '19.12' then
            RadioGroup(rgrpP6l, 0, 2, -1, Response);
          if S = '19.14' then
            RadioGroup(rgrpP7, 0, 2, -1, Response);
          if S = '19.15' then
            RadioGroup(rgrpP7l, 0, 2, -1, Response);
          if S = '19.16' then
            RadioGroup(rgrpP8, 0, 2, -1, Response);
          if S = '19.17' then
            RadioGroup(rgrpP8l, 0, 2, -1, Response);
          if S = '19.18' then
            RadioGroup(rgrpP9, 0, 2, -1, Response);
          if S = '19.19' then
            RadioGroup(rgrpP9l, 0, 2, -1, Response);
          if S = '19.21' then
            RadioGroup(rgrpP10, 0, 2, -1, Response);
          if S = '19.22' then
            RadioGroup(rgrpP10l, 0, 2, -1, Response);
          if S = '19.23' then
            Edit('edtP11', Response);
          if S = '19.24' then
            RadioGroup(rgrpP12, 0, 5, -1, Response);
          if S = '19.25' then
            RadioGroup(rgrpP13, 0, 5, -1, Response);
          if S = '19.26' then
            RadioGroup(rgrpP14, 0, 2, -1, Response);
          if S = '19.27' then
            RadioGroup(rgrpP15, 0, 2, -1, Response);
          if S = '19.28' then
            RadioGroup(rgrpP16, 0, 2, -1, Response);
          if S = '19.29' then
            RadioGroup(rgrpP17, 0, 2, -1, Response);
          if S = '19.31' then
            RadioGroup(rgrpP18, 0, 2, -1, Response);
          if S = '19.32' then
            RadioGroup(rgrpP19, 0, 2, -1, Response);
          if S = '19.33' then
            RadioGroup(rgrpP20, 0, 10, -1, Response);
          if S = '19.34' then
            RadioGroup(rgrpP21, 0, 2, -1, Response);
          if S = '19.35' then
            RadioGroup(rgrpP22, 0, 2, -1, Response);
       // Comment field is below
          skip:
        end;

      ASI_LoadCommentFields(TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).IENS);

      if lvPartialList <> nil then
        lvPartialList.Free;
    end;
end;


procedure ASI_BuildForm;
begin

  with frmMHA_ASI_Entry do
    begin
  //"Initialize" is necessary to turn off TRzRadioGroupClicks.

      with cbxG11Interviewerx do
        begin
          InitLongList(TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewerName);
          SelectByIEN(StrToInt(TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewerDUZ));
        end;

      with cbxG11OrderedByx do
        begin
          InitLongList(TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).OrderedByName);
          SelectByIEN(StrToInt(TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).OrderedbyDUZ));
        end;

      case TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType of

        itFull:
          begin
            if not TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).IENSExist then
              // A new Full ASI
              begin
                rgrpG8.ItemIndex := 0;
                TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).IENS := '';
                ASI_SetUpFull;
              end
            else
              // A partial Full ASI
              begin
                rgrpG8.ItemIndex := 0;
                ASI_SetUpFull;
                ASI_InsertItems; // Data pulled from dark-side
              end;
          end;

        itLite, itMV:
          begin
            if not TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).IENSExist then
              // A new Lite ASI
              begin
                rgrpG8.ItemIndex := 1;
                TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).IENS := '';
                ASI_SetUpLite;
              end
            else
              begin
                rgrpG8.ItemIndex := 1;
                ASI_SetUpLite;
                if TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).IENSExist then
                  ASI_InsertItems; // Data pulled from dark-side
              end;
          end;

        itFU:
          begin
            if not TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).IENSExist then
              // A new followup ASI
              begin
                rgrpG8.ItemIndex := 2;
                TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).IENS := '';
                ASI_SetUpFollowup;
              end
            else
              begin
                rgrpG8.ItemIndex := 2;
                ASI_SetUpFollowup;
                if TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).IENSExist then
                  ASI_InsertItems; // Data pulled from dark-side
              end;
          end;
      end; //case
    end;
end;

procedure ASI_SetupComboBoxItems;
// run-time contruction of the strings for combo boxes
var
  TempStr                     : TStringList;
begin
  with frmMHA_ASI_Entry do
    begin
      TempStr := TStringList.Create;
      TempStr.Add('0. Clearly NO for all relatives in that category');
      TempStr.Add('1. Clearly YES for any relatives in that category');
      TempStr.Add('X. Uncertain or don''t know');
      TempStr.Add('N. No relative in that category');

      cbxH1a.Items.Assign(TempStr);
      cbxH2a.Items.Assign(TempStr);
      cbxH3a.Items.Assign(TempStr);
      cbxH4a.Items.Assign(TempStr);
      cbxH5a.Items.Assign(TempStr);
      cbxH6a.Items.Assign(TempStr);
      cbxH7a.Items.Assign(TempStr);
      cbxH8a.Items.Assign(TempStr);
      cbxH9a.Items.Assign(TempStr);
      cbxH10a.Items.Assign(TempStr);
      cbxH11a.Items.Assign(TempStr);
      cbxH12a.Items.Assign(TempStr);

      cbxH1d.Items.Assign(TempStr);
      cbxH2d.Items.Assign(TempStr);
      cbxH3d.Items.Assign(TempStr);
      cbxH4d.Items.Assign(TempStr);
      cbxH5d.Items.Assign(TempStr);
      cbxH6d.Items.Assign(TempStr);
      cbxH7d.Items.Assign(TempStr);
      cbxH8d.Items.Assign(TempStr);
      cbxH9d.Items.Assign(TempStr);
      cbxH10d.Items.Assign(TempStr);
      cbxH11d.Items.Assign(TempStr);
      cbxH12d.Items.Assign(TempStr);

      cbxH1p.Items.Assign(TempStr);
      cbxH2p.Items.Assign(TempStr);
      cbxH3p.Items.Assign(TempStr);
      cbxH4p.Items.Assign(TempStr);
      cbxH5p.Items.Assign(TempStr);
      cbxH6p.Items.Assign(TempStr);
      cbxH7p.Items.Assign(TempStr);
      cbxH8p.Items.Assign(TempStr);
      cbxH9p.Items.Assign(TempStr);
      cbxH10p.Items.Assign(TempStr);
      cbxH11p.Items.Assign(TempStr);
      cbxH12p.Items.Assign(TempStr);

      cbxF12.Items.Assign(TempStr);
      cbxF13.Items.Assign(TempStr);
      cbxF14.Items.Assign(TempStr);
      cbxF15.Items.Assign(TempStr);
      cbxF16.Items.Assign(TempStr);
      cbxF17.Items.Assign(TempStr);

      TempStr.Clear;
      TempStr.Add('1. Oral ');
      TempStr.Add('2. Nasal');
      TempStr.Add('3. Smoking');
      TempStr.Add('4. Non IV injection');
      TempStr.Add('5. IV injection');
      TempStr.Add('X. Not Answered');
      cbxD1r.Items.Assign(TempStr);
      cbxD2r.Items.Assign(TempStr);
      cbxD3r.Items.Assign(TempStr);
      cbxD4r.Items.Assign(TempStr);
      cbxD5r.Items.Assign(TempStr);
      cbxD6r.Items.Assign(TempStr);
      cbxD7r.Items.Assign(TempStr);
      cbxD8r.Items.Assign(TempStr);
      cbxD9r.Items.Assign(TempStr);
      cbxD10r.Items.Assign(TempStr);
      cbxD11r.Items.Assign(TempStr);
      cbxD12r.Items.Assign(TempStr);
      TempStr.Free;
    end;
end;


//-------------------------------------------------------------------
//       Defaults & Captions: Full, Lite & Followup
//-------------------------------------------------------------------

procedure ASI_DefaultValuesForItems;
// These values are NOT from Allan Finkelstein's, ASI Quick Text.txt.
// Edit items are set to blank, and radio groups are unchecked.

begin
  with frmMHA_ASI_Entry do
    begin
  //    frmMHA_ASI_Entry.initialize := True;
  // Put a header in the comment
      if length(memGeneral.text) = 0 then
        memGeneral.text := 'General Comments:';
      if length(memMedical.text) = 0 then
        memMedical.text := 'Medical Status Comments:';
      if length(memEmploy.text) = 0 then
        memEmploy.text := 'Employment/Support Status Comments:';
      if length(memDrug.text) = 0 then
        memDrug.text := 'Drug/Alcohol Use Comments:';
      if length(memFamily.text) = 0 then
        memFamily.text := 'Family History Comments:';
      if length(memLegal.text) = 0 then
        memLegal.text := 'Legal Status Comments:';
      if length(memPsych.text) = 0 then
        memPsych.text := 'Psychiatric Status Comments:';
      if length(memSocial.text) = 0 then
        memSocial.text := 'Family/Social Relationships Comments:';

      if rgrpG9.ItemIndex = -1 then
        rgrpG9.ItemIndex := 0;
      if rgrpG12.ItemIndex = -1 then
        rgrpG12.ItemIndex := 3;
      if ((edtG14y.Enabled) and (edtG14y.text <> '')) then
        edtG14y.text := '';
      if ((edtG14m.Enabled) and (edtG14m.text <> '')) then
        edtG14m.text := '';
      if ((rgrpG15.Enabled) and (rgrpG15.ItemIndex <> -1)) then
        rgrpG15.ItemIndex := -1;
      rgrpG17.ItemIndex := -1;
      rgrpG18.ItemIndex := -1;
      rgrpG19.ItemIndex := -1;
      edtG19e.Text := '';
      edtG20.text := '';

      edtM1.Text := '';
      edtM2y.text := '';
      edtM2m.text := '';
      rgrpM3.ItemIndex := -1;
      edtM3e.text := '';
      rgrpM4.ItemIndex := -1;
      rgrpM5.ItemIndex := -1;
      edtM5e.text := '';
      edtM6.Text := '';
      rgrpM7.ItemIndex := -1;
      rgrpM8.ItemIndex := -1;
      rgrpM9.ItemIndex := -1;
      rgrpM10.ItemIndex := -1;
      rgrpM11.ItemIndex := -1;

      edtE1y.text := '';
      edtE1m.text := '';
      edtE2.text := '';
      rgrpE3.ItemIndex := -1;
      edtE3e.text := '';
      rgrpE4.ItemIndex := -1;
      rgrpE5.ItemIndex := -1;
      edtE6y.text := '';
      edtE6m.text := '';
      rgrpE7.ItemIndex := -1;
      edtE7e.text := '';
      rgrpE8.ItemIndex := -1;
      rgrpE9.ItemIndex := -1;
      rgrpE10.ItemIndex := -1;
      edtE11.text := '';
      edtE12.text := '0';
      edtE13.text := '0';
      edtE14.text := '0';
      edtE15.text := '0';
      edtE16.text := '0';
      edtE17.text := '0';
      edtE18.text := '';
      edtE19.text := '';
      rgrpE20.ItemIndex := -1;
      rgrpE21.ItemIndex := -1;
      rgrpE22.ItemIndex := -1;
      rgrpE23.ItemIndex := -1;
      rgrpE24.ItemIndex := -1;
  // Drug values are from Vista defaults
      if edtD1d.Text = '' then
        edtD1d.text := '0';
      edtD1y.text := '0';
  //if cbxD1r.Text = '' then
      cbxD1r.ItemIndex := 0;
      if edtD2d.Text = '' then
        edtD2d.text := '0';
      edtD2y.text := '0';
  //if cbxD2r.Text = '' then
      cbxD2r.ItemIndex := 0;
      edtD3d.text := '0';
      edtD3y.text := '0';
  //if cbxD3r.Text = '' then
      cbxD3r.ItemIndex := 4;
      edtD4d.text := '0';
      edtD4y.text := '0';
  //if cbxD4r.Text = '' then
      cbxD4r.ItemIndex := 0;
      edtD5d.text := '0';
      edtD5y.text := '0';
  //if cbxD5r.Text = '' then
      cbxD5r.ItemIndex := 0;
      edtD6d.text := '0';
      edtD6y.text := '0';
  //if cbxD6r.Text = '' then
      cbxD6r.ItemIndex := 0;
      edtD7d.text := '0';
      edtD7y.text := '0';
  //if cbxD7r.Text = '' then
      cbxD7r.ItemIndex := 0;
      edtD8d.text := '0';
      edtD8y.text := '0';
  //if cbxD8r.Text = '' then
      cbxD8r.ItemIndex := 1;
      edtD9d.text := '0';
      edtD9y.text := '0';
  //if cbxD9r.Text = '' then
      cbxD9r.ItemIndex := 0;
      edtD10d.text := '0';
      edtD10y.text := '0';
  //if cbxD10r.Text = '' then
      cbxD10r.ItemIndex := 2;
      edtD11d.text := '0';
      edtD11y.text := '0';
  //if cbxD11r.Text = '' then
      cbxD11r.ItemIndex := 0;
      edtD12d.text := '0';
      edtD12y.text := '0';
  //if cbxD12r.Text = '' then
      cbxD12r.ItemIndex := 1;
      edtD13d.text := '0';
      edtD13y.text := '0';

      rgrpD14.ItemIndex := -1;
      edtD15.text := '';
      edtD16.text := '';
      edtD17.text := '';
      edtD18.text := '';
      edtD19.text := ''; // blank required by program logic
      edtD20.text := ''; // blank required by program logic
      edtD21.text := '';
      edtD22.text := '';
      edtD23.text := '0';
      edtD24.text := '0';
      edtD25.text := '';
      edtD26.text := ''; // blank required by program logic
      edtD27.text := ''; // blank required by program logic
      rgrpD28.ItemIndex := -1;
      rgrpD29.ItemIndex := -1;
      rgrpD30.ItemIndex := -1;
      rgrpD31.ItemIndex := -1;
      rgrpD32.ItemIndex := -1;
      rgrpD33.ItemIndex := -1;
      rgrpD34.ItemIndex := -1;
      rgrpD35.ItemIndex := -1;

      rgrpL1.ItemIndex := -1;
      rgrpL2.ItemIndex := -1;
      edtL3.text := '0';
      edtL8.text := '0';
      edtL13.text := '0';
      edtL4.text := '0';
      edtL9.text := '0';
      edtL14.text := '0';
      edtL5.text := '0';
      edtL10.text := '0';
      edtL15.text := '0';
      edtL6.text := '0';
      edtL11.text := '0';
      edtL16.text := '0';
      edtL7.text := '0';
      edtL12.text := '0';
      edtL17.text := '0';
      edtL18.text := '0';
      edtL19.text := '0';
      edtL20.text := '0';
      edtL21.text := '';
      edtL22.text := '';
      rgrpL23.ItemIndex := -1;
      rgrpL24.ItemIndex := -1;
      rgrpL25.ItemIndex := -1;
      edtL26.text := '0';
      edtL27.text := '0';
      rgrpL28.ItemIndex := -1;
      rgrpL29.ItemIndex := -1;
      rgrpL30.ItemIndex := -1;
      rgrpL31.ItemIndex := -1;
      rgrpL32.ItemIndex := -1;
      if cbxH1a.Enabled then
        begin
          cbxH1a.ItemIndex := 0;
          cbxH1d.ItemIndex := 0;
          cbxH1p.ItemIndex := 0;
          cbxH2a.ItemIndex := 0;
          cbxH2d.ItemIndex := 0;
          cbxH2p.ItemIndex := 0;
          cbxH3a.ItemIndex := 0;
          cbxH3d.ItemIndex := 0;
          cbxH3p.ItemIndex := 0;
          cbxH4a.ItemIndex := 0;
          cbxH4d.ItemIndex := 0;
          cbxH4p.ItemIndex := 0;
          cbxH5a.ItemIndex := 0;
          cbxH5d.ItemIndex := 0;
          cbxH5p.ItemIndex := 0;
          cbxH6a.ItemIndex := 0;
          cbxH6d.ItemIndex := 0;
          cbxH6p.ItemIndex := 0;
          cbxH7a.ItemIndex := 0;
          cbxH7d.ItemIndex := 0;
          cbxH7p.ItemIndex := 0;
          cbxH8a.ItemIndex := 0;
          cbxH8d.ItemIndex := 0;
          cbxH8p.ItemIndex := 0;
          cbxH9a.ItemIndex := 0;
          cbxH9d.ItemIndex := 0;
          cbxH9p.ItemIndex := 0;
          cbxH10a.ItemIndex := 0;
          cbxH10d.ItemIndex := 0;
          cbxH10p.ItemIndex := 0;
          cbxH11a.ItemIndex := 0;
          cbxH11d.ItemIndex := 0;
          cbxH11p.ItemIndex := 0;
          cbxH12a.ItemIndex := 0;
          cbxH12d.ItemIndex := 0;
          cbxH12p.ItemIndex := 0;
        end;

      rgrpF1.ItemIndex := -1;
      edtF2y.Text := '';
      edtF2m.text := '';
      rgrpF3.ItemIndex := -1;
      rgrpF4.ItemIndex := -1;
      edtF5y.Text := '';
      edtF5m.text := '';
      rgrpF6.ItemIndex := -1;
      rgrpF7.ItemIndex := -1;
      rgrpF8.ItemIndex := -1;
      rgrpF9.ItemIndex := -1;
      rgrpF10.ItemIndex := -1;
      edtF11.text := '';
      cbxF12.ItemIndex := -1;
      cbxF13.ItemIndex := -1;
      cbxF14.ItemIndex := -1;
      cbxF15.ItemIndex := -1;
      cbxF16.ItemIndex := -1;
      cbxF17.ItemIndex := -1;
      rgrpF18.ItemIndex := -1;
      rgrpF18l.ItemIndex := -1;
      rgrpF19.ItemIndex := -1;
      rgrpF19l.ItemIndex := -1;
      rgrpF20.ItemIndex := -1;
      rgrpF20l.ItemIndex := -1;
      rgrpF21.ItemIndex := -1;
      rgrpF21l.ItemIndex := -1;
      rgrpF22.ItemIndex := -1;
      rgrpF22l.ItemIndex := -1;
      rgrpF23.ItemIndex := -1;
      rgrpF23l.ItemIndex := -1;
      rgrpF24.ItemIndex := -1;
      rgrpF24l.ItemIndex := -1;
      rgrpF25.ItemIndex := -1;
      rgrpF25l.ItemIndex := -1;
      rgrpF26.ItemIndex := -1;
      rgrpF26l.ItemIndex := -1;
      rgrpF27.ItemIndex := -1;
      rgrpF27l.ItemIndex := -1;
      rgrpF28.ItemIndex := -1;
      rgrpF28l.ItemIndex := -1;
      rgrpF29.ItemIndex := -1;
      rgrpF29l.ItemIndex := -1;
      edtF30.Text := '';
      edtF31.text := '';
      rgrpF32.ItemIndex := -1;
      rgrpF33.ItemIndex := -1;
      rgrpF34.ItemIndex := -1;
      rgrpF35.ItemIndex := -1;
      rgrpF36.ItemIndex := -1;
      rgrpF37.ItemIndex := -1;
      rgrpF38.ItemIndex := -1;

      edtP1a.text := '0';
      edtP1b.text := '0';
      rgrpP2.ItemIndex := -1;
      rgrpP3.ItemIndex := -1;
      rgrpP3l.ItemIndex := -1;
      rgrpP4.ItemIndex := -1;
      rgrpP4l.ItemIndex := -1;
      rgrpP5.ItemIndex := -1;
      rgrpP5l.ItemIndex := -1;
      rgrpP6.ItemIndex := -1;
      rgrpP6l.ItemIndex := -1;
      rgrpP7.ItemIndex := -1;
      rgrpP7l.ItemIndex := -1;
      rgrpP8.ItemIndex := -1;
      rgrpP8l.ItemIndex := -1;
      rgrpP9.ItemIndex := -1;
      rgrpP9l.ItemIndex := -1;
      rgrpP10.ItemIndex := -1;
      rgrpP10l.ItemIndex := -1;
      edtP11.text := '';
      rgrpP12.ItemIndex := -1;
      rgrpP13.ItemIndex := -1;
      rgrpP14.ItemIndex := -1;
      rgrpP15.ItemIndex := -1;
      rgrpP16.ItemIndex := -1;
      rgrpP17.ItemIndex := -1;
      rgrpP18.ItemIndex := -1;
      rgrpP19.ItemIndex := -1;
      rgrpP20.ItemIndex := -1;
      rgrpP21.ItemIndex := -1;
      rgrpP22.ItemIndex := -1;
    end;
end;

//-------------------------------------------------------------------
//             ASI items are placed on scroll box
//-------------------------------------------------------------------

procedure ASI_SetupFull;
begin
  with frmMHA_ASI_Entry do
    begin
      Screen.Cursor := crHourglass;
      TabFamily.TabVisible := true;
  // Make sure these questions are Visible
      lblG14.Visible := true;
      lblG14m.Visible := True;
      edtG14y.Visible := true;
      edtG14m.Visible := true;
      SpnG14y.Visible := TRUE;
      SpnG14m.Visible := true;
      rgrpG15.Visible := True;
      rgrpG17.Visible := True;
      rgrpG18.Visible := True;
      edtG19e.Color := clSilver;
      edtG19e.Enabled := false;

      lblM2.Visible := True;
      lblM2m.Visible := True;
      edtM2y.Visible := True;
      edtM2m.Visible := True;
      spnM2y.Visible := True;
      spnM2m.Visible := True;
      rgrpM3.Visible := True;
      edtM3e.Visible := true;
      edtM3e.Enabled := false;
      edtM3e.Color := clSilver;
      edtM5e.Visible := true;
      edtM5e.Enabled := false;
      edtM5e.Color := clSilver;
      rgrpM9.Visible := True;

      rgrpE3.Visible := True;
      edtE3e.Visible := true;
      edtE3e.Enabled := false;
      edtE3e.Color := clSilver;
      lblE6.Visible := True;
      lblE6m.Visible := True;
      edtE6y.Visible := True;
      edtE6m.Visible := True;
      spnE6y.Visible := True;
      spnE6m.Visible := True;
      rgrpE8.Visible := True;
      rgrpE10.Visible := True;
      edtE19.Visible := true;
      lblE19.Visible := true;
      spnE19.Visible := true;
      rgrpE20.Visible := true;
      rgrpE22.Visible := true;

      lblly.Visible := True;
      edtD1y.Visible := true;
      edtD2y.Visible := true;
      edtD3y.Visible := true;
      edtD4y.Visible := true;
      edtD5y.Visible := true;
      edtD6y.Visible := true;
      edtD7y.Visible := true;
      edtD8y.Visible := true;
      edtD9y.Visible := true;
      edtD10y.Visible := true;
      edtD11y.Visible := true;
      edtD12y.Visible := true;
      edtD13y.Visible := true;
      spnD1y.Visible := true;
      spnD2y.Visible := true;
      spnD3y.Visible := true;
      spnD4y.Visible := true;
      spnD5y.Visible := true;
      spnD6y.Visible := true;
      spnD7y.Visible := true;
      spnD8y.Visible := true;
      spnD9y.Visible := true;
      spnD10y.Visible := true;
      spnD11y.Visible := true;
      spnD12y.Visible := true;
      spnD13y.Visible := true;
      rgrpD14.Visible := true;
      lblD15.Visible := true;
      edtD15.Visible := true;
      spnD15.Visible := true;
      lblD16.Visible := true;
      edtD16.Visible := true;
      spnD16.Visible := true;
      lblD17.Visible := true;
      edtD17.Visible := true;
      spnD17.Visible := true;
      lblD18.Visible := true;
      edtD18.Visible := true;
      spnD18.Visible := true;
      lblD21.Visible := true;
      edtD21.Visible := true;
      spnD21.Visible := true;
      lblD22.Visible := true;
      edtD22.Visible := true;
      spnD22.Visible := true;
      lblD23.WordWrap := false;
      lblD24.WordWrap := false;
      rgrpD32.Visible := true;
      rgrpD33.Visible := true;

      rgrpL1.Visible := True;
      edtL22.Visible := true;
      lblL22.Visible := true;
      spnL22.Visible := true;
      rgrpL23.Visible := true;
      rgrpL30.Visible := true;

      pnlFamily.Visible := true;
      lblHF1.Visible := True;
      lblHF2.Visible := True;
      lblHF3.Visible := True;
      lblHF4.Visible := True;
      lblH1.Visible := True;
      cbxH1a.Visible := True;
      cbxH1d.Visible := True;
      cbxH1p.Visible := True;
      lblH2.Visible := True;
      cbxH2a.Visible := True;
      cbxH2d.Visible := True;
      cbxH2p.Visible := True;
      lblH3.Visible := True;
      cbxH3a.Visible := True;
      cbxH3d.Visible := True;
      cbxH3p.Visible := True;
      lblH4.Visible := True;
      cbxH4a.Visible := True;
      cbxH4d.Visible := True;
      cbxH4p.Visible := True;
      lblH5.Visible := True;
      cbxH5a.Visible := True;
      cbxH5d.Visible := True;
      cbxH5p.Visible := True;
      lblH6.Visible := True;
      cbxH6a.Visible := True;
      cbxH6d.Visible := True;
      cbxH6p.Visible := True;
      lblH7.Visible := True;
      cbxH7a.Visible := True;
      cbxH7d.Visible := True;
      cbxH7p.Visible := True;
      lblH8.Visible := True;
      cbxH8a.Visible := True;
      cbxH8d.Visible := True;
      cbxH8p.Visible := True;
      lblH9.Visible := True;
      cbxH9a.Visible := True;
      cbxH9d.Visible := True;
      cbxH9p.Visible := True;
      lblH10.Visible := True;
      cbxH10a.Visible := True;
      cbxH10d.Visible := True;
      cbxH10p.Visible := True;
      lblH11.Visible := True;
      cbxH11a.Visible := True;
      cbxH11d.Visible := True;
      cbxH11p.Visible := True;
      lblH12.Visible := True;
      cbxH12a.Visible := True;
      cbxH12d.Visible := True;
      cbxH12p.Visible := True;

      lblH1a.Visible := True;
      lblH1d.Visible := True;
      lblH1p.Visible := True;
      lblH2a.Visible := True;
      lblH2d.Visible := True;
      lblH2p.Visible := True;
      lblH3a.Visible := True;
      lblH3d.Visible := True;
      lblH3p.Visible := True;
      lblH4a.Visible := True;
      lblH4d.Visible := True;
      lblH4p.Visible := True;
      lblH5a.Visible := True;
      lblH5d.Visible := True;
      lblH5p.Visible := True;
      lblH6a.Visible := True;
      lblH6d.Visible := True;
      lblH6p.Visible := True;
      lblH7a.Visible := True;
      lblH7d.Visible := True;
      lblH7p.Visible := True;
      lblH8a.Visible := True;
      lblH8d.Visible := True;
      lblH8p.Visible := True;
      lblH9a.Visible := True;
      lblH9d.Visible := True;
      lblH9p.Visible := True;
      lblH10a.Visible := True;
      lblH10d.Visible := True;
      lblH10p.Visible := True;
      lblH11a.Visible := True;
      lblH11d.Visible := True;
      lblH11p.Visible := True;
      lblH12a.Visible := True;
      lblH12d.Visible := True;
      lblH12p.Visible := True;

      lblF2.Visible := True;
      lblF2m.Visible := True;
      edtF2y.Visible := True;
      edtF2m.Visible := True;
      spnF2y.Visible := True;
      spnF2m.Visible := True;
      lblF5.Visible := True;
      lblF5m.Visible := True;
      edtF5y.Visible := True;
      edtF5m.Visible := True;
      spnF5y.Visible := True;
      spnF5m.Visible := True;
      lblF5y.Visible := True;
      rgrpF9.Visible := true;
      rgrpF10.Visible := true;
      edtF11.Visible := true;
      lblF11.Visible := true;
      spnF11.Visible := true;
      lblF12toF17.Visible := true;
      lblF12.Visible := true;
      cbxF12.Visible := true;
      lblF13.Visible := true;
      cbxF13.Visible := true;
      lblF14.Visible := true;
      cbxF14.Visible := true;
      lblF15.Visible := true;
      cbxF15.Visible := true;
      lblF16.Visible := true;
      cbxF16.Visible := true;
      lblF17.Visible := true;
      cbxF17.Visible := true;
      rgrpF27.Visible := true;
      rgrpF27l.Visible := true;
      rgrpF18l.Visible := true;
      rgrpF19l.Visible := true;
      rgrpF20l.Visible := true;
      rgrpF21l.Visible := true;
      rgrpF22l.Visible := true;
      rgrpF23l.Visible := true;
      rgrpF24l.Visible := true;
      rgrpF25l.Visible := true;
      rgrpF26l.Visible := true;
      rgrpF33.Visible := true;
      rgrpF35.Visible := true;
      rgrpF36.Visible := true;

      rgrpP14.Visible := true;
      rgrpP15.Visible := true;
      rgrpP16.Visible := true;
      rgrpP17.Visible := true;
      rgrpP18.Visible := true;
      rgrpP19.Visible := true;
      rgrpP20.Visible := true;
      lbl40.visible := true;
      rgrpP3l.visible := true;
      rgrpP4l.visible := true;
      rgrpP5l.visible := true;
      rgrpP6l.visible := true;
      rgrpP7l.visible := true;
      rgrpP8l.visible := true;
      rgrpP9l.visible := true;
      rgrpP10l.visible := true;

  // Set these captions
      lblM1.Caption := '*M1. How many times in your life have you been hospitalized for ' +
        'medical problems ("N" for never)?';
      lblE1.Caption := '*E1. Education completed? (GED = 12 years)           ' +
        'Years:';
      lblE2.Caption := '*E2. Training or technical education completed?               ' +
        '                         Months:';
      rgrpE7.Caption := '*E7. Usual (or last) occupation.';
      lblD17.Caption :=
        'D17. How many times have you had alcohol d.t.''s? . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .';
      lblD18.Caption :=
        'D18. How many times have you overdosed on drugs? . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .';
      lblD19.Caption :=
        '*D19. How many times in your life have you been treated for alcohol abuse? . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .';
      lblD20.Caption :=
        '*D20. How many times in your life have you been treated for drug abuse? . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .';
      lblD21.Caption :=
        'D21. How many of these were for alcohol detox only? . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .';
      lblD22.Caption :=
        'D22. How many of these were for drug detox only? . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ';
      lblD23.Caption :=
        '*D23. How much would you say you spent during the past 30 days for alcohol? . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .';
      lblD24.Caption :=
        '*D24. How much would you say you spent during the past 30 days for drugs? . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .';
      lblL3to16.Caption := 'How many times in your life have you been arrested and ' +
        'CHARGED with the following:';
      lblL17.Caption := '*L17. How many of these charges resulted in convictions? . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .';
      lblL18toL21.Caption := 'How many times in your life have you been charged ' +
        'with the following:';
      rgrpF4.Caption := '*F4. Usual living arrangements (past 3 years)';
      lblP1.Caption := '*P1. How many times have you been treated for any psychological ' +
        'or emotional problems?';

      sbGeneral.VertScrollBar.Range := 600;
      sbMedical.VertScrollBar.Range := 600;
      sbEmploy.VertScrollBar.Range := 1200;
      sbDrug.VertScrollBar.Range := 1500;
      sbLegal.VertScrollBar.Range := 1300;
      sbSocial.VertScrollBar.Range := 2100;
      sbPsych.VertScrollBar.Range := 1400;

      ASI_PositionItems('F');
      Screen.Cursor := crDefault;
    end;
end;

procedure ASI_SetupLite;
begin
  with frmMHA_ASI_Entry do
    begin
      Screen.Cursor := crHourglass;
  //scroll.visible := false;
      TabFamily.TabVisible := false;
      lblG14.Visible := true;
      lblG14m.Visible := true;
      edtG14y.Visible := true;
      edtG14m.Visible := true;
      spnG14y.Visible := true;
      spnG14m.Visible := true;
      rgrpG15.Visible := False;
      rgrpG17.Visible := true;
      rgrpG18.Visible := true;
      edtG19e.Color := clSilver;
      edtG19e.Enabled := false;

      lblM2.Visible := False;
      lblM2m.Visible := False;
      edtM2y.Visible := False;
      edtM2m.Visible := False;
      spnM2y.Visible := False;
      spnM2m.Visible := False;
      rgrpM3.Visible := true;
      edtM3e.Visible := true;
      edtM3e.Color := clSilver;
      edtM3e.Enabled := false;
      edtM5e.Visible := true;
      edtM5e.Enabled := false;
      edtM5e.Color := clSilver;
      rgrpM9.Visible := False;

      rgrpE3.Visible := False;
      edtE3e.Visible := false;
      lblE6.Visible := true;
      lblE6m.Visible := true;
      edtE6y.Visible := true;
      edtE6m.Visible := true;
      spnE6y.Visible := true;
      spnE6m.Visible := true;
      rgrpE8.Visible := False;
      rgrpE10.Visible := true;
      edtE19.Visible := false;
      lblE19.Visible := false;
      spnE19.Visible := false;
      rgrpE20.Visible := false;
      rgrpE22.Visible := false;

      lblly.Visible := true;
      edtD1y.Visible := true;
      edtD2y.Visible := true;
      edtD3y.Visible := true;
      edtD4y.Visible := true;
      edtD5y.Visible := true;
      edtD6y.Visible := true;
      edtD7y.Visible := true;
      edtD8y.Visible := true;
      edtD9y.Visible := true;
      edtD10y.Visible := true;
      edtD11y.Visible := true;
      edtD12y.Visible := true;
      edtD13y.Visible := true;
      spnD1y.Visible := true;
      spnD2y.Visible := true;
      spnD3y.Visible := true;
      spnD4y.Visible := true;
      spnD5y.Visible := true;
      spnD6y.Visible := true;
      spnD7y.Visible := true;
      spnD8y.Visible := true;
      spnD9y.Visible := true;
      spnD10y.Visible := true;
      spnD11y.Visible := true;
      spnD12y.Visible := true;
      spnD13y.Visible := true;
      rgrpD14.Visible := false;
      lblD15.Visible := False;
      edtD15.Visible := False;
      spnD15.Visible := false;
      lblD16.Visible := False;
      edtD16.Visible := False;
      spnD16.Visible := False;
      lblD17.Visible := False;
      edtD17.Visible := False;
      spnD17.Visible := false;
      lblD18.Visible := False;
      edtD18.Visible := False;
      spnD18.Visible := False;
      lblD21.Visible := false;
      edtD21.Visible := false;
      spnD21.Visible := false;
      lblD22.Visible := false;
      edtD22.Visible := false;
      spnD22.Visible := false;
      lblD23.WordWrap := false;
      lblD24.WordWrap := false;
      rgrpD32.Visible := false;
      rgrpD33.Visible := false;

      rgrpL1.Visible := true;
      edtL22.Visible := false;
      lblL22.Visible := false;
      spnL22.Visible := false;
      rgrpL23.Visible := false;
      rgrpL30.Visible := false;

      pnlFamily.Visible := false;
      lblHF1.Visible := False;
      lblHF2.Visible := False;
      lblHF3.Visible := False;
      lblHF4.Visible := False;
      lblH1.Visible := False;
      cbxH1a.Visible := False;
      cbxH1d.Visible := False;
      cbxH1p.Visible := False;
      lblH2.Visible := False;
      cbxH2a.Visible := False;
      cbxH2d.Visible := False;
      cbxH2p.Visible := False;
      lblH3.Visible := False;
      cbxH3a.Visible := False;
      cbxH3d.Visible := False;
      cbxH3p.Visible := False;
      lblH4.Visible := False;
      cbxH4a.Visible := False;
      cbxH4d.Visible := False;
      cbxH4p.Visible := False;
      lblH5.Visible := False;
      cbxH5a.Visible := False;
      cbxH5d.Visible := False;
      cbxH5p.Visible := False;
      lblH6.Visible := False;
      cbxH6a.Visible := False;
      cbxH6d.Visible := False;
      cbxH6p.Visible := False;
      lblH7.Visible := False;
      cbxH7a.Visible := False;
      cbxH7d.Visible := False;
      cbxH7p.Visible := False;
      lblH8.Visible := False;
      cbxH8a.Visible := False;
      cbxH8d.Visible := False;
      cbxH8p.Visible := False;
      lblH9.Visible := False;
      cbxH9a.Visible := False;
      cbxH9d.Visible := False;
      cbxH9p.Visible := False;
      lblH10.Visible := False;
      cbxH10a.Visible := False;
      cbxH10d.Visible := False;
      cbxH10p.Visible := False;
      lblH11.Visible := False;
      cbxH11a.Visible := False;
      cbxH11d.Visible := False;
      cbxH11p.Visible := False;
      lblH12.Visible := False;
      cbxH12a.Visible := False;
      cbxH12d.Visible := False;
      cbxH12p.Visible := False;

      lblH1a.Visible := False;
      lblH1d.Visible := False;
      lblH1p.Visible := False;
      lblH2a.Visible := False;
      lblH2d.Visible := False;
      lblH2p.Visible := False;
      lblH3a.Visible := False;
      lblH3d.Visible := False;
      lblH3p.Visible := False;
      lblH4a.Visible := False;
      lblH4d.Visible := False;
      lblH4p.Visible := False;
      lblH5a.Visible := False;
      lblH5d.Visible := False;
      lblH5p.Visible := False;
      lblH6a.Visible := False;
      lblH6d.Visible := False;
      lblH6p.Visible := False;
      lblH7a.Visible := False;
      lblH7d.Visible := False;
      lblH7p.Visible := False;
      lblH8a.Visible := False;
      lblH8d.Visible := False;
      lblH8p.Visible := False;
      lblH9a.Visible := False;
      lblH9d.Visible := False;
      lblH9p.Visible := False;
      lblH10a.Visible := False;
      lblH10d.Visible := False;
      lblH10p.Visible := False;
      lblH11a.Visible := False;
      lblH11d.Visible := False;
      lblH11p.Visible := False;
      lblH12a.Visible := False;
      lblH12d.Visible := False;
      lblH12p.Visible := False;

      lblF2.Visible := False;
      lblF2m.Visible := False;
      edtF2y.Visible := False;
      edtF2m.Visible := False;
      spnF2y.Visible := False;
      spnF2m.Visible := False;
      lblF5.Visible := False;
      lblF5m.Visible := False;
      edtF5y.Visible := False;
      edtF5m.Visible := False;
      spnF5y.Visible := False;
      spnF5m.Visible := False;
      lblF5y.Visible := False;
      rgrpF9.Visible := false;
      rgrpF10.Visible := false;
      edtF11.Visible := false;
      lblF11.Visible := false;
      spnF11.Visible := false;
      lblF12toF17.Visible := False;
      lblF12.Visible := False;
      cbxF12.Visible := False;
      lblF13.Visible := False;
      cbxF13.Visible := False;
      lblF14.Visible := False;
      cbxF14.Visible := False;
      lblF15.Visible := False;
      cbxF15.Visible := False;
      lblF16.Visible := False;
      cbxF16.Visible := False;
      lblF17.Visible := False;
      cbxF17.Visible := False;
      rgrpF27.Visible := false;
      rgrpF27l.Visible := false;
      lbliyl.Visible := true;
      rgrpF18l.Visible := true;
      rgrpF19l.Visible := true;
      rgrpF20l.Visible := true;
      rgrpF21l.Visible := true;
      rgrpF22l.Visible := true;
      rgrpF23l.Visible := true;
      rgrpF24l.Visible := true;
      rgrpF25l.Visible := true;
      rgrpF26l.Visible := true;
      rgrpF33.Visible := false;
      rgrpF35.Visible := false;
      rgrpF36.Visible := false;

      rgrpP14.Visible := false;
      rgrpP15.Visible := false;
      rgrpP16.Visible := false;
      rgrpP17.Visible := false;
      rgrpP18.Visible := false;
      rgrpP19.Visible := false;
      rgrpP20.Visible := false;
      lbl40.visible := True;
      lblend.visible := true;
      lblend1.visible := true;
      rgrpP3l.visible := true;
      rgrpP4l.visible := true;
      rgrpP5l.visible := true;
      rgrpP6l.visible := true;
      rgrpP7l.visible := true;
      rgrpP8l.visible := true;
      rgrpP9l.visible := true;
      rgrpP10l.visible := true;

  // Set these captions
      lblM1.Caption := '*M1. How many times in your life have you been hospitalized for ' +
        'medical problems ("N" for never)?';
      lblE1.Caption := '*E1. Education completed? (GED = 12 years)           ' +
        'Years:';
      lblE2.Caption := '*E2. Training or technical education completed?               ' +
        '                         Months:';
      rgrpE7.Caption := '*E7. Usual (or last) occupation.';
      lblD17.Caption :=
        'D17. How many times have you had alcohol d.t.''s? . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .';
      lblD18.Caption :=
        'D18. How many times have you overdosed on drugs? . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .';
      lblD19.Caption :=
        '*D19. How many times in your life have you been treated for alcohol abuse? . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .';
      lblD20.Caption :=
        '*D20. How many times in your life have you been treated for drug abuse? . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .';
      lblD21.Caption :=
        'D21. How many of these were for alcohol detox only? . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .';
      lblD22.Caption :=
        'D22. How many of these were for drug detox only? . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .';
      lblD23.Caption :=
        '*D23. How much would you say you spent during the past 30 days for alcohol? . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ';
      lblD24.Caption :=
        '*D24. How much would you say you spent during the past 30 days for drugs? . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .';
      lblL3to16.Caption := 'How many times in your life have you been arrested and ' +
        'CHARGED with the following:';
      lblL17.Caption :=
        '*L17. How many of these charges resulted in convictions? . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .';
      lblL18toL21.Caption := 'How many times in your life have you been charged ' +
        'with the following:';
      rgrpF4.Caption := '*F4. Usual living arrangements   (past 3 years)';
      lblP1.Caption := '*P1. How many times have you been treated for any psychological ' +
        'or emotional problems?';

      sbGeneral.VertScrollBar.Range := 550;
      sbMedical.VertScrollBar.Range := 550;
      sbEmploy.VertScrollBar.Range := 900;
      sbDrug.VertScrollBar.Range := 1100;
      sbLegal.VertScrollBar.Range := 1100;
      sbSocial.VertScrollBar.Range := 1400;
      sbPsych.VertScrollBar.Range := 1100;

      ASI_PositionItems('L');
      Screen.Cursor := crDefault;
    end;
end;

procedure ASI_SetupFollowup; // Followup
begin
  with frmMHA_ASI_Entry do
    begin
      Screen.Cursor := crHourglass;
      TabFamily.TabVisible := false;
  // Make sure these questions are Visible
      lblG14.Visible := False;
      lblG14m.Visible := False;
      edtG14y.Visible := False;
      edtG14m.Visible := False;
      rgrpG15.Visible := False;
      rgrpG17.Visible := False;
      rgrpG18.Visible := False;
      edtG19e.Color := clSilver;
      edtG19e.Enabled := false;

      lblM2.Visible := False;
      lblM2m.Visible := False;
      edtM2y.Visible := False;
      edtM2m.Visible := False;
      spnG14y.Visible := false;
      spnG14m.Visible := False;
      spnM2y.Visible := False;
      spnM2m.Visible := False;
      rgrpM3.Visible := False;
      edtM3e.Visible := false;
      edtM5e.Visible := true;
      edtM5e.Enabled := false;
      edtM5e.Color := clSilver;
      rgrpM9.Visible := true;

      rgrpE3.Visible := False;
      edtE3e.Visible := false;
      lblE6.Visible := False;
      lblE6m.Visible := False;
      edtE6y.Visible := False;
      edtE6m.Visible := False;
      spnE6y.Visible := False;
      spnE6m.Visible := False;
      rgrpE8.Visible := true;
      rgrpE10.Visible := False;
      edtE19.Visible := true;
      lblE19.Visible := true;
      spnE19.Visible := true;
      rgrpE20.Visible := true;
      rgrpE22.Visible := true;

      lblly.Visible := false;
      edtD1y.Visible := false;
      edtD2y.Visible := false;
      edtD3y.Visible := false;
      edtD4y.Visible := false;
      edtD5y.Visible := false;
      edtD6y.Visible := false;
      edtD7y.Visible := false;
      edtD8y.Visible := false;
      edtD9y.Visible := false;
      edtD10y.Visible := false;
      edtD11y.Visible := false;
      edtD12y.Visible := false;
      edtD13y.Visible := false;
      spnD1y.Visible := false;
      spnD2y.Visible := false;
      spnD3y.Visible := false;
      spnD4y.Visible := false;
      spnD5y.Visible := false;
      spnD6y.Visible := false;
      spnD7y.Visible := false;
      spnD8y.Visible := false;
      spnD9y.Visible := false;
      spnD10y.Visible := false;
      spnD11y.Visible := false;
      spnD12y.Visible := false;
      spnD13y.Visible := false;
      rgrpD14.Visible := true;
      lblD15.Visible := false;
      edtD15.Visible := false;
      spnD15.Visible := false;
      lblD16.Visible := false;
      edtD16.Visible := false;
      spnD16.Visible := false;
      lblD17.Visible := true;
      edtD17.Visible := true;
      spnD17.Visible := true;
      lblD18.Visible := true;
      edtD18.Visible := true;
      spnD18.Visible := true;
      lblD21.Visible := true;
      edtD21.Visible := true;
      spnD21.Visible := true;
      lblD22.Visible := true;
      edtD22.Visible := true;
      spnD22.Visible := true;
      lblD23.WordWrap := true;
      lblD24.WordWrap := true;
      rgrpD32.Visible := true;
      rgrpD33.Visible := true;

      rgrpL1.Visible := False;
      edtL22.Visible := true;
      lblL22.Visible := true;
      spnL22.Visible := true;
      rgrpL23.Visible := true;
      rgrpL30.Visible := true;

      pnlFamily.Visible := false;
      lblHF1.Visible := False;
      lblHF2.Visible := False;
      lblHF3.Visible := False;
      lblHF4.Visible := False;
      lblH1.Visible := False;
      cbxH1a.Visible := False;
      cbxH1d.Visible := False;
      cbxH1p.Visible := False;
      lblH2.Visible := False;
      cbxH2a.Visible := False;
      cbxH2d.Visible := False;
      cbxH2p.Visible := False;
      lblH3.Visible := False;
      cbxH3a.Visible := False;
      cbxH3d.Visible := False;
      cbxH3p.Visible := False;
      lblH4.Visible := False;
      cbxH4a.Visible := False;
      cbxH4d.Visible := False;
      cbxH4p.Visible := False;
      lblH5.Visible := False;
      cbxH5a.Visible := False;
      cbxH5d.Visible := False;
      cbxH5p.Visible := False;
      lblH6.Visible := False;
      cbxH6a.Visible := False;
      cbxH6d.Visible := False;
      cbxH6p.Visible := False;
      lblH7.Visible := False;
      cbxH7a.Visible := False;
      cbxH7d.Visible := False;
      cbxH7p.Visible := False;
      lblH8.Visible := False;
      cbxH8a.Visible := False;
      cbxH8d.Visible := False;
      cbxH8p.Visible := False;
      lblH9.Visible := False;
      cbxH9a.Visible := False;
      cbxH9d.Visible := False;
      cbxH9p.Visible := False;
      lblH10.Visible := False;
      cbxH10a.Visible := False;
      cbxH10d.Visible := False;
      cbxH10p.Visible := False;
      lblH11.Visible := False;
      cbxH11a.Visible := False;
      cbxH11d.Visible := False;
      cbxH11p.Visible := False;
      lblH12.Visible := False;
      cbxH12a.Visible := False;
      cbxH12d.Visible := False;
      cbxH12p.Visible := False;

      lblH1a.Visible := False;
      lblH1d.Visible := False;
      lblH1p.Visible := False;
      lblH2a.Visible := False;
      lblH2d.Visible := False;
      lblH2p.Visible := False;
      lblH3a.Visible := False;
      lblH3d.Visible := False;
      lblH3p.Visible := False;
      lblH4a.Visible := False;
      lblH4d.Visible := False;
      lblH4p.Visible := False;
      lblH5a.Visible := False;
      lblH5d.Visible := False;
      lblH5p.Visible := False;
      lblH6a.Visible := False;
      lblH6d.Visible := False;
      lblH6p.Visible := False;
      lblH7a.Visible := False;
      lblH7d.Visible := False;
      lblH7p.Visible := False;
      lblH8a.Visible := False;
      lblH8d.Visible := False;
      lblH8p.Visible := False;
      lblH9a.Visible := False;
      lblH9d.Visible := False;
      lblH9p.Visible := False;
      lblH10a.Visible := False;
      lblH10d.Visible := False;
      lblH10p.Visible := False;
      lblH11a.Visible := False;
      lblH11d.Visible := False;
      lblH11p.Visible := False;
      lblH12a.Visible := False;
      lblH12d.Visible := False;
      lblH12p.Visible := False;

      lblF2.Visible := False;
      lblF2m.Visible := False;
      edtF2y.Visible := False;
      edtF2m.Visible := False;
      spnF2y.Visible := False;
      spnF2m.Visible := False;
      lblF5.Visible := False;
      lblF5m.Visible := False;
      edtF5y.Visible := False;
      edtF5m.Visible := False;
      spnF5y.Visible := False;
      spnF5m.Visible := False;
      lblF5y.Visible := False;
      rgrpF9.Visible := true;
      rgrpF10.Visible := true;
      edtF11.Visible := true;
      lblF11.Visible := true;
      spnF11.Visible := true;
      lblF12toF17.Visible := False;
      lblF12.Visible := False;
      cbxF12.Visible := False;
      lblF13.Visible := False;
      cbxF13.Visible := False;
      lblF14.Visible := False;
      cbxF14.Visible := False;
      lblF15.Visible := False;
      cbxF15.Visible := False;
      lblF16.Visible := False;
      cbxF16.Visible := False;
      lblF17.Visible := False;
      cbxF17.Visible := False;
      rgrpF27.Visible := true;
      rgrpF27l.Visible := true;
      lbliyl.Visible := false;
      rgrpF18l.Visible := false;
      rgrpF19l.Visible := false;
      rgrpF20l.Visible := false;
      rgrpF21l.Visible := false;
      rgrpF22l.Visible := false;
      rgrpF23l.Visible := false;
      rgrpF24l.Visible := false;
      rgrpF25l.Visible := false;
      rgrpF26l.Visible := false;
      rgrpF33.Visible := true;
      rgrpF35.Visible := true;
      rgrpF36.Visible := true;

      rgrpP14.Visible := true;
      rgrpP15.Visible := true;
      rgrpP16.Visible := true;
      rgrpP17.Visible := true;
      rgrpP18.Visible := true;
      rgrpP19.Visible := true;
      rgrpP20.Visible := true;
      lbl40.visible := false;
      rgrpP3l.visible := false;
      rgrpP4l.visible := false;
      rgrpP5l.visible := false;
      rgrpP6l.visible := false;
      rgrpP7l.visible := false;
      rgrpP8l.visible := false;
      rgrpP9l.visible := false;
      rgrpP10l.visible := false;

  // Set these captions:  LastASIDate is a property of ASI_List
  //NB: I don't know how often this will occur in real life, but if the Followup
  //begin edited isn't the most recent ASI administered, LastASIDate will be a date
  //prior to the putative date of the Followup interview.
      with ASI_OPS do
        begin
          lblM1.Caption := '*M1. How many times since ' + LastASIDate + ' have you been ' +
            'hospitalized for medical problems?';
          lblE1.Caption := '*E1. Education completed since ' + LastASIDate + ' (years)?';
          lblE2.Caption := '*E2. Training or technical education completed since ' + LastASIDate +
            ' (months)?';
          rgrpE7.Caption := '*E7. Occupation since ' + LastASIDate;
          lblD17.Caption :=
            'D17. How many times since ' + LastASIDate + ' have you had alcohol d.t.''s? . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .';
          lblD18.Caption :=
            'D18. How many times since ' + LastASIDate + ' have you overdosed on drugs? . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .';
          lblD19.Caption :=
            '*D19. How many times since ' + LastASIDate + ' have you been treated for alcohol abuse? . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ';
          lblD20.Caption :=
            '*D20. How many times since ' + LastASIDate + ' have you been treated for drug abuse? . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ';
          lblD21.Caption :=
            'D21. Since ' + LastASIDate + ' how many of these were for alcohol detox only? . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .';
          lblD22.Caption :=
            'D22. Since ' + LastASIDate + ' how many of these were for drug detox only? . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .';
          lblD23.Caption :=
            '*D23. How much would you say you spent during the past 30 days for alcohol? . . . . . . . . . . .';
          lblD24.Caption :=
            '*D24. How much would you say you spent during the past 30 days for drugs? . . . . . . . . . . . . . . . . .';
          lblL3to16.Caption := 'How many times since ' + LastASIDate + ' have you been arrested and ' +
            'CHARGED with the following:';
          lblL17.Caption := '*L17. Since ' + LastASIDate + ' how many of these charges resulted in convictions? . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .';
          lblL18toL21.Caption := 'How many times since ' + LastASIDate + ' have you been charged ' +
            'with the following:';
          rgrpF4.Caption := '*F4. Usual living arrangements since ' + LastASIDate + '.';
          lblP1.Caption := '*P1. How many times since ' + LastASIDate + ' have you been treated for any psychological ' +
            'or emotional problems?';
        end;

      sbGeneral.VertScrollBar.Range := 400;
      sbMedical.VertScrollBar.Range := 500;
      sbEmploy.VertScrollBar.Range := 1000;
      sbDrug.VertScrollBar.Range := 1500;
      sbLegal.VertScrollBar.Range := 1300;
      sbSocial.VertScrollBar.Range := 2000;
      sbPsych.VertScrollBar.Range := 1400;

      ASI_PositionItems('U');
      Screen.Cursor := crDefault;
    end;
end;


procedure ASI_PositionItems(WhichForm: Char);
var
  T, // Top
    S // Space between items;
                              : integer;
begin
  with frmMHA_ASI_Entry do
    begin
  // Reset the Scroll bars
      sbGeneral.VertScrollBar.Position := 0;
      sbMedical.VertScrollBar.Position := 0;
      sbEmploy.VertScrollBar.Position := 0;
      sbLegal.VertScrollBar.Position := 0;
      sbDrug.VertScrollBar.Position := 0;
      sbFamily.VertScrollBar.Position := 0;
      sbSocial.VertScrollBar.Position := 0;
      sbPsych.VertScrollBar.Position := 0;
      T := 5;
      S := 5;
  // General Information Items --------------------------------------
      lblG3.top := T;
      cbxG3.top := T;
      T := T + cbxG3.Height + S;
      lblG4.top := T;
      dtpG4.top := T;
      lblG5.top := T;
      dtpG5.Top := T;
      T := T + dtpG4.Height + S;
      rgrpG8.top := T;
      rgrpG9.Top := T;
      T := T + rgrpG8.Height + S;
      lblG11Interviewerx.top := T;
      cbxG11Interviewerx.top := T;
      T := T + cbxG11Interviewerx.Height + S;
      lblG11OrderedByx.top := T;
      cbxG11OrderedByx.top := T;
      T := T + cbxG11OrderedByx.Height + S;
      rgrpG12.top := T;
      T := T + rgrpG12.Height + S;
      if not (WhichForm = 'U') then
        begin
          lblG14.Top := T;
          edtG14y.Top := T;
          lblG14m.top := T;
          edtG14m.top := T;
          spnG14y.top := T;
          spnG14m.Top := T;
          T := T + S + edtG14y.Height;
        end;
      if WhichForm = 'F' then
        begin
          rgrpG15.Top := T;
          T := T + S + rgrpG15.Height;
        end;
      if not (WhichForm = 'U') then
        begin
          rgrpG17.Top := T;
          T := T + S + rgrpG17.Height;
          rgrpG18.Top := T;
          T := T + S + rgrpG18.Height;
        end;
      rgrpG19.Top := T;
      T := T + S + rgrpG19.Height;
      edtG19e.Top := T;
      lblG20.top := T;
      edtG20.Top := T;
      spnG20.Top := T;
      T := T + S * 3 + edtG20.Height;
      GeneralNextPage.top := T + 30;
  // Medical Status -------------------------------------------------
      T := 5;
      lblM1.Top := T;
      edtM1.Top := T;
      spnM1.Top := T;
      T := T + S + edtM1.height;
      if WhichForm = 'F' then
        begin
          lblM2.Top := T;
          edtM2y.Top := T;
          spnM2y.Top := T;
          lblM2m.Top := T;
          edtM2m.Top := T;
          spnM2m.Top := T;
          T := T + S + edtM2y.height;
        end;
      if not (WhichForm = 'U') then
        begin
          rgrpM3.top := T;
          T := T + S + rgrpM3.height;
          edtM3e.top := T;
          T := T + S + edtM3e.height;
        end;
      rgrpM4.top := T;
      T := T + S + rgrpM4.height;
      rgrpM5.top := T;
      T := T + S + rgrpM5.height;
      edtM5e.top := T;
      T := T + S + edtM5e.height;
      lblM6.Top := T;
      edtM6.Top := T;
      spnM6.Top := T;
      T := T + S + edtM6.height;
      rgrpM7.top := T;
      T := T + S + rgrpM7.height;
      rgrpM8.top := T;
      T := T + S + rgrpM8.height;
      if ((WhichForm = 'U') or (WhichForm = 'F')) then
        begin
          rgrpM9.top := T;
          T := T + S + rgrpM9.height;
        end;
      rgrpM10.top := T;
      T := T + S + rgrpM10.height;
      rgrpM11.top := T;
      T := T + S * 3 + rgrpM11.Height;
      MedicalNextPage.top := T + 30;
  // Employment -----------------------------------------------------
      T := 5;
      lblE1.Top := T;
      edtE1y.Top := T;
      spnE1y.Top := T;
      lblE1m.Top := T;
      edtE1m.Top := T;
      spnE1m.Top := T;
      T := T + S + edtE1y.height;
      lblE2.Top := T;
      edtE2.Top := T;
      spnE2.Top := T;
      T := T + S + edtE2.height;
      if WhichForm = 'F' then
        begin
          rgrpE3.top := T;
          T := T + S + rgrpE3.height;
          edtE3e.top := T;
          T := T + S + edtE3e.height;
        end;
      rgrpE4.top := T;
      T := T + S + rgrpE4.height;
      rgrpE5.top := T;
      T := T + S + rgrpE5.height;
      if not (WhichForm = 'U') then
        begin
          lblE6.Top := T;
          edtE6y.Top := T;
          spnE6y.Top := T;
          lblE6m.Top := T;
          edtE6m.Top := T;
          spnE6m.Top := T;
          T := T + S + edtE6y.height;
        end;
      rgrpE7.top := T;
      T := T + S + rgrpE7.height;
      btnHollingshead.top := T;
      edtE7e.top := T;
      lblE7.top := T;
      T := T + S + edtE7e.height;
      if not (WhichForm = 'L') then
        begin
          rgrpE8.top := T;
          T := T + S + rgrpE8.height;
        end;
      rgrpE9.top := T;
      T := T + S + rgrpE9.height;
      if not (WhichForm = 'U') then
        begin
          rgrpE10.top := T;
          T := T + S + rgrpE10.height;
        end;
      lblE11.Top := T;
      edtE11.Top := T;
      spnE11.Top := T;
      T := T + S + edtE11.height;
      lblE12.Top := T;
      edtE12.Top := T;
      T := T + S + edtE12.height;
      lblE13.Top := T;
      edtE13.Top := T;
      T := T + S + edtE13.height;
      lblE14.Top := T;
      edtE14.Top := T;
      T := T + S + edtE14.height;
      lblE15.Top := T;
      edtE15.Top := T;
      T := T + S + edtE15.height;
      lblE16.Top := T;
      edtE16.Top := T;
      T := T + S + edtE16.height;
      lblE17.Top := T;
      edtE17.Top := T;
      T := T + S + edtE17.height;
      lblE18.Top := T;
      edtE18.Top := T;
      spnE18.Top := T;
      T := T + S + edtE18.height;
      if not (WhichForm = 'L') then
        begin
          lblE19.Top := T;
          edtE19.Top := T;
          spnE19.Top := T;
          T := T + S + edtE19.height;
          rgrpE20.top := T;
          T := T + S + rgrpE20.height;
        end;
      rgrpE21.top := T;
      T := T + S + rgrpE21.height;
      if not (WhichForm = 'L') then
        begin
          rgrpE22.top := T;
          T := T + S + rgrpE22.height;
        end;
      rgrpE23.top := T;
      T := T + S + rgrpE23.height;
      rgrpE24.top := T;
      T := T + S * 3 + rgrpE24.Height;
      EmployNextPage.top := T + 30;
  // Drug -------------------------------------------------
      T := 5;
      lbl30d.top := T;
      lbliyl.top := T;
      Lblra.top := T;
      T := T + S + lbl30d.height;
      lblD1.Top := T;
      edtD1d.top := T;
      spnD1d.Top := T;
      edtD1y.top := T;
      spnD1y.top := T;
      cbxD1r.top := T;
      T := T + S + edtD1d.height;
      lblD2.Top := T;
      edtD2d.top := T;
      spnD2d.Top := T;
      edtD2y.top := T;
      spnD2y.top := T;
      cbxD2r.top := T;
      T := T + S + edtD2d.height;
      lblD3.Top := T;
      edtD3d.top := T;
      spnD3d.Top := T;
      edtD3y.top := T;
      spnD3y.top := T;
      cbxD3r.top := T;
      T := T + S + edtD3d.height;
      lblD4.Top := T;
      edtD4d.top := T;
      spnD4d.Top := T;
      edtD4y.top := T;
      spnD4y.top := T;
      cbxD4r.top := T;
      T := T + S + edtD4d.height;
      lblD5.Top := T;
      edtD5d.top := T;
      spnD5d.Top := T;
      edtD5y.top := T;
      spnD5y.top := T;
      cbxD5r.top := T;
      T := T + S + edtD5d.height;
      lblD6.Top := T;
      edtD6d.top := T;
      spnD6d.Top := T;
      edtD6y.top := T;
      spnD6y.top := T;
      cbxD6r.top := T;
      T := T + S + edtD6d.height;
      lblD7.Top := T;
      edtD7d.top := T;
      spnD7d.Top := T;
      edtD7y.top := T;
      spnD7y.top := T;
      cbxD7r.top := T;
      T := T + S + edtD7d.height;
      lblD8.Top := T;
      edtD8d.top := T;
      spnD8d.Top := T;
      edtD8y.top := T;
      spnD8y.top := T;
      cbxD8r.top := T;
      T := T + S + edtD8d.height;
      lblD9.Top := T;
      edtD9d.top := T;
      spnD9d.Top := T;
      edtD9y.top := T;
      spnD9y.top := T;
      cbxD9r.top := T;
      T := T + S + edtD9d.height;
      lblD10.Top := T;
      edtD10d.top := T;
      spnD10d.Top := T;
      edtD10y.top := T;
      spnD10y.top := T;
      cbxD10r.top := T;
      T := T + S + edtD10d.height;
      lblD11.Top := T;
      edtD11d.top := T;
      spnD11d.Top := T;
      edtD11y.top := T;
      spnD11y.top := T;
      cbxD11r.top := T;
      T := T + S + edtD11d.height;
      lblD12.Top := T;
      edtD12d.top := T;
      spnD12d.Top := T;
      edtD12y.top := T;
      spnD12y.top := T;
      cbxD12r.top := T;
      T := T + S + edtD12d.height;
      lblD13.Top := T;
      edtD13d.top := T;
      spnD13d.Top := T;
      edtD13y.top := T;
      spnD13y.top := T;
      T := T + S + edtD13d.height;
      if not (WhichForm = 'L') then
        begin
          rgrpD14.top := T;
          T := T + S + rgrpD14.Height;
        end;
      if WhichForm = 'F' then
        begin
          lblD15.Top := T;
          edtD15.top := T;
          spnD15.Top := T;
          T := T + S + edtD15.height;
          lblD16.Top := T;
          edtD16.top := T;
          spnD16.Top := T;
          T := T + S + edtD16.height;
        end;
      if not (WhichForm = 'L') then
        begin
          lblD17.Top := T;
          edtD17.top := T;
          spnD17.Top := T;
          T := T + S + edtD17.height;
          lblD18.Top := T;
          edtD18.top := T;
          spnD18.Top := T;
          T := T + S + edtD18.height;
        end;
      lblD19.Top := T;
      edtD19.top := T;
      spnD19.Top := T;
      T := T + S + edtD19.height;
      lblD20.Top := T;
      edtD20.top := T;
      spnD20.Top := T;
      T := T + S + edtD20.height;
      if not (WhichForm = 'L') then
        begin
          lblD21.Top := T;
          edtD21.top := T;
          spnD21.Top := T;
          T := T + S + edtD21.height;
          lblD22.Top := T;
          edtD22.top := T;
          spnD22.Top := T;
          T := T + S + edtD22.height;
        end;
      lblD23.Top := T;
      edtD23.top := T;
      spnD23.Top := T;
      T := T + S + lblD23.height;
      lblD24.Top := T;
      edtD24.top := T;
      spnD24.Top := T;
      T := T + S + lblD24.height;
      lblD25.Top := T;
      edtD25.top := T;
      spnD25.Top := T;
      T := T + S + lblD25.height;
      lblD26.Top := T;
      edtD26.top := T;
      spnD26.Top := T;
      T := T + S + edtD26.height;
      lblD27.Top := T;
      edtD27.top := T;
      spnD27.Top := T;
      T := T + S + edtD27.height;
      rgrpD28.top := T;
      T := T + S + rgrpD28.height;
      rgrpD29.top := T;
      T := T + S + rgrpD29.height;
      rgrpD30.top := T;
      T := T + S + rgrpD30.height;
      rgrpD31.top := T;
      T := T + S + rgrpD31.height;
      if not (WhichForm = 'L') then
        begin
          rgrpD32.top := T;
          T := T + S + rgrpD32.height;
          rgrpD33.top := T;
          T := T + S + rgrpD33.height;
        end;
      rgrpD34.top := T;
      T := T + S + rgrpD34.height;
      rgrpD35.top := T;
      T := T + S * 3 + rgrpD35.Height;
      DrugNextPage.top := T + 30;
  //Legal -------------------------------------------------
      T := 5;
      if not (WhichForm = 'U') then
        begin
          rgrpL1.top := T;
          T := T + S + rgrpL1.height;
        end;
      rgrpL2.top := T;
      T := T + S + rgrpL2.height;
      lblL3to16.Top := T;
      T := T + S + lblL3to16.height;
      lblL3.Top := T;
      edtL3.top := T;
      spnL3.Top := T;
      lblL10.Top := T;
      edtL10.top := T;
      spnL10.Top := T;
      T := T + S + edtL3.height;
      lblL4.Top := T;
      edtL4.top := T;
      spnL4.Top := T;
      lblL11.Top := T;
      edtL11.top := T;
      spnL11.Top := T;
      T := T + S + edtL4.height;
      lblL5.Top := T;
      edtL5.top := T;
      spnL5.Top := T;
      lblL12.Top := T;
      edtL12.top := T;
      spnL12.Top := T;
      T := T + S + edtL5.height;
      lblL6.Top := T;
      edtL6.top := T;
      spnL6.Top := T;
      lblL13.Top := T;
      edtL13.top := T;
      spnL13.Top := T;
      T := T + S + edtL6.height;
      lblL7.Top := T;
      edtL7.top := T;
      spnL7.Top := T;
      lblL14.Top := T;
      edtL14.top := T;
      spnL14.Top := T;
      T := T + S + edtL7.height;
      lblL8.Top := T;
      edtL8.top := T;
      spnL8.Top := T;
      lblL15.Top := T;
      edtL15.top := T;
      spnL15.Top := T;
      T := T + S + edtL8.height;
      lblL9.Top := T;
      edtL9.top := T;
      spnL9.Top := T;
      lblL16.Top := T;
      edtL16.top := T;
      spnL16.Top := T;
      T := T + S + edtL9.height;
      lblL17.Top := T;
      edtL17.top := T;
      spnL17.Top := T;
      T := T + S + edtL17.height;
      lblL18toL21.Top := T;
      T := T + S + lblL18toL21.height;
      lblL18.Top := T;
      edtL18.top := T;
      spnL18.Top := T;
      T := T + S + edtL18.height;
      lblL19.Top := T;
      edtL19.top := T;
      spnL19.Top := T;
      T := T + S + edtL19.height;
      lblL20.Top := T;
      edtL20.top := T;
      spnL20.Top := T;
      T := T + S + edtL20.height;
      lblL21.Top := T;
      edtL21.top := T;
      spnL21.Top := T;
      T := T + S + edtL21.height;
      if not (WhichForm = 'L') then
        begin
          lblL22.Top := T;
          edtL22.top := T;
          spnL22.Top := T;
          T := T + S + edtL22.height;
          rgrpL23.top := T;
          T := T + S + rgrpL23.height;
        end;
      rgrpL24.top := T;
      T := T + S + rgrpL24.height;
      rgrpL25.top := T;
      T := T + S + rgrpL25.height;
      lblL26.Top := T;
      edtL26.top := T;
      spnL26.Top := T;
      T := T + S + edtL26.height;
      lblL27.Top := T;
      edtL27.top := T;
      spnL27.Top := T;
      T := T + S + edtL27.height;
      rgrpL28.top := T;
      T := T + S + rgrpL28.height;
      rgrpL29.top := T;
      T := T + S + rgrpL29.height;
      if not (WhichForm = 'L') then
        begin
          rgrpL30.top := T;
          T := T + S + rgrpL30.height;
        end;
      rgrpL31.top := T;
      T := T + S + rgrpL31.height;
      rgrpL32.top := T;
      T := T + S * 3 + rgrpL32.Height;
      LegalNextPage.top := T + 30;

  //Family -------------------------------------------------
      T := 5;
      if WhichForm = 'F' then
        begin

          lblHF1.top := T;
          T := T + S + lblHF1.height;
          lblHF2.top := T;
          T := T + S + lblHF2.height;
          lblH1.top := T;
          lblH1a.top := T;
          cbxH1a.top := T;
          lblH1d.top := T;
          cbxH1d.top := T;
          lblH1p.top := T;
          cbxH1p.top := T;
          T := T + S + cbxH1a.height;
          lblH2.top := T;
          lblH2a.top := T;
          cbxH2a.top := T;
          lblH2d.top := T;
          cbxH2d.top := T;
          lblH2p.top := T;
          cbxH2p.top := T;
          T := T + S + cbxH2a.height;
          lblH3.top := T;
          lblH3a.top := T;
          cbxH3a.top := T;
          lblH3d.top := T;
          cbxH3d.top := T;
          lblH3p.top := T;
          cbxH3p.top := T;
          T := T + S + cbxH3a.height;
          lblH4.top := T;
          lblH4a.top := T;
          cbxH4a.top := T;
          lblH4d.top := T;
          cbxH4d.top := T;
          lblH4p.top := T;
          cbxH4p.top := T;
          T := T + S + cbxH4a.height;
          lblH5.top := T;
          lblH5a.top := T;
          cbxH5a.top := T;
          lblH5d.top := T;
          cbxH5d.top := T;
          lblH5p.top := T;
          cbxH5p.top := T;
          T := T + S + cbxH5a.height;
          lblHF3.top := T;
          T := T + S + lblHF3.height;
          lblH6.top := T;
          lblH6a.top := T;
          cbxH6a.top := T;
          lblH6d.top := T;
          cbxH6d.top := T;
          lblH6p.top := T;
          cbxH6p.top := T;
          T := T + S + cbxH6a.height;
          lblH7.top := T;
          lblH7a.top := T;
          cbxH7a.top := T;
          lblH7d.top := T;
          cbxH7d.top := T;
          lblH7p.top := T;
          cbxH7p.top := T;
          T := T + S + cbxH7a.height;
          lblH8.top := T;
          lblH8a.top := T;
          cbxH8a.top := T;
          lblH8d.top := T;
          cbxH8d.top := T;
          lblH8p.top := T;
          cbxH8p.top := T;
          T := T + S + cbxH8a.height;
          lblH9.top := T;
          lblH9a.top := T;
          cbxH9a.top := T;
          lblH9d.top := T;
          cbxH9d.top := T;
          lblH9p.top := T;
          cbxH9p.top := T;
          T := T + S + cbxH9a.height;
          lblH10.top := T;
          lblH10a.top := T;
          cbxH10a.top := T;
          lblH10d.top := T;
          cbxH10d.top := T;
          lblH10p.top := T;
          cbxH10p.top := T;
          T := T + S + cbxH10a.height;
          lblHF4.top := T;
          T := T + S + lblHF4.height;
          lblH11.top := T;
          lblH11a.top := T;
          cbxH11a.top := T;
          lblH11d.top := T;
          cbxH11d.top := T;
          lblH11p.top := T;
          cbxH11p.top := T;
          T := T + S + cbxH11a.height;
          lblH12.top := T;
          lblH12a.top := T;
          cbxH12a.top := T;
          lblH12d.top := T;
          cbxH12d.top := T;
          lblH12p.top := T;
          cbxH12p.top := T;
          T := T + S * 3 + cbxH12a.height;
          FamilyNextPage.top := T + 30;
        end;
  //Social -------------------------------------------------
      T := 5;
      rgrpF1.top := T;
      T := T + S + rgrpF1.height;
      if WhichForm = 'F' then
        begin
          lblF2.Top := T;
          edtF2y.Top := T;
          spnF2y.Top := T;
          lblF2m.Top := T;
          edtF2m.Top := T;
          spnF2m.Top := T;
          T := T + S + edtF2y.height;
        end;
      rgrpF3.top := T;
      T := T + S + rgrpF3.height;
      rgrpF4.top := T;
      T := T + S + rgrpF4.height;
      if WhichForm = 'F' then
        begin
          lblF5.top := T;
          T := T + lblF5.height;
          lblF5y.Top := T;
          edtF5y.Top := T;
          spnF5y.Top := T;
          lblF5m.Top := T;
          edtF5m.Top := T;
          spnF5m.Top := T;
          T := T + S + edtF5y.height;
        end;
      rgrpF6.top := T;
      T := T + S + rgrpF6.height;
      rgrpF7.top := T;
      T := T + S + rgrpF7.height;
      rgrpF8.top := T;
      T := T + S + rgrpF8.height;
      if not (WhichForm = 'L') then
        begin
          rgrpF9.top := T;
          T := T + S + rgrpF9.height;
          rgrpF10.top := T;
          T := T + S + rgrpF10.height;
          lblF11.Top := T;
          edtF11.Top := T;
          spnF11.Top := T;
          T := T + S + edtF11.height;
        end;
      if WhichForm = 'F' then
        begin
          lblF12toF17.top := T;
          T := T + S + lblF12toF17.height;
          lblF12.top := T;
          cbxF12.top := T;
          lblF15.top := T;
          cbxF15.top := T;
          T := T + S + cbxF12.height;
          lblF13.top := T;
          cbxF13.top := T;
          lblF16.top := T;
          cbxF16.top := T;
          T := T + S + cbxF13.height;
          lblF14.top := T;
          cbxF14.top := T;
          lblF17.top := T;
          cbxF17.top := T;
          T := T + S + cbxF14.height;
        end;
      lblF.Top := T;
      T := T + S + lblF.height;
      lbl30.Top := T;
      lbliyl.Top := T;
      T := T + S + lbliyl.height;
      rgrpF18.top := T;
      rgrpF18l.top := T;
      T := T + S + rgrpF18.height;
      rgrpF19.top := T;
      rgrpF19l.top := T;
      T := T + S + rgrpF19.height;
      rgrpF20.top := T;
      rgrpF20l.top := T;
      T := T + S + rgrpF20.height;
      rgrpF21.top := T;
      rgrpF21l.top := T;
      T := T + S + rgrpF21.height;
      rgrpF22.top := T;
      rgrpF22l.top := T;
      T := T + S + rgrpF22.height;
      rgrpF23.top := T;
      rgrpF23l.top := T;
      T := T + S + rgrpF23.height;
      rgrpF24.top := T;
      rgrpF24l.top := T;
      T := T + S + rgrpF24.height;
      rgrpF25.top := T;
      rgrpF25l.top := T;
      T := T + S + rgrpF25.height;
      rgrpF26.top := T;
      rgrpF26l.top := T;
      T := T + S + rgrpF26.height;
      lbl37.Top := T;
      T := T + S + lbl37.height;
      lbl33.Top := T;
      lbl35.Top := T;
      T := T + S + lbl33.height;
      if not (WhichForm = 'L') then
        begin
          rgrpF27.top := T;
          rgrpF27l.top := T;
          T := T + S + rgrpF27.height;
        end;
      rgrpF28.top := T;
      rgrpF28l.top := T;
      T := T + S + rgrpF28.height;
      rgrpF29.top := T;
      rgrpF29l.top := T;
      T := T + S + rgrpF29.height;
      lblF30.Top := T;
      edtF30.top := T;
      spnF30.Top := T;
      T := T + S + edtF30.height;
      lblF31.Top := T;
      edtF31.top := T;
      spnF31.Top := T;
      T := T + S + edtF31.height;
      rgrpF32.top := T;
      T := T + S + rgrpF32.height;
      if not (WhichForm = 'L') then
        begin
          rgrpF33.top := T;
          T := T + S + rgrpF33.height;
        end;
      rgrpF34.top := T;
      T := T + S + rgrpF34.height;
      if not (WhichForm = 'L') then
        begin
          rgrpF35.top := T;
          T := T + S + rgrpF35.height;
          rgrpF36.top := T;
          T := T + S + rgrpF36.height;
        end;
      rgrpF37.top := T;
      T := T + S + rgrpF37.height;
      rgrpF38.top := T;
      T := T + S * 3 + rgrpF38.height;
      SocialNextPage.top := T + 30;

  //Psych -------------------------------------------------
      T := 5;
      lblP1.top := T;
      T := T + S + lblP1.height;
      lblP1a.top := T;
      edtP1a.top := T;
      spnP1a.top := T;
      T := T + S + lblP1a.height;
      lblP1b.top := T;
      edtP1b.top := T;
      spnP1b.top := T;
      T := T + S + lblP1b.height;
      rgrpP2.top := T;
      T := T + S + rgrpP2.height;
      lbl42.Top := T;
      T := T + S + lbl42.height;
      lbl40.Top := T;
      lbl41.Top := T;
      T := T + S + lbl40.height;
      rgrpP3.top := T;
      rgrpP3l.top := T;
      T := T + S + rgrpP3.height;
      rgrpP4.top := T;
      rgrpP4l.top := T;
      T := T + S + rgrpP4.height;
      rgrpP5.top := T;
      rgrpP5l.top := T;
      T := T + S + rgrpP5.height;
      rgrpP6.top := T;
      rgrpP6l.top := T;
      T := T + S + rgrpP6.height;
      rgrpP7.top := T;
      rgrpP7l.top := T;
      T := T + S + rgrpP7.height;
      rgrpP8.top := T;
      rgrpP8l.top := T;
      T := T + S + rgrpP8.height;
      rgrpP9.top := T;
      rgrpP9l.top := T;
      T := T + S + rgrpP9.height;
      rgrpP10.top := T;
      rgrpP10l.top := T;
      T := T + S + rgrpP10.height;
      lblP11.Top := T;
      edtP11.top := T + S;
      spnP11.Top := T + S;
      T := T + S + lblP11.height;
      rgrpP12.top := T;
      T := T + S + rgrpP12.height;
      rgrpP13.top := T;
      T := T + S + rgrpP13.height;
      if not (WhichForm = 'L') then
        begin
          rgrpP14.top := T;
          T := T + S + rgrpP14.height;
          rgrpP15.top := T;
          T := T + S + rgrpP15.height;
          rgrpP16.top := T;
          T := T + S + rgrpP16.height;
          rgrpP17.top := T;
          T := T + S + rgrpP17.height;
          rgrpP18.top := T;
          T := T + S + rgrpP18.height;
          rgrpP19.top := T;
          T := T + S + rgrpP19.height;
          rgrpP20.top := T;
          T := T + S + rgrpP20.height;
        end;
      rgrpP21.top := T;
      T := T + S + rgrpP21.height;
      rgrpP22.top := T;
      T := T + S + rgrpP22.height;
      lblEnd.Top := T;
      T := T + S + lblEnd.Height;
      lblEnd1.Top := T;
      T := T + 3 * S + lblEnd1.Height;

  //End -------------------------------------------------
      btnFinished.Top := T;
    end;
end;




end.

