{

 NOTES: The "rgrp" notation is used to indicate list boxes.
 
 }

unit uMHA_ASI_Save_508;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  comctrls,
  Graphics,
  Controls,
  Forms,
  fIA_Dialogs,
  Fmcmpnts,
  Diaccess,
  StdCtrls,
  ExtCtrls,
  Mask,
  uMHA_SpnEdt,
  uMHA_ASI,
  Fmcntrls;

type
  {**
  Save ASI to M database.
  }
  TASI_Save_508 = class(TObject)
  private

  protected
  public
    constructor Create;
    procedure SaveASIOnTheRun;
    function SaveASIData(
      aRecordIENS,
      aPatientDFN,
      aInterviewerDUZ,
      aOrderedByDUZ,
      ADate,
      aProgramIEN: string;
      aInterviewType: TInterviewType): string;
    destructor Destroy; override;
  published
  end; { TASI_Save }

var
  ASI_Save_508                : TASI_Save_508;

implementation

uses
  RzEdit,
  RzCmboBx,
  fMHA_ASI_Entry_508,
  uMHA_LocalFiles,
  uMHA_ASI_OPS,
  uIA_Patient,
  uIA_Utils,
  uIA_Const,
  uMHA_Const,
  uMHA_DM;


constructor TASI_Save_508.Create;
begin
  inherited Create;
end;

destructor TASI_Save_508.Destroy;
begin
  inherited Destroy;
end;

procedure TASI_Save_508.SaveASIOnTheRun;
// This is the text file augmented with each user's response and
// saved immediately. This a protection against crashes. The text file is
// deleted upon a normal closing of the program.
var
  i                           : integer;
  TempG3,
    TempStr                   : string;
begin

  with frmMHA_ASI_Entry_508 do
    begin
      ASI_OPS.ChoicesMade.Clear;
      TempStr := '';

      TempG3 := '';
        // The first line of the text file has the type of ASI (Full, Lite, etc),
        // the RecordIENS, the patient identifier, the staff identifier and
        // program identifier.
      if cbxG3.ItemIndex <> -1 then
        TempG3 := inttostr(cbxG3.ItemIndex + 1)
      else
        TempG3 := '1';

      TempStr := TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewTypeStr + U
        + TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).IENS + U
        + Patient.DFN + U
        + TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewerDUZ + U
        + TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).OrderedByDUZ + U
        + TempG3;

      ASI_OPS.ChoicesMade.Add(TempStr);
      ProgramIEN := TempG3;


      for i := 0 to ComponentCount - 1 do
        begin
          // Program Note: the order of these components must match that on the
          // recovery side.
          if Components[i] is TEdit then
            ASI_OPS.ChoicesMade.Add(TEdit(Components[i]).Text);
          if Components[i] is TRzEdit then
            ASI_OPS.ChoicesMade.Add(TRzEdit(Components[i]).Text);
          if Components[i] is TDateTimePicker then
            ASI_OPS.ChoicesMade.Add(DateToStr(TDateTimePicker(Components[i]).Date));
          if Components[i] is TListBox then
            ASI_OPS.ChoicesMade.Add(IntToStr(TListBox(Components[i]).ItemIndex));
          if Components[i] is TRzComboBox then
            ASI_OPS.ChoicesMade.Add(TRzComboBox(Components[i]).Text);
          // the TORComboBox is not saved since the staff ID and Program ID are
          // IENS, not names.

        end;

      try
        ASI_OPS.ChoicesMade.SaveToFile(LocalFiles.ASI_RecoveryFile);

      except
        on E: Exception do
          begin
            MessageBeep(MB_ICONASTERISK);
            MsgDlgFrm('The file that saves the data continuously has an error: ' + e.message,
              'Addiction Severity Index',
              mtError, [mbOk], 0);
          end;
      end;
    end;
end;


function TASI_Save_508.SaveASIData(
  aRecordIENS,
  aPatientDFN,
  aInterviewerDUZ,
  aOrderedByDUZ,
  ADate,
  aProgramIEN: string;
  aInterviewType: TInterviewType): string;
var
  TempIENS                    : string;

  function OkToSaveItem(ItemName: string): Boolean;
    // With partial ASI, save only the items where the user provides input.
    // Do not save the items where default values are provided without the user
    // confirming the input. If the item has ever been active, it will be placed
    // ResponseList.
    // In crash recovery situations, save the data "as is"
  begin
    with frmMHA_ASI_Entry_508 do
      begin
        result := true;
        if FileExists(LocalFiles.ASI_RecoveryFile) then
          exit;
        if ((rgrpG12.ItemIndex = 3) and (not FUserTerminates)) then
          exit; // Vet finished ASI
        // Did the user ever enter this item?
        if Pos(UpperCase(ItemName), ResponseList) > 0 then
          exit;
        Result := false;
      end;
  end;

  procedure SaveDate(MCode: string; Item: TDateTimePicker);
  begin
    with frmMHA_ASI_Entry_508 do
      begin
        // Remove the time from DateTime
        ASI_OPS.ChoicesMade.Add(MCode + FloatToStrF(DateTimeToFMDateTime(Item.Date),
          ffFixed, 14, 0) + '^');
      end;
  end;

  procedure SaveSpinEdit(MCode: string; Item: TMHA_SpnEdt);
    // These are spin edit boxes
  var
    TempStr                   : string;
  begin
    with frmMHA_ASI_Entry_508 do
      begin
        if OkToSaveItem(Item.Name) then
          begin
            TempStr := Item.text;
            // Saving a blank on the M-side will cause a crash,
            // "X" indicates "Not answered."
            if TempStr = '' then
              TempStr := 'X';
            // Strip a leading 0 from the number: Vista will not accept it
            while ((Length(TempStr) > 1) and (TempStr[1] = '0')) do
              Delete(TempStr, 1, 1); // remove leading zero
            ASI_OPS.ChoicesMade.Add(MCode + TempStr + '^');
          end;
      end;
  end;

  procedure SaveEdit(Mcode: string; Item: TEdit);
  var
    TempStr                   : string;
  begin
    with frmMHA_ASI_Entry_508 do
      begin
        if OkToSaveItem(Item.Name) then
          begin
            TempStr := Item.text;
            // Saving a blank on the M-side will cause a crash,
            // "X" indicates "Not answered."
            if TempStr = '' then
              TempStr := 'X';
            // Strip a leading 0 from the number: Vista will not accept it
            while ((Length(TempStr) > 1) and (TempStr[1] = '0')) do
              Delete(TempStr, 1, 1); // remove leading zero
            ASI_OPS.ChoicesMade.Add(MCode + TempStr + '^');
          end;
      end;
  end;

  procedure SaveRzEdit(Mcode: string; Item: TRzEdit);
    // These are free text boxes
  begin
    with frmMHA_ASI_Entry_508 do
      begin
        if OkToSaveItem(Item.Name) then
          begin
            // Saving a blank on the M-side will cause a crash.
            if Item.text = '' then
              Item.text := 'Not answered.';
            ASI_OPS.ChoicesMade.Add(MCode + Item.text + '^');
          end;
      end;
  end;

  procedure SaveListBox(MCode: string; Item: TListBox; Start, X, N: integer);
    // Standard List box
  var
    Save                      : string;
  begin
    with frmMHA_ASI_Entry_508 do
      begin
        save := '';
        // There have been checks on reguired items already. A blank item now
        // will get an "X"
        if Item.ItemIndex >= Start then
          begin
            save := IntToStr(Item.ItemIndex + Start);
            if Item.ItemIndex = X then
              save := 'X';
            if Item.ItemIndex = N then
              save := 'N';
          end;
        if Item.ItemIndex = -1 then
          save := 'X';
        if Start = 1 then
          if Item.ItemIndex = 0 then
            save := IntToStr(Start);
        if Start = 0 then
          if Item.ItemIndex = 0 then
            save := IntToStr(Start);
        if OkToSaveItem(Item.Name) then
          ASI_OPS.ChoicesMade.Add(MCode + save + '^');
      end;
  end; // List box Answer function

  procedure SaveComboBox(MCode: string; Item: TRzComboBox; Start, X, N: integer);
  var
    save                      : string;
  begin
    with frmMHA_ASI_Entry_508 do
      begin
        save := '';
        // There have been checks on reguired items already. A blank item now
        // will get an "X"
        if Item.ItemIndex = -1 then
          save := 'X';
        if Start = 1 then
          if Item.ItemIndex = 0 then
            save := IntToStr(Start);
        if Item.ItemIndex >= Start then
          begin
            save := IntToStr(Item.ItemIndex + Start);
            if Item.ItemIndex = X then
              save := 'X';
            if Item.ItemIndex = N then
              save := 'N';
          end;
        if OkToSaveItem(Item.Name) then
          ASI_OPS.ChoicesMade.Add(MCode + save + '^');
      end;
  end; // Combo Box Answer function

  procedure SaveListBoxII(MCode: string; Item: TListBox);
    // Used for L23 (14.26) and L25 (14.28)
  var
    Save                      : string;
  begin
    with frmMHA_ASI_Entry_508 do
      begin
        save := '';
        case Item.ItemIndex of
          0: save := '3';
          1: save := '4';
          2: save := '5';
          3: save := '6';
          4: save := '7';
          5: save := '8';
          6: save := '9';
          7: save := '10';
          8: save := '11';
          9: save := '12';
          10: save := '13';
          11: save := '14';
          12: save := '15';
          13: save := '16';
          14: save := '18';
          15: save := '19';
          16: save := '20';
          17: save := 'X';
          18: save := 'N';
        end;
        if OkToSaveItem(Item.Name) then
          ASI_OPS.ChoicesMade.Add(MCode + save + '^');
      end;
  end; // Legal Radio Group

  procedure SaveListBoxIII(MCode: string; Item: TListBox);
    // Used for D14 (10.45)
  var
    Save                      : string;
  begin
    with frmMHA_ASI_Entry_508 do
      begin
        save := '';
        case Item.ItemIndex of
          0: save := '0';
          1: save := '1';
          2: save := '2';
          3: save := '3';
          4: save := '4';
          5: save := '5';
          6: save := '6';
          7: save := '7';
          8: save := '8';
          9: save := '9';
          10: save := '10';
          11: save := '11';
          12: save := '12';
          13: save := '15';
          14: save := '16';
          15: save := 'X';
          16: save := 'N';
        end;
        if OkToSaveItem(Item.Name) then
          ASI_OPS.ChoicesMade.Add(MCode + save + '^');
      end;
  end; // Legal Radio Group

  procedure SaveCommentField(Memo: TFMMemo; Field: string);
  begin
    with frmMHA_ASI_Entry_508, Memo do
      begin
        // The carriage returns in the memo are saved on the M-side.
        // Make the comments fields the same as Vista-size fields.
        // Do not turn off WordWrap--comment will not be saved at all.
        Align := alNone;
        Font.Name := 'Courier New';
        Font.Size := 9;
        Width := 567;
        // re-wrap
        Refresh;

        FMFile := '604';
        FMField := Field;
        IENS := TempIENS;

        DataModule1.RPCBroker1.CreateContext('YS BROKER1');
        // Set the FMFiler property to the TFMFiler component to use to file changes.
        FMFiler := DataModule1.FMFiler1;
        //Add the particular memo control to the list of controls to be updated.
        FMFiler.AddChgdControl(memo);
        // regular screen is returned when rebuilt, don't do it here.
      end;
  end;


  // main part of the SaveData procedure
begin
  Result := OK;

  if TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itFull then
    gvASI_Type := 1;
  if TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itLite then
    gvASI_Type := 2;
  if TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itFU then
    gvASI_Type := 3;
  if TASI(ASI_OPS.ListOfASIResults[gvCurrentResult]).InterviewType = itMV then
    gvASI_Type := 4;


  with frmMHA_ASI_Entry_508 do
    begin
      if not FASITimedOut then
        begin
          Screen.Cursor := crHourglass;
          //lblHint.Caption := 'Saving data . . . .';
        end;

      ASI_OPS.ChoicesMade.Clear;

      // General---------------------------------------------------------
      ASI_OPS.ChoicesMade.Add('NAME^.02^' + aPatientDFN + '^');
      ASI_OPS.ChoicesMade.Add('INTRCODE^.81^' + aInterviewerDUZ + '^');
      ASI_OPS.ChoicesMade.Add('ORDEREDBY^.09^' + aOrderedByDUZ + '^');
      if  aProgramIEN <> '' then
        ASI_OPS.ChoicesMade.Add('PROGRAM^2^' + aProgramIEN + '^');
      SaveEdit('ADMITED^1^', dtpG4);
      SaveEdit('INTDATE^.05^', dtpG5);

      //SaveListBox('CLASS^.04^', rgrpG8, 1, -1, -1);
      if gvASI_Type = 1 then
        ASI_OPS.ChoicesMade.Add('CLASS^.04^1^');
      if gvASI_Type = 2 then
        ASI_OPS.ChoicesMade.Add('CLASS^.04^2^');
      if gvASI_Type = 3 then
        ASI_OPS.ChoicesMade.Add('CLASS^.04^3^');
      if gvASI_Type = 4 then
        ASI_OPS.ChoicesMade.Add('CLASS^.04^4^');

      SaveListBox('CONTACT^.07^', rgrpG9, 1, -1, -1);
      SaveListBox('SPECIAL^.11^', rgrpG12, 1, -1, 3);

      if (gvASI_Type <> 3 {Followup}) then
        begin
          SaveSpinEdit('ADDYEARS^1.201^', edtG14y);
          SaveSpinEdit('ADDMONTS^1.202^', edtG14m);
          if (gvASI_Type = 1 {Full}) then
            SaveListBox('OWNHOME^1.203^', rgrpG15, 0, 2, -1);
          if rgrpG17.ItemIndex <> -1 then
            SaveListBox('RACE^.16^', rgrpG17, 1, -1, -1);
          if rgrpG18.ItemIndex <> -1 then
            SaveListBox('RELIGION^.17^', rgrpG18, 1, -1, -1);
        end;

      SaveListBox('CONENV^2.01^', rgrpG19, 1, 6, 7);
      if edtG19e.Enabled then
        SaveRzEdit('OTHER^2.02^', edtG19e);
      if edtG20.Enabled then // see page 92, pink manual
        begin
          SaveSpinEdit('CONENTIM^2.03^', edtG20);
        end
      else
        if ((not FUserTerminates) or (rgrpG12.ItemIndex = 3)) then
          ASI_OPS.ChoicesMade.Add('CONENTIM^2.03^N^');

      // Medical --------------------------------------------------------
      SaveSpinEdit('HOSPLIFE^8.01^', edtM1);
      if (gvASI_Type = 1 {Full}) then
        begin
          if edtM2y.Enabled then // see page 92, pink manual
            begin
              SaveSpinEdit('HOSPYEAR^8.02^', edtM2y);
            end
          else
            if ((not FUserTerminates) or (rgrpG12.ItemIndex = 3)) then
              ASI_OPS.ChoicesMade.Add('HOSPYEAR^8.02^N^');
          if edtM2m.Enabled then // see page 92, pink manual
            begin
              SaveSpinEdit('HOSPMONT^8.025^', edtM2m);
            end
          else
            if ((not FUserTerminates) or (rgrpG12.ItemIndex = 3)) then
              ASI_OPS.ChoicesMade.Add('HOSPMONT^8.025^N^');
        end;
      if (gvASI_Type <> 3 {Followup}) then
        begin
          SaveListBox('CHRONMED^8.03^', rgrpM3, 0, 2, -1);
          if edtM3e.Enabled then
            SaveRzEdit('CHRONMEDSPEC^8.04^', edtM3e);
        end;

      SaveListBox('MEDICATS^8.05^', rgrpM4, 0, 2, -1);
      SaveListBox('PHYSDIS^8.06^', rgrpM5, 0, 2, -1);
      if edtM5e.Enabled then
        SaveRzEdit('PHYSDISSPEC^8.07^', edtM5e);
      SaveSpinEdit('DAYMEDP^8.08^', edtM6);
      SaveListBox('TROUBLED^8.09^', rgrpM7, 0, 5, -1);
      SaveListBox('IMPTMT^8.11^', rgrpM8, 0, 5, -1);
      if ((gvASI_Type = 1 {Full}) or (gvASI_Type = 3 {Followup})) then
        SaveListBox('ISRMED^8.12^', rgrpM9, 0, 10, -1);
      SaveListBox('MPATMISR^8.14^', rgrpM10, 0, 2, -1);
      SaveListBox('MEDUNDER^8.15^', rgrpM11, 0, 2, -1);

      // Employment -----------------------------------------------------
      SaveSpinEdit('EDUCYEAR^9.01^', edtE1y);
      SaveSpinEdit('EDUCMONT^9.02^', edtE1m);
      SaveSpinEdit('TRAINING^9.03^', edtE2);
      if gvASI_Type = 0 {Full} then
        begin
          SaveListBox('PROFN^9.04^', rgrpE3, 0, 2, -1);
          if edtE3e.Enabled then
            SaveRzEdit('SPECPTS^9.05^', edtE3e);
        end;
      SaveListBox('LICENSE^9.06^', rgrpE4, 0, 2, -1);
      if rgrpE5.Enabled then
        SaveListBox('CAR^9.09^', rgrpE5, 0, 2, -1)
      else
        if ((not FUserTerminates) or (rgrpG12.ItemIndex = 3)) then
          ASI_OPS.ChoicesMade.Add('CAR^9.09^0^');
      if ((gvASI_Type = 1 {Full}) or (gvASI_Type = 2 {Lite})) then
        begin
          SaveSpinEdit('JOBYEAR^9.11^', edtE6y);
          SaveSpinEdit('JOBMONTH^9.12^', edtE6m);
        end;
      SaveListBox('OCCUP^9.14^', rgrpE7, 1, -1, 9);
      SaveRzEdit('SPECOCCUP^9.145^', edtE7e);
      if ((gvASI_Type = 1 {Full}) or (gvASI_Type = 3 {Followup})) then
        SaveListBox('SUPPORT^9.15^', rgrpE8, 0, 2, -1);
      // Item may be disabled, set to "N", see page 92, pink manual
      if rgrpE9.Enabled then
        SaveListBox('MAJORITY^9.16^', rgrpE9, 0, 2, 3)
      else
        ASI_OPS.ChoicesMade.Add('MAJORITY^9.16^N^');
      //  end
      //else
      //  if ((not FUserTerminates) or (rgrpG12.ItemIndex = 3)) then
      //    ASI_OPS.ChoicesMade.Add('MAJORITY^9.16^N^');
      if ((gvASI_Type = 1 {Full}) or (gvASI_Type = 2 {Lite})) then
        SaveListBox('PATTERNS^9.17^', rgrpE10, 1, 8, 9);
      SaveSpinEdit('DAYSPAID^9.18^', edtE11);
      SaveEdit('EMPL$^9.19^', edtE12);
      SaveEdit('UNEMPLOY^9.21^', edtE13);
      SaveEdit('DPA^9.22^', edtE14);
      SaveEdit('PENSION^9.23^', edtE15);
      SaveEdit('FAMILY^9.24^', edtE16);
      SaveEdit('ILLEGAL^9.25^', edtE17);
      SaveSpinEdit('DEPENDS^9.29^', edtE18);
      if ((gvASI_Type = 1 {Full}) or (gvASI_Type = 3 {Followup})) then
        begin
          SaveSpinEdit('EMPROB^9.31^', edtE19);
          SaveListBox('EMPTROUB^9.32^', rgrpE20, 0, 5, 6);
        end;
      SaveListBox('EMPCOUNS^9.33^', rgrpE21, 0, 5, 6);
      if ((gvASI_Type = 1 {Full}) or (gvASI_Type = 3 {Followup})) then
        SaveListBox('EMPLOYRA^9.34^', rgrpE22, 0, 10, -1);
      SaveListBox('EPATMISR^9.35^', rgrpE23, 0, 2, -1);
      SaveListBox('EMPUNDER^9.36^', rgrpE24, 0, 2, -1);

      // Drug and Alcohol ------------------------------------------------
      SaveSpinEdit('ALC30^10.01^', edtD1d);
      SaveSpinEdit('ALCLIYR^10.02^', edtD1y);
      SaveListBox('ALCRT^10.03^', lbD1r, 1, 5, -1);
      SaveSpinEdit('ALCIN30^10.04^', edtD2d);
      SaveSpinEdit('ALCINLIY^10.05^', edtD2y);
      SaveListBox('INTOXRT^10.06^', lbD2r, 1, 5, -1);
      SaveSpinEdit('HEROIN30^10.07^', edtD3d);
      SaveSpinEdit('HERONLIY^10.08^', edtD3y);
      SaveListBox('HERNRT^10.09^', lbD3r, 1, 5, -1);
      SaveSpinEdit('METHDN30^10.11^', edtD4d);
      SaveSpinEdit('METDNLIY^10.12^', edtD4y);
      SaveListBox('METHRT^10.14^', lbD4r, 1, 5, -1);
      SaveSpinEdit('OPIAT30^10.15^', edtD5d);
      SaveSpinEdit('OPIATLIY^10.16^', edtD5y);
      SaveListBox('OPIRT^10.17^', lbD5r, 1, 5, -1);
      SaveSpinEdit('BARB30^10.18^', edtD6d);
      SaveSpinEdit('BARBLIFY^10.19^', edtD6y);
      SaveListBox('BARBRT^10.21^', lbD6r, 1, 5, -1);
      SaveSpinEdit('SEDS30^10.22^', edtD7d);
      SaveSpinEdit('SEDLIFYR^10.23^', edtD7y);
      SaveListBox('SEDSRT^10.24^', lbD7r, 1, 5, -1);
      SaveSpinEdit('COCAN30^10.25^', edtD8d);
      SaveSpinEdit('COCLIFYR^10.26^', edtD8y);
      SaveListBox('COCAINRT^10.27^', lbD8r, 1, 5, -1);
      SaveSpinEdit('AMPH30^10.28^', edtD9d);
      SaveSpinEdit('AMPLIFYR^10.29^', edtD9y);
      SaveListBox('AMPRT^10.31^', lbD9r, 1, 5, -1);
      SaveSpinEdit('MJ30^10.32^', edtD10d);
      SaveSpinEdit('MJLIFEYR^10.33^', edtD10y);
      SaveListBox('MJRT^10.34^', lbD10r, 1, 5, -1);
      SaveSpinEdit('HALLU30^10.35^', edtD11d);
      SaveSpinEdit('HALLIFYR^10.36^', edtD11y);
      SaveListBox('HALRT^10.37^', lbD11r, 1, 5, -1);
      SaveSpinEdit('INHA30^10.38^', edtD12d);
      SaveSpinEdit('INHALIYR^10.39^', edtD12y);
      SaveListBox('INHALRT^10.41^', lbD12r, 1, 5, -1);
      SaveSpinEdit('GT130^10.42^', edtD13d);
      SaveSpinEdit('GT1LIYR^10.43^', edtD13y);
      if ((gvASI_Type = 1 {Full}) or (gvASI_Type = 3 {Followup})) then
        if rgrpD14.ItemIndex <> -1 then
          SaveListBoxIII('MAJPROB^10.45^', rgrpD14);
      if gvASI_Type = 0 {Full} then
        begin
          if edtD15.Enabled then //See page 46, pink manual
            SaveSpinEdit('LONGABST^11.01^', edtD15)
          else
            if ((not FUserTerminates) or (rgrpG12.ItemIndex = 3)) then
              ASI_OPS.ChoicesMade.Add('LONGABST^11.01^N^');
          if edtD16.Enabled then //See page 46, pink manual
            SaveSpinEdit('LASTABST^11.02^', edtD16)
          else
            if ((not FUserTerminates) or (rgrpG12.ItemIndex = 3)) then
              ASI_OPS.ChoicesMade.Add('LASTABST^11.02^N^');
        end;
      if ((gvASI_Type = 1 {Full}) or (gvASI_Type = 3 {Followup})) then
        begin
          SaveSpinEdit('DTS^11.03^', edtD17);
          SaveSpinEdit('ODS^11.04^', edtD18);
        end;
      SaveSpinEdit('ALCTXS^11.05^', edtD19);
      SaveSpinEdit('DRUGTXS^11.06^', edtD20);
      if ((gvASI_Type = 1 {Full}) or (gvASI_Type = 3 {Followup})) then
        begin
          if edtD21.Enabled then
            SaveSpinEdit('ALDETOX^11.07^', edtD21)
          else
            if ((not FUserTerminates) or (rgrpG12.ItemIndex = 3)) then
              ASI_OPS.ChoicesMade.Add('ALDETOX^11.07^N^');
          if edtD22.Enabled then
            SaveSpinEdit('DRUDETOX^11.08^', edtD22)
          else
            if ((not FUserTerminates) or (rgrpG12.ItemIndex = 3)) then
              ASI_OPS.ChoicesMade.Add('DRUDETOX^11.08^N^');
        end;
      SaveSpinEdit('ALCMONEY^11.09^', edtD23);
      SaveSpinEdit('DRUMONEY^11.11^', edtD24);
      SaveSpinEdit('OPDAYS^11.12^', edtD25);
      SaveSpinEdit('ALPROBS^11.14^', edtD26);
      SaveSpinEdit('DRUPROBS^11.15^', edtD27);
      if rgrpD28.Enabled then
        SaveListBox('ALBOTHR^11.16^', rgrpD28, 0, 5, 6)
      else
        if ((not FUserTerminates) or (rgrpG12.ItemIndex = 3)) then
          ASI_OPS.ChoicesMade.Add('ALBOTHR^11.16^0^');
      if rgrpD29.Enabled then
        SaveListBox('DRUGBOTH^11.17^', rgrpD29, 0, 5, 6)
      else
        if ((not FUserTerminates) or (rgrpG12.ItemIndex = 3)) then
          ASI_OPS.ChoicesMade.Add('DRUGBOTH^11.17^0^');
      if rgrpD30.Enabled then
        SaveListBox('ALTMT^11.165^', rgrpD30, 0, 5, 6)
      else
        if ((not FUserTerminates) or (rgrpG12.ItemIndex = 3)) then
          ASI_OPS.ChoicesMade.Add('ALTMT^11.165^0^');
      if rgrpD31.Enabled then
        SaveListBox('DRUTMT^11.175^', rgrpD31, 0, 5, 6)
      else
        if ((not FUserTerminates) or (rgrpG12.ItemIndex = 3)) then
          ASI_OPS.ChoicesMade.Add('DRUTMT^11.175^0^');
      if ((gvASI_Type = 1 {Full}) or (gvASI_Type = 3 {Followup})) then
        begin
          SaveListBox('ISRALC^11.18^', rgrpD32, 0, 10, 11);
          SaveListBox('ISRDRUG^11.185^', rgrpD33, 0, 10, -1);
        end;
      SaveListBox('DAMISREP^11.19^', rgrpD34, 0, 2, -1);
      if rgrpD35.ItemIndex <> -1 then
        SaveListBox('DAUNDER^11.21^', rgrpD35, 0, -1, -1);

      // Legal  ---------------------------------------------------------
      if ((gvASI_Type = 1 {Full}) or (gvASI_Type = 2 {Lite})) then
        SaveListBox('CJINVOLV^14.01^', rgrpL1, 0, 2, -1);
      SaveListBox('ONPROBAT^14.02^', rgrpL2, 0, 2, -1);
      SaveSpinEdit('SHOPLIFT^14.03^', edtL3);
      SaveSpinEdit('PAROLVIL^14.04^', edtL4);
      SaveSpinEdit('DRUGCHAR^14.05^', edtL5);
      SaveSpinEdit('FORGE^14.06^', edtL6);
      SaveSpinEdit('WEAPONS^14.07^', edtL7);
      SaveSpinEdit('B_N_E^14.08^', edtL8);
      SaveSpinEdit('ROBBERY^14.09^', edtL9);
      SaveSpinEdit('ASSAULT^14.11^', edtL10);
      SaveSpinEdit('ARSON^14.12^', edtL11);
      SaveSpinEdit('RAPE^14.14^', edtL12);
      SaveSpinEdit('MURDER^14.15^', edtL13);
      SaveSpinEdit('PROSTITU^14.16^', edtL14);
      SaveSpinEdit('CONTEMPT^14.17^', edtL15);
      SaveSpinEdit('OTHER^14.18^', edtL16);
      if edtL17.Enabled then // page 92 of pink book
        SaveSpinEdit('CONVICTS^14.19^', edtL17)
      else
        if ((not FUserTerminates) or (rgrpG12.ItemIndex = 3)) then
          ASI_OPS.ChoicesMade.Add('CONVICTS^14.19^N^');
      SaveSpinEdit('DISORDER^14.21^', edtL18);
      SaveSpinEdit('DWI^14.22^', edtL19);
      SaveSpinEdit('DRIVING^14.23^', edtL20);
      SaveSpinEdit('INCARLI^14.24^', edtL21);
      if ((gvASI_Type = 1 {Full}) or (gvASI_Type = 3 {Followup})) then
        begin
          if edtL22.Enabled then
            SaveSpinEdit('LASTINCA^14.25^', edtL22)
          else
            if ((not FUserTerminates) or (rgrpG12.ItemIndex = 3)) then
              ASI_OPS.ChoicesMade.Add('LASTINCA^14.25^N^');
          // Check proper answer for no crimes at all: Blank, "0", "N" ??
          // This will be the same response for L25
          if rgrpL23.Enabled then
            begin
              if rgrpL23.ItemIndex <> -1 then
                SaveListBoxII('REASONIN^14.26^', rgrpL23)
            end
          else
            if ((not FUserTerminates) or (rgrpG12.ItemIndex = 3)) then
              ASI_OPS.ChoicesMade.Add('REASONIN^14.26^N^');
        end;
      SaveListBox('WAITRIAL^14.27^', rgrpL24, 0, 2, -1);
      if rgrpL25.Enabled then
        begin
          if rgrpL25.ItemIndex <> -1 then
            SaveListBoxII('REASTRIA^14.28^', rgrpL25)
        end
      else
        if ((not FUserTerminates) or (rgrpG12.ItemIndex = 3)) then
          ASI_OPS.ChoicesMade.Add('REASONIN^14.28^N^');
      if edtL26.Enabled then
        SaveSpinEdit('DETAIN30^14.29^', edtL26)
      else
        if ((not FUserTerminates) or (rgrpG12.ItemIndex = 3)) then
          ASI_OPS.ChoicesMade.Add('DETAIN30^14.29^0^');
      SaveSpinEdit('ILLDAY30^14.31^', edtL27);
      SaveListBox('PRALEGAL^14.32^', rgrpL28, 0, 5, 6);
      SaveListBox('PRACOUNS^14.33^', rgrpL29, 0, 5, 6);
      if ((gvASI_Type = 1 {Full}) or (gvASI_Type = 3 {Followup})) then
        SaveListBox('ISRLEGAL^14.34^', rgrpL30, 0, 10, -1);
      SaveListBox('LPMISREP^14.35^', rgrpL31, 0, 2, -1);
      SaveListBox('LPTUNDER^14.36^', rgrpL32, 0, 2, -1);

      // Family History ---------------------------------------------------
      if gvASI_Type = 1 then // Full ASI
        begin
          SaveListBox('FHMGM^15.01^', lbH1a, 0, 2, 3);
          SaveListBox('FHMGM^15.02^', lbH1d, 0, 2, 3);
          SaveListBox('FHMGM^15.03^', lbH1p, 0, 2, 3);
          SaveListBox('FHMGF^15.04^', lbH2a, 0, 2, 3);
          SaveListBox('FHMGF^15.05^', lbH2d, 0, 2, 3);
          SaveListBox('FHMGF^15.06^', lbH2p, 0, 2, 3);
          SaveListBox('FHMM^15.07^', lbH3a, 0, 2, 3);
          SaveListBox('FHMM^15.08^', lbH3d, 0, 2, 3);
          SaveListBox('FHMM^15.09^', lbH3p, 0, 2, 3);
          SaveListBox('FHMA^15.11^', lbH4a, 0, 2, 3);
          SaveListBox('FHMA^15.12^', lbH4d, 0, 2, 3);
          SaveListBox('FHMA^15.14^', lbH4p, 0, 2, 3);
          SaveListBox('FHMU^15.15^', lbH5a, 0, 2, 3);
          SaveListBox('FHMU^15.16^', lbH5d, 0, 2, 3);
          SaveListBox('FHMU^15.17^', lbH5p, 0, 2, 3);
          SaveListBox('FHFGM^15.18^', lbH6a, 0, 2, 3);
          SaveListBox('FHFGM^15.19^', lbH6d, 0, 2, 3);
          SaveListBox('FHFGM^15.21^', lbH6p, 0, 2, 3);
          SaveListBox('FHFGF^15.22^', lbH7a, 0, 2, 3);
          SaveListBox('FHFGF^15.23^', lbH7d, 0, 2, 3);
          SaveListBox('FHFGF^15.24^', lbH7p, 0, 2, 3);
          SaveListBox('FHFF^15.25^', lbH8a, 0, 2, 3);
          SaveListBox('FHFF^15.26^', lbH8d, 0, 2, 3);
          SaveListBox('FHFF^15.27^', lbH8p, 0, 2, 3);
          SaveListBox('FHFA^16.01^', lbH9a, 0, 2, 3);
          SaveListBox('FHFA^16.02^', lbH9d, 0, 2, 3);
          SaveListBox('FHFA^16.03^', lbH9p, 0, 2, 3);
          SaveListBox('FHFU^16.04^', lbH10a, 0, 2, 3);
          SaveListBox('FHFU^16.05^', lbH10d, 0, 2, 3);
          SaveListBox('FHFU^16.06^', lbH10p, 0, 2, 3);
          SaveListBox('FHIBB^16.07^', lbH11a, 0, 2, 3);
          SaveListBox('FHIBB^16.08^', lbH11d, 0, 2, 3);
          SaveListBox('FHIBB^16.09^', lbH11p, 0, 2, 3);
          SaveListBox('FHIBS^16.11^', lbH12a, 0, 2, 3);
          SaveListBox('FHIBS^16.12^', lbH12d, 0, 2, 3);
          SaveListBox('FHIBS^16.14^', lbH12p, 0, 2, 3);
        end; // Full ASI

      // Social ---------------------------------------------------------
      SaveListBox('MARSTAT^17.01^', rgrpF1, 1, 6, -1);
      if gvASI_Type = 1 then // Full ASI
        begin
          SaveSpinEdit('MARYRS^17.02^', edtF2y);
          SaveSpinEdit('MARMOS^17.03^', edtF2m);
        end;
      SaveListBox('MARSATF^17.04^', rgrpF3, 0, 3, 4);
      SaveListBox('LIVARRGN^17.05^', rgrpF4, 1, 9, 10);
      if gvASI_Type = 1 then // Full ASI
        begin
          SaveSpinEdit('LIVYRS^17.06^', edtF5y);
          SaveSpinEdit('LIVMONTH^17.07^', edtF5m);
        end;
      SaveListBox('LIVSATF^17.08^', rgrpF6, 0, 3, 4);
      SaveListBox('LIVWALC^17.09^', rgrpF7, 0, 2, -1);
      SaveListBox('LIVWDRUG^17.11^', rgrpF8, 0, 2, -1);
      if ((gvASI_Type = 1 {Full}) or (gvASI_Type = 3 {Followup})) then
        begin
          SaveListBox('FREETIME^17.12^', rgrpF9, 1, 3, 4);
          SaveListBox('FREESATF^17.14^', rgrpF10, 0, 3, 4);
          SaveSpinEdit('CLOSFREN^17.15^', edtF11);
        end;
      if gvASI_Type = 1 then // Full ASI
        begin
          SaveListBox('CLOSMOTR^17.16^', lbF12, 0, 2, 3);
          SaveListBox('CLOSFATR^17.17^', lbF13, 0, 2, 3);
          SaveListBox('CLOSSIBS^17.18^', lbF14, 0, 2, 3);
          SaveListBox('CLOSPRTN^17.19^', lbF15, 0, 2, 3);
          SaveListBox('CLOSKIDS^17.21^', lbF16, 0, 2, 3);
          SaveListBox('CLOSFREN^17.22^', lbF17, 0, 2, 3);
        end;
      SaveListBox('MOM30^18.01^', rgrpF18, 0, 2, 3);
      SaveListBox('MOMLIFE^18.02^', rgrpF18l, 0, 2, 3);
      SaveListBox('DAD30^18.03^', rgrpF19, 0, 2, 3);
      SaveListBox('DADLIFE^18.04^', rgrpF19l, 0, 2, 3);
      SaveListBox('SIBS30^18.05^', rgrpF20, 0, 2, 3);
      SaveListBox('SIBSLIFE^18.06^', rgrpF20l, 0, 2, 3);
      SaveListBox('SPOUS30^18.07^', rgrpF21, 0, 2, 3);
      SaveListBox('SPOULIFE^18.08^', rgrpF21l, 0, 2, 3);
      SaveListBox('KIDS30^18.09^', rgrpF22, 0, 2, 3);
      SaveListBox('KIDSLIFE^18.11^', rgrpF22l, 0, 2, 3);
      SaveListBox('OTHFAM30^18.12^', rgrpF23, 0, 2, 3);
      SaveListBox('OTHFAMLI^18.14^', rgrpF23l, 0, 2, 3);
      if rgrpF24.Enabled then // See page 92 in pink manual
        SaveListBox('FREN30^18.15^', rgrpF24, 0, 2, 3)
      else
        if ((not FUserTerminates) or (rgrpG12.ItemIndex = 3)) then
          ASI_OPS.ChoicesMade.Add('FREN30^18.15^N^');
      SaveListBox('FRENLIFE^18.16^', rgrpF24l, 0, 2, 3);
      SaveListBox('NEIGH30^18.17^', rgrpF25, 0, 2, 3);
      SaveListBox('NEIGHLIF^18.18^', rgrpF25l, 0, 2, 3);
      if rgrpF26.Enabled then // See page 92 in pink manual
        SaveListBox('COWOR30^18.185^', rgrpF26, 0, 2, 3)
      else
        if ((not FUserTerminates) or (rgrpG12.ItemIndex = 3)) then
          ASI_OPS.ChoicesMade.Add('COWOR30^18.185^N^');
      SaveListBox('COWORLIF^18.186^', rgrpF26l, 0, 2, 3);
      if ((gvASI_Type = 1 {Full}) or (gvASI_Type = 3 {Followup})) then
        SaveListBox('EMOABU30^18.19^', rgrpF27, 0, 2, 3);
      SaveListBox('EMOABULI^18.195^', rgrpF27l, 0, 2, 3);
      SaveListBox('PHYABU30^18.21^', rgrpF28, 0, 2, 3);
      SaveListBox('PHYABULI^18.215^', rgrpF28l, 0, 2, 3);
      SaveListBox('SEXABU30^18.22^', rgrpF29, 0, 2, 3);
      SaveListBox('SEXABULI^18.225^', rgrpF29l, 0, 2, 3);
      SaveSpinEdit('FAMCONFL^18.23^', edtF30);
      SaveSpinEdit('OTHCONFL^18.24^', edtF31);
      SaveListBox('PRAFPROB^18.25^', rgrpF32, 0, 5, 6);
      if ((gvASI_Type = 1 {Full}) or (gvASI_Type = 3 {Followup})) then
        SaveListBox('PRASPROB^18.26^', rgrpF33, 0, 5, 6);
      SaveListBox('FAMTMT^18.27^', rgrpF34, 0, 5, 6);
      if ((gvASI_Type = 1 {Full}) or (gvASI_Type = 3 {Followup})) then
        begin
          SaveListBox('SOCTMT^18.28^', rgrpF35, 0, 5, 6);
          SaveListBox('ISRFS^18.29^', rgrpF36, 0, 10, -1);
        end;
      SaveListBox('FSMISREP^18.31^', rgrpF37, 0, 2, -1);
      SaveListBox('FSPUND^18.32^', rgrpF38, 0, 2, -1);

      // Psych ----------------------------------------------------------
      SaveSpinEdit('INPSYC^19.01^', edtP1a);
      SaveSpinEdit('OUTPSYC^19.02^', edtP1b);
      SaveListBox('PSYCPEN^19.03^', rgrpP2, 0, 2, -1);
      SaveListBox('DEPR30^19.04^', rgrpP3, 0, 2, -1);
      SaveListBox('DEPRLIFE^19.05^', rgrpP3l, 0, 2, -1);
      SaveListBox('ANXT30^19.06^', rgrpP4, 0, 2, -1);
      SaveListBox('ANXTLIFE^19.07^', rgrpP4l, 0, 2, -1);
      SaveListBox('HALL30^19.08^', rgrpP5, 0, 2, -1);
      SaveListBox('HALLLIFE^19.09^', rgrpP5l, 0, 2, -1);
      SaveListBox('UNDER30^19.11^', rgrpP6, 0, 2, -1);
      SaveListBox('UNDERLIF^19.12^', rgrpP6l, 0, 2, -1);
      SaveListBox('VIOL30^19.14^', rgrpP7, 0, 2, -1);
      SaveListBox('VIOLLIFE^19.15^', rgrpP7l, 0, 2, -1);
      SaveListBox('SUITH30^19.16^', rgrpP8, 0, 2, -1);
      SaveListBox('SUITHLIF^19.17^', rgrpP8l, 0, 2, -1);
      SaveListBox('SUIAT30^19.18^', rgrpP9, 0, 2, -1);
      SaveListBox('SUIATLIF^19.19^', rgrpP9l, 0, 2, -1);
      SaveListBox('PMED30^19.21^', rgrpP10, 0, 2, -1);
      SaveListBox('PMEDLIFE^19.22^', rgrpP10l, 0, 2, -1);
      SaveSpinEdit('PSYCDAYS^19.23^', edtP11);
      SaveListBox('PRATPSY^19.24^', rgrpP12, 0, 5, -1);
      SaveListBox('PSYTMT^19.25^', rgrpP13, 0, 5, -1);
      if ((gvASI_Type = 1 {Full}) or (gvASI_Type = 3 {Followup})) then
        begin
          SaveListBox('DEPNOW^19.26^', rgrpP14, 0, 2, -1);
          SaveListBox('HOSTNOW^19.27^', rgrpP15, 0, 2, -1);
          SaveListBox('ANXNOW^19.28^', rgrpP16, 0, 2, -1);
          SaveListBox('REALNOW^19.29^', rgrpP17, 0, 2, -1);
          SaveListBox('COMPRNOW^19.31^', rgrpP18, 0, 2, -1);
          SaveListBox('SUICNOW^19.32^', rgrpP19, 0, 2, -1);
          SaveListBox('ISRPSYC^19.33^', rgrpP20, 0, 10, -1);
        end;
      SaveListBox('PMISREP^19.34^', rgrpP21, 0, 2, -1);
      SaveListBox('PSPUND^19.35^', rgrpP22, 0, 2, -1);

      TempIENS := ASI_OPS.SaveChoicesMade(
        aRecordIENS <> NO_ID,
        aRecordIENS,
        aPatientDFN,
        aDate,
        aInterviewerDUZ,
        aOrderedbyDUZ,
        aInterviewType);

      // When successful this is returned:
      // "OK ASI SAVED XXXX," where XXXX is the RecordIEN

      if TempIENS <> BAD_DATA then
        begin
          try
            // Save Comments, these are memo fields
            SaveCommentField(memGeneral, '.6');
            SaveCommentField(memMedical, '8.5');
            SaveCommentField(memEmploy, '9.5');
            SaveCommentField(memDrug, '10.5');
            SaveCommentField(memLegal, '14.5');
            SaveCommentField(memFamily, '16.5');
            SaveCommentField(memSocial, '18.5');
            SaveCommentField(memPsych, '19.5');
            SaveCommentField(memLeisure, '187');
            SaveCommentField(memSpirit, '188');
            // Update "saves" data from ALL controls SaveComboBoxed
            // using SaveComboBoxChgdControl in SaveCommentField
            if DataModule1.FMFiler1.Update then
            else
              DataModule1.FMFiler1.DisplayErrors;
          finally;
          end;
        end
      else
        Result := 'The ASI was not saved in the VistA database. Please try to save it again.';

      if not FASITimedOut then
        Screen.Cursor := crDefault;
    end;
end;


end.

