
unit uMHA_Battery;

interface

uses
  Classes;

type
  TBattery = class
  private
    FBatteryName,
      FBatteryID: string;
    FInstrumentsInBattery: TStringList;
  protected
  public
    constructor Create;
    destructor Destroy; override;

    property BatteryName: string read FBatteryName write FBatteryName;
    property BatteryID: string read FBatteryID write FBatteryID;
    property InstrumentsInBattery: TStringList read FInstrumentsInBattery
      write FInstrumentsInBattery; // Name only, no ID
    procedure Clear;
  published
  end; { TBattery }

implementation

procedure TBattery.Clear;
begin
  FBatteryName := '';
  FBatteryID := '';
  FInstrumentsInBattery.Clear;
end;


destructor TBattery.Destroy;
begin
  if FInstrumentsInBattery <> nil then
    FInstrumentsInBattery.Free;
  inherited Destroy;
end;

constructor TBattery.Create;
begin
  inherited Create;
  FInstrumentsInBattery := TStringList.Create;
end;

end.

