unit uMHA_Patient_IO;

interface

uses
  Windows,
  Messages,
  TRPCb,
  SysUtils;


function PatientLoad(ADFN: string): string;
procedure PatientSelectUsingCPRS;
procedure PatientClear;


implementation

uses
  uIA_Const,
  uMHA_Const,
  uIA_Utils,
  uIA_Patient,
  uMHA_DM;



function ReadPatientProperties(ADFN: string): string;
var
  i                           : integer;
var
  tmpDFN                      : string;
begin
  //To prevent an undefined result
  Result := '';

  tmpDFN := ADFN;

  with DataModule1.RPCBroker1 do
    begin
      ClearResults := True;
      ClearParameters := True;
      CreateContext('YS BROKER1');
      RemoteProcedure := 'YTQ PATIENT INFO';
      Param[0].Mult['"DFN"'] := tmpDFN;
      Param[0].PType := List;

      Call;

      if not (Results[0] = DATA) then
        Result := BAD_DATA
      else
        for i := 1 to 7 do
          Result := Result + Results[i] + RECORD_END;

    //         Output
    //         ; YSDATA(2)= name
    //         ; YSDATA(3)=ssn
    //         ; YSDATA(4)=dob
    //         ; YSDATA(5)=age
    //         ; YSDATA(6)=sex
    //         ; YSDATA(7)=date of death
    //         ; YSDATA(8)=0 NCS/ 1 SC^%^service connected
    //
    //
    //
    //[DATA]
    //GREEN,FROG^name
    //123456789^123-45-6789^ssn
    //2470420^APR 20,1947^dob
    //57^age
    //M^MALE^sex
    //0^^date of death
    //0^service connected
    end;
end;

(*
function PatientLoad(ADFN: string): string;
var
  tmpPt, tmpPiece             : string;
begin
  Result := OK;
  with Patient do
    begin
      tmpPt := ReadPatientProperties(ADFN);

      if (tmpPt = BAD_DATA) or (tmpPt = '') then
        begin
          Result := tmpPt;
          Exit;
        end;

      DFN := ADFN;
      IsSelected := not (DFN = '');

  //1--GREEN,FROG^name
  //2--123456789^123-45-6789^ssn
  //3--2470420^APR 20,1947^dob
  //4--57^age
  //5--M^MALE^sex
  //6--3020820.1748^AUG 20,2002@1748^date of death
  //7--0^service connected

  //Name
      Name := Piece(tmpPt, U, 1);
  //SSN
      tmpPiece := Piece(tmpPt, RECORD_END, 2);
      SSN := Piece(tmpPiece, U, 1);
      FormattedSSN := Piece(tmpPiece, U, 2);
  //DOB
      tmpPiece := Piece(tmpPt, RECORD_END, 3);
      DOB := Piece(tmpPiece, U, 2);
  //Age
      tmpPiece := Piece(tmpPt, RECORD_END, 4);
      Age := StrToIntDef(Piece(tmpPiece, U, 1), 0);
  //Sex
      tmpPiece := Piece(tmpPt, RECORD_END, 5);
      if Length(Piece(tmpPiece, U, 1)) > 0 then
        Sex := Piece(tmpPiece, U, 1)
      else
        Sex := 'U';

  //DOD      Date of Death
      tmpPiece := Piece(tmpPt, RECORD_END, 6);
  //FIsDead := (StrToIntDef(Piece(tmpPiece, U, 1), 0) > 0); Don't use
      IsDead := Length(Piece(tmpPiece, U, 1)) > 1;
      if IsDead then
        DOD := FMDateStrToDateStr(Piece(tmpPiece, U, 1));

  //Service Connected
      tmpPiece := Piece(tmpPt, RECORD_END, 7);
      IsServiceConnected := (Piece(tmpPiece, U, 1) = '1');
      if IsServiceConnected then
        PctSC := StrToIntDef(Piece(tmpPiece, U, 2), 0);

//  FFirstNameLastName := Trim(Piece(Self.Name, ',', 2)) + ' ' +
//    Trim(Piece(Self.Name, ',', 1));
      SetCaptionInfo;
    end;
end;


procedure PatientClear;
begin
  with Patient do
    begin
      DFN := '';
      IsSelected := False;
      Sex := 'U';
      SSN := '';
      FormattedSSN := '';
      Name := '';
      DOB := DateToStr(Date);
      Age := 0;
      PctSC := 0;
      CaptionInfo := '';
      DOD := '';
      IsDead := False;
      IsServiceConnected := False;
    end;
end;


procedure PatientSelectUsingCPRS;
var
  ptSelHandle                 : hWnd;
begin
  if gvCPRS_Instance_Handle <> 0 then
    begin
      PostMessage(gvCPRS_Instance_Handle, WM_COMMAND, 2, 0);
      //2= Patient select command

      Sleep(2000);

      ptSelHandle := FindWindow('TfrmPtSel', nil); //Patient-selection window

      BringWindowToTop(gvCPRS_Instance_Handle);
      BringWindowToTop(ptSelHandle);
      SetForegroundWindow(ptSelHandle);
    end;
end;*)

end.

