unit uMHA_Result_OPS;

interface


uses
  Windows,
  Messages,
  Contnrs,
  Classes,
  SysUtils,
  Trpcb,
  dialogs;

type
  TResult_OPS = class
  private
    FListOfResults: TObjectList;
    FListOfScaleGroups: TObjectList;
    FListOfScales: TObjectList;
  protected
  public
    constructor Create;
    destructor Destroy; override;

    function LoadCompleteResults(aDFN: string): string;
    function LoadScaleGroupsAndScales(WhichInstrument: string): string;
    function LoadComments(aAdminID: string): string;
    function LoadScores(aAnswersAreInLegacyFile: Boolean;
      aAdministrationIENS, aName, aPatientDFN, aDateSaved: string): string;

    property ListOfResults: TObjectList read FListOfResults write FListOfResults;
    property ListOfScaleGroups: TObjectList read FListOfScaleGroups write FListOfScaleGroups;
    property ListOfScales: TObjectList read FListOfScales write FListOfScales;

  published
  end; // TResults_OPS

var
  Result_OPS                  : TResult_OPS;

implementation

uses
  uMHA_Report_IO,
  uMHA_InstrumentResults_IO,
  uMHA_DM;


constructor TResult_OPS.Create;
begin
  inherited Create;

  FListOfResults := TObjectList.Create;
  FListOfScaleGroups := TObjectList.Create;
  FListOfScales := TObjectList.Create;
end;

destructor TResult_OPS.Destroy;
begin
  if ListOfResults <> nil then
    ListOfResults.Free;
  if ListOfScaleGroups <> nil then
    ListOfScaleGroups.Free;
  if ListOfScales <> nil then
    ListOfScales.Free;
  inherited Destroy;
end;

function TResult_OPS.LoadCompleteResults(aDFN: string): string;
begin
  // uMHA_InstrumentResults_IO
  Result := ReadCompleteResults(aDFN, DataModule1.RPCBroker1);
end;

function TResult_OPS.LoadScaleGroupsAndScales(WhichInstrument: string): string;
begin
  // uMHA_InstrumentResults_IO
  Result := ReadScaleGroupsAndScales(WhichInstrument, DataModule1.RPCBroker1);
end;


function TResult_OPS.LoadComments(aAdminID: string): string;
begin
  // uMHA_Report_IO
  Result := ReadComments(aAdminID, DataModule1.RPCBroker1);
end;

function TResult_OPS.LoadScores(aAnswersAreInLegacyFile: Boolean;
  aAdministrationIENS, aName, aPatientDFN, aDateSaved: string): string;

begin
  Result := '';

  // uMHA_InstrumentResults_IO
  // Output Format is: ScaleName1=ScaleScore1~ScaleName2=ScaleScore2~
  // If there are no scores (i.e., no scales), ReadScores returns a blank.
  Result := ReadScores(aAnswersAreInLegacyFile, aAdministrationIENS, aName,
    aPatientDFN, aDateSaved, DataModule1.RPCBroker1);
end;

initialization
  Result_OPS := TResult_OPS.Create;

finalization
  Result_OPS.Free;

end.

