unit uMHA_AUX_PHQ2;

interface

uses
  SysUtils,
  fIA_dialogs,
  uMHA_AUX_Const,
  uMHA_AUX_Utils;

function ProgressNote_PHQ2(
  ScoreString: string): string;

function ScoreAnswers_PHQ2(
  AnswerString: string): string;

implementation


function ScoreAnswers_PHQ2(
  AnswerString: string): string;

var
  Score,
    Count, i                  : Integer;

  TempResult,
    TempAnswer                : string;

begin
  // AnswerString Format:
  //      83=1^1330^234~
  //      84=0^214~...

  // '83' is QuestionID,
  // '1' is ItemIndex for radio group, but can be text from edit field
  // '1330' is ChoiceID (not used here)
  // '234' is AnswerID (not used here)

  // AUDC scoring is straight forward for items 1 & 3. For question 2,
  // both the 1st and 2nd question are scored zero.

  // This is used by InstrumentResults to do a quick check on the
  // instrument as to its use of the dll

  if AnswerString = 'PHQ2' then
    begin
      Result := 'YES';
      exit;
    end;

  Result := '';
  Count := NumberOfPieces(AnswerString, RECORD_END);

  if Count < 1 then
    Exit;

  Score := 0;

  for i := 1 to Count - 1 do
    begin
      TempResult := Piece(AnswerString, RECORD_END, i);
      TempAnswer := Piece(Piece(TempResult, U, 1), EQ, 2);

      // ignore (Blank) answers
      if (TempAnswer = '') or (TempAnswer = ' ') or
        (TempAnswer = '-1') or
        (TempAnswer = '0') or
        (TempAnswer = CHOICE_ID_OF_SKIPPED_MULTIPLE_CHOICE_QUESTION) or
        (TempAnswer = CHOICE_ID_OF_SKIPPED_BY_RULE_MC_QUESTION) or
        (TempAnswer = CHOICE_ID_OF_SKIPPED_REQUIRED_ANSWER) then
        begin
          //
        end // Skipped questions
      else
        Score := Score + StrToIntDef(TempAnswer, 0);
    end; // for i

  Result := 'Score^^' + IntToStr(Score) + RECORD_END;
end;


function ProgressNote_PHQ2(
  ScoreString: string): string;
// The header, footer and questions and answers are handled else where; avoiding
// broker calls here. <.DLL_String.> provides location for this string in the
// report.

const
  Indent                      : string = '   ';
var
  PHQ2_Score                  : string;
begin
  Result := '';

  if (ScoreString = '') then Exit;

  PHQ2_Score := Piece(ScoreString, U, 3);
  Delete(PHQ2_Score, Length(PHQ2_Score), 1);

  if (StrToIntDef(PHQ2_Score, 0) <= 2) then
    Result := Result + Indent + 'A score of ' + PHQ2_Score + ' or less indicates a negative screen. ' + #13
  else
    Result := Result + Indent + 'A score of ' + PHQ2_Score + ' or more indicates a positive screen. ' + #13;

end;

end.

