unit uMHA_AUX_TBI;
interface

uses
  SysUtils,
  dialogs,
  uMHA_AUX_Const,
  uMHA_AUX_Utils;

function Verify_TBIV2(
  InstrumentName,
  PatientName,
  PatientDOB,
  PatientSex,
  AnswerString: string): string;

function Verify_TBIFU(InstrumentName,
  PatientName,
  PatientDOB,
  PatientSex,
  AnswerString: string): string;


implementation

function Verify_TBIV2(
  InstrumentName,
  PatientName,
  PatientDOB,
  PatientSex,
  AnswerString: string): string;

var
  Yr, Mo, Dy                  : word;

  YesCount,
    TempYr, TempMo,
    Count, i                  : Integer;

  Temp4AM, Temp4AY,
    Temp4BM, Temp4BY,
    Temp4CM, Temp4CY,
    TempQID,
    TempStr,
    TempStr1                  : string;


begin
  // AnswerString Format:
  //      83=1^1330~
  //      84=0^214~...
  //
  // '83' is QuestionID,
  // '1' is ItemIndex for radio group, but can be text from edit field
  // '1130' is ChoiceID

  Result := ''; // Default: means no problems
  // Remeber to add a "V" to result if there is a message for user. This
  // separates multiple messages.

  Count := NumberOfPieces(AnswerString, V);
  YesCount := 0;

  if Count < 1 then
    Exit;

  for i := 1 to Count - 1 do
    begin
      TempStr := Piece(AnswerString, V, i);
      TempQID := Piece(TempStr, EQ, 1);

      // Gather the months and years for Question 4
      if TempQID = '3918' then
        Temp4AM := Piece(Piece(TempStr, EQ, 2), U, 1);
      if TempQID = '3919' then
        Temp4AY := Piece(Piece(TempStr, EQ, 2), U, 1);
      if TempQID = '3920' then
        Temp4BM := Piece(Piece(TempStr, EQ, 2), U, 1);
      if TempQID = '3921' then
        Temp4BY := Piece(Piece(TempStr, EQ, 2), U, 1);
      if TempQID = '3922' then
        Temp4CM := Piece(Piece(TempStr, EQ, 2), U, 1);
      if TempQID = '3923' then
        Temp4CY := Piece(Piece(TempStr, EQ, 2), U, 1);

      // Question #6, #7 and #8
      if (i = 23) or (i = 25) or (i = 27) then
        begin
          TempStr := Piece(AnswerString, V, i);
          TempStr1 := Piece(TempStr, EQ, 2);
          TempStr1 := Piece(TempStr1, U, 1);
          if (TempStr1 = '0') or (TempStr1 = '-1') or
            (TempStr1 = '1156') then // do nothing
          else
            Inc(YesCount);
        end;
      if (i = 74) and (YesCount > 0) then
        begin
          TempStr := Piece(AnswerString, V, i);
          TempStr1 := Piece(TempStr, EQ, 2);
          TempStr1 := Piece(TempStr1, U, 1);
          if (TempStr1 = '0') or (TempStr1 = '-1') then
            Result := 'This patient has positive indications for TBI based ' +
              'on the answers for questions 6, 7 or 8.' + #13 + #13 +
              'Please reconsider your answer for question 27.' + V;
        end;
    end; // for i

  DecodeDate(Date, Yr, Mo, Dy);

  if (Temp4AY <> '1156') and (TryStrToInt(Temp4AY, TempYr)) then
    begin
      if TempYr > Yr then
        begin
          Result := 'Please check the year entered on Question 4-A-2. ' +
            ' Dates in the future are not permitted.' + V;
          exit;
        end
      else
        begin
          if TryStrToInt(Temp4AM, TempMo) then
            if TempMo > Mo then
              begin
                Result := 'Please check the month entered on Question 4-A-1. ' +
                  ' Dates in the future are not permitted.' + V;
                exit;
              end;
        end;
    end;

  if (Temp4BY <> '1156') and (TryStrToInt(Temp4BY, TempYr)) then
    begin
      if TempYr > Yr then
        begin
          Result := 'Please check the year entered on Question 4-B-2. ' +
            ' Dates in the future are not permitted.' + V;
          exit;
        end
      else
        begin
          if TryStrToInt(Temp4BM, TempMo) then
            if TempMo > Mo then
              begin
                Result := 'Please check the month entered on Question 4-B-1. ' +
                  ' Dates in the future are not permitted.' + V;
                exit;
              end;
        end;
    end;

  if (Temp4CY <> '1156') and (TryStrToInt(Temp4CY, TempYr)) then
    begin
      if TempYr > Yr then
        begin
          Result := 'Please check the year entered on Question 4-C-2. ' +
            ' Dates in the future are not permitted.' + V;
          exit;
        end
      else
        begin
          if TryStrToInt(Temp4CM, TempMo) then
            if TempMo > Mo then
              begin
                Result := 'Please check the month entered on Question 4-C-1. ' +
                  ' Dates in the future are not permitted.' + V;
                exit;
              end;
        end;
    end;
end;

function Verify_TBIFU(InstrumentName,
  PatientName,
  PatientDOB,
  PatientSex,
  AnswerString: string): string;
var
  Yr, Mo, Dy                  : word;

  TempYr, TempMo,
    Count, i                  : Integer;

  Temp4M, Temp4Y,
    TempQID,
    TempStr                   : string;


begin
  // AnswerString Format:
  //      83=1^1330~
  //      84=0^214~...
  //
  // '83' is QuestionID,
  // '1' is ItemIndex for radio group, but can be text from edit field
  // '1130' is ChoiceID

  Result := ''; // Default: means no problems
  // Remeber to add a "V" to result if there is a message for user. This
  // separates multiple messages.

  Count := NumberOfPieces(AnswerString, V);

  if Count < 1 then
    Exit;

  for i := 1 to Count - 1 do
    begin
      TempStr := Piece(AnswerString, V, i);
      TempQID := Piece(TempStr, EQ, 1);

      // Gather the months and years for Question 4
      if TempQID = '4259' then
        Temp4M := Piece(Piece(TempStr, EQ, 2), U, 1);
      if TempQID = '4279' then
        Temp4Y := Piece(Piece(TempStr, EQ, 2), U, 1);
    end; // for i

  DecodeDate(Date, Yr, Mo, Dy);

  if (Temp4Y <> '1156') and (TryStrToInt(Temp4Y, TempYr)) then
    begin
      if TempYr > Yr then
        begin
          Result := 'Please check the year entered on Question 4-B. ' +
            ' Dates in the future are not permitted.' + V;
          exit;
        end
      else
        begin
          if TryStrToInt(Temp4M, TempMo) then
            if TempMo > Mo then
              begin
                Result := 'Please check the month entered on Question 4-A. ' +
                  ' Dates in the future are not permitted.' + V;
                exit;
              end;
        end;
    end;

end;

end.

