unit uIA_Consult_IO;
// Read available consults

interface

uses
  Classes,
  SysUtils,
  dialogs,
  Trpcb;


function ReadConsultSubSet(const PtDFN: string;
  Broker: TRPCBroker): TStrings;

implementation

uses
  uIA_Const,
  uIA_Utils;


function ReadConsultSubSet(const PtDFN: string;
  Broker: TRPCBroker): TStrings;
// returns a pointer to a list of consults (for use in a long list box) -  The return value is
// a pointer to RPCBroker1.Results, so the data must be used BEFORE the next broker call!
var
  i                           : Integer;

  TempStr,
    TempStr1,
    TempDate                  : string;

begin
  with Broker do
    begin
//      LocalFiles.UpdateAPILog('Call to ORQQCN LIST: PtDFN= ' + PtDFN);
      ClearResults := True;

      //To prevent an undefined result
      Result := Results;

      ClearParameters := True;
      CreateContext('OR CPRS GUI CHART');
      RemoteProcedure := 'ORQQCN LIST';

      Param[0].Value := PtDFN;
      Param[0].PType := literal;

//      try
      Call;

//      except
//        on E: EBrokerError do
//          begin
//            LocalFiles.UpdateAPILog('Call to ORQQCN LIST: Error ');
//            LocalFiles.UpdateAPILog('   ' + 'Broker Error: ' + E.message);
//            exit;
//          end;
//        on E: EAccessViolation do
//          begin
//            LocalFiles.UpdateAPILog('Call to ORQQCN LIST: Error ');
//            LocalFiles.UpdateAPILog('   ' + 'Access Violation: ' + E.message);
//            exit;
//          end;
//      end; // try

      if Pos('<', Result[0]) > 0 then
        begin
          CreateContext('YS BROKER1');
//              LocalFiles.UpdateAPILog('Call to ORQQCN LIST Failed: ' + Result[i]);
          Exit;
        end;

      for i := Result.Count - 1 downto 0 do
        begin
          TempStr := Result[i];
          TempStr1 := Piece(TempStr, U, 3);

          if (TempStr1 = 'c') or
            (TempStr1 = 'dc') or
            (TempStr1 = 'e') or
            (TempStr1 = 'u') or
            (TempStr1 = 'dce') or
            (TempStr1 = 'x') or
            (TempStr1 = 'l') then
            Result.Delete(i)
          else
            begin
              SetPiece(TempStr, U, 3, ' (' + TempStr1 + ') ');

              TempDate := FMDateStrToDateStr(Piece(TempStr, U, 2));
              TempDate := FormatDateStrToMMMDDYYYY(TempDate);
              SetPiece(TempStr, U, 2, TempDate);

              result[i] := TempStr;
            end;
        end;

//      LocalFiles.UpdateAPILog('Call to ORQQCN LIST: Successful');
      CreateContext('YS BROKER1');
    end;
end;

(*
Here the RPC description an example of the output is below.
And here the RPC ORQQCN DETAIL to display the details of the Consult
 
Select REMOTE PROCEDURE NAME: ORQQCN LIST
ANOTHER ONE:
STANDARD CAPTIONED OUTPUT? Yes//   (Yes)
Include COMPUTED fields:  (N/Y/R/B): NO// BOTH Computed Fields and Record Number
 (IEN)
 
NUMBER: 340                             NAME: ORQQCN LIST
  TAG: LIST                             ROUTINE: ORQQCN
  RETURN VALUE TYPE: GLOBAL ARRAY       AVAILABILITY: SUBSCRIPTION
  WORD WRAP ON: TRUE
 DESCRIPTION:
 Returns a list of consult requests for a patient within optional date range
 and optional service.
INPUT PARAMETER: PATIENT                PARAMETER TYPE: LITERAL
  MAXIMUM DATA LENGTH: 16               REQUIRED: YES
 DESCRIPTION:
 Patient DFN from File #2 (Patient File.)
INPUT PARAMETER: START DATE             PARAMETER TYPE: LITERAL
  MAXIMUM DATA LENGTH: 16
 DESCRIPTION:
 Optional start date to begin the search.
INPUT PARAMETER: STOP DATE              PARAMETER TYPE: LITERAL
  MAXIMUM DATA LENGTH: 16
 DESCRIPTION:
 Optional stop date to end the search.
INPUT PARAMETER: SERVICE                PARAMETER TYPE: LITERAL
  MAXIMUM DATA LENGTH: 16
 
Enter RETURN to continue or '^' to exit:
 DESCRIPTION:
 Optional consulting service from the Request Service file (#123.5).
 RETURN PARAMETER DESCRIPTION:
 Array of consult requests in the form:

 Consult id^date/time of request^status^consulting service^procedure
 
 
ORQQCN LIST


Params ------------------------------------------------------------------

literal 47
literal
literal
literal
literal


Results -----------------------------------------------------------------

946^3060925.12355^p^PULMONARY^Consult^^PULMONARY Cons^22331^C
862^3051004.134042^p^ANESTHESIA^Consult^^ANESTHESIA Cons^21233^C
713^3040426.144431^p^PROSTHETICS SERVICE^Consult^^PROSTHETICS SERVICE Cons^18231^C
703^3040405.150502^p^AMPUTEE/PROSTHETICS CLINIC^Consult^^AMPUTEE/PROSTHETICS CLINIC Cons^18004^C
702^3040405.141242^p^DIETETICS SERVICE^Consult^^DIETETICS SERVICE Cons^17471^C
537^2990601.091635^p^REHAB MEDICINE^Consult^^REHAB MEDICINE Cons^15288^C
534^2990519.124437^p^DIETETICS SERVICE^Consult^^DIETETICS SERVICE Cons^15247^C
311^2980403.142701^c^DENTAL, TEST^Consult^^DENTAL, TEST Cons^11644^C
208^2960423.1119^c^PULMONARY^SHERI'S BRONCHOSCOPY^^SHERI'S BRONCHOSCOPY PULMONARY Proc^^P


*)

end.

 